viewerApp.controller("reportController",function($scope,$http){
$scope.caseBase={};
$scope.report={};
$scope.Case={};
$scope.cancelAudit={};
$scope.reportUser={};
//自动扩大输入框高度
$scope.autoTextarea = function (elem, extra, maxHeight) {
        extra = extra || 0;
        var isFirefox = !!document.getBoxObjectFor || 'mozInnerScreenX' in window,
        isOpera = !!window.opera && !!window.opera.toString().indexOf('Opera'),
                addEvent = function (type, callback) {
                        elem.addEventListener ?
                                elem.addEventListener(type, callback, false) :
                                elem.attachEvent('on' + type, callback);
                },
                getStyle = elem.currentStyle ? function (name) {
                        var val = elem.currentStyle[name];

                        if (name === 'height' && val.search(/px/i) !== 1) {
                                var rect = elem.getBoundingClientRect();
                                return rect.bottom - rect.top -
                                        parseFloat(getStyle('paddingTop')) -
                                        parseFloat(getStyle('paddingBottom')) + 'px';
                        };

                        return val;
                } : function (name) {
                                return getComputedStyle(elem, null)[name];
                },
                minHeight = parseFloat(getStyle('height'))*3;


        elem.style.resize = 'none';

        var change = function () {
                var scrollTop, height,
                        padding = 0,
                        style = elem.style;

                if (elem._length === elem.value.length) return;
                elem._length = elem.value.length;

                if (!isFirefox && !isOpera) {
                        padding = parseInt(getStyle('paddingTop')) + parseInt(getStyle('paddingBottom'));
                };
                scrollTop = document.body.scrollTop || document.documentElement.scrollTop;

                elem.style.height = minHeight + 'px';
                if (elem.scrollHeight > minHeight) {
                        if (maxHeight && elem.scrollHeight > maxHeight) {
                                height = maxHeight - padding;
                                style.overflowY = 'auto';
                        } else {
                                height = elem.scrollHeight - padding;
                                style.overflowY = 'hidden';
                        };
                        style.height = height + extra + 'px';
                        scrollTop += parseInt(style.height) - elem.currHeight;
                        document.body.scrollTop = scrollTop;
                        document.documentElement.scrollTop = scrollTop;
                        elem.currHeight = parseInt(style.height);
                };
        };

        addEvent('propertychange', change);
        addEvent('input', change);
        addEvent('focus', change);
        change();
};
$scope.authonFilter = function(){
  var userIdentity = localStorage.getItem("userIdentity") ;
  if(userIdentity == "7"){
    layer.open({
      title: '提示',
      content: '您的账户还未开通此权限，请联系管理员！',
      btn: ['确定'],
      yes: function(index){
        layer.close(index);
      }
    });
    return true;
  }else{
    return false ;
  }
}
//根据报告状态及用户URL判断提交类型/PUT/POST
$scope.operationReport=function(type){
      if($scope.authonFilter()){
          return ;
        };

        if($scope.report.finding==''&&$scope.report.conclusion==''){
            layer.open({
                content: '您没有填写任何内容！',
                time: 2
            });
            return false;
        }
        if(type==1){
            if($scope.report.finding==''&&$scope.report.conclusion==''){
                layer.open({
                    content: '您没有填写任何内容！',
                    time: 2
                });
            }else{
                if($scope.newReport){
                    $scope.postReport(type);
                    $scope.saved=true;
                }else{
                    $scope.putReport(type);
                    $scope.saved=true;
                }
                // if($scope.report.finding!=$scope.caseBase.reportModel.finding||$scope.report.conclusion!=$scope.caseBase.reportModel.conclusion){
                //     $scope.putReport(type);
                //     $scope.saved=true;
                // };
            }
        };
        if(type==2){
            //判断角色  1为报告医生
          if(Math.min.apply(null,$scope.user.roles) == 1){
                layer.open({
                    title: '提示',
                    content: '是否提交该报告？',
                    btn: ['确定', '取消'],
                    yes: function(index){
                        $scope.postReport(type);
                    }
                });
            }
           //判断角色  2为审核
            if(Math.min.apply(null,$scope.user.roles) == 2){
                var txt = '';
                if($scope.Case.status == 0 || $scope.Case.status == 2){
                    txt = '提交';
                }
                if($scope.Case.status == 1){
                    txt = '审核';
                }
                layer.open({
                    title: '提示',
                    content: '是否'+txt+'该报告？',
                    btn: ['确定', '取消'],
                    yes: function(index){
                        if($scope.Case.status==0){
                            $scope.postReport(type);
                        }
                        if($scope.Case.status!=0){
                            $scope.putReport(type);
                        }
                    }
                });
            }
        }
        if(type==3){
            if($scope.Case.status==0){
                layer.open({content: '报告还未提交！',time: 2});
            };
            if($scope.Case.status==1){
                layer.open({
                    title: '提示',
                    content: '是否拒绝该报告？',
                    btn: ['确定', '取消'],
                    yes: function(index){
                        $scope.putReport(type);
                    }
                });
            }
        };
        if(type==4){
            layer.open({
                title: '提示',
                content: '是否提交该报告？',
                btn: ['确定', '取消'],
                yes: function(index){
                    if($scope.Case.status==0){
                        $scope.postReport(type);
                    }else if($scope.Case.status==2){
                        $scope.putReport(type);
                    }
                }
            });
        }
};
//打开报告
$scope.caseInfo=function(){
    $http.get($scope.api.portalapi+'/report/case/'+$scope.GetRequest().id+"?hospitalId="+$scope.user.hospitalId,{
            headers:{'SESSIONID':$scope.GetRequest().sessionId}
        }
    ).success(function(data){
        if(data.code == 200){
            $scope.caseBase=data.data;
            if($scope.caseBase.reportModel.id==undefined){
                $scope.newReport=true;
            }else{
                $scope.newReport=false;
            }
            console.log($scope.caseBase);
            $scope.report=data.data.reportModel;
            $scope.Case=data.data.caseModel;
            $scope.cancelAudit=data.data.cancelAudit;
            $scope.reportUser=data.data.caseModel.reportUser;
            getFromHospitalConfig(data.data.caseModel.hospitalId);
        }else if(data.code == 4001){
            layer.open({content: '登录超时，请重新进入',time: 2});
        }
    });
};
//POST报告
$scope.postReport=function(type){
    var params={};
    params.type=type;
    params.caseId=$scope.Case.id;
    params.conclusion=$scope.report.conclusion;
    params.finding=$scope.report.finding;
    if(type === 2 && $scope.fromHospitalConfig.ca !== undefined && $scope.fromHospitalConfig.ca){
        checkCaPost(params);
    }else{
        postReportDo(params);
    }
};
//POST DO
function postReportDo(params) {
    var paramss=JSON.stringify(params);
    $http({
        url:$scope.api.portalapi+'/report/case/'+params.caseId,
        method:'POST',
        headers: {
            'SESSIONID': $scope.GetRequest().sessionId
        },
        data:paramss
    }).success(function(data){
        if(data.code==200){
            layer.open({content: '操作成功！',time: 2});
            $scope.reOpenReport();
        }
        if(data.code==3001){
            layer.open({content: '参数不全！',time: 2});
        }
        if(data.code==6000){
            layer.open({content: '报告医生没有提交，无法进行审核',time: 2});
        }
        if(data.code==4001){
            layer.open({content: '登录超时，请重新进入',time: 2});
        }
        console.log(data);
    });
}
//put报告
$scope.putReport=function(type){//type:1 保存 ，2：审核，3：驳回
    if($scope.Case.caseId!=null&&$scope.Case.caseId!=''){
        var params={};
        params.type=type;
        params.id=$scope.caseBase.reportModel.id;
        params.caseId=$scope.Case.id;
        params.conclusion=$scope.report.conclusion;
        params.finding=$scope.report.finding;
        if(type === 2 && $scope.fromHospitalConfig.ca !== undefined && $scope.fromHospitalConfig.ca){
            checkCaPut(params);
        }else{
            putReportDo(params);
        }
    }else{
        layer.open({content: '请先提交报告！',time: 2});
    }
};
function putReportDo(params) {
    var paramss=JSON.stringify(params);
    $http({
        url:$scope.api.portalapi+'/report/'+params.id+'/case/'+params.caseId,
        method:'PUT',
        headers: {
            'SESSIONID': $scope.GetRequest().sessionId
        },
        data:JSON.stringify(params)
    }).success(function(data){
        if(data.code==200){
            layer.open({content: '操作成功！',time: 2});
            $scope.reOpenReport();
        }
        if(data.code==3001){
            layer.open({content: '参数不全！',time: 2});
        }
        if(data.code==5008){
            layer.open({content: '该报告已下放！',time: 2});
        }
        if(data.code==6000){
            layer.open({content: '报告医生没有提交，无法进行审核！',time: 2});
        }
        if(data.code==4001){
            layer.open({content: '登录超时，请重新进入',time: 2});
        }
    });
};
//-------CA相关业务-------
//获取报告上传医院个性化配置
function getFromHospitalConfig(hospitalId) {
    var params = {
        hospitalId:hospitalId
    };
    $http.get($scope.api.portalapi + '/users/config', {
        headers: { 'SESSIONID': $scope.GetRequest().sessionId },
        params: {
            userId: $scope.GetRequest().userId,
            hospitalId: params.hospitalId
        }
    }).success(function(data) {
        if (data.code === '200') {
            if (data.data === undefined) {
                data.data = '{patientName:0,hospitalName:0,submitPhone:0,callback:1,listByTeam:1,ca:0}';
            }
            if (params.callback === 1) {
                $scope.fromHospitalConfig = eval('(' + data.data + ')');
            } else {
                var hospitalConfig = eval('(' + data.data + ')');
                $scope.fromHospitalConfig = eval('(' + data.data + ')');
            }
        } else {
            layer.open({content: errorCode(data),time: 2});
        }
    }).error(function() {
        layer.open({content: '请求失败，请检网络！',time: 2});
        layer.open({content: errorCode('4001'),time: 2});
    });
}
//check ca post
function checkCaPost(params) {
    $scope.caParams = params;
    $scope.caParams.httpType = 'post';
    var inParams = {
        id:$scope.GetRequest().userId,
        type:params.type,
        caseId:$scope.caseBase.caseModel.id,
        finding:params.finding,
        conclusion:params.conclusion
    }
    postCaSgin(inParams,function(data){
        if(data.data.message === 'success'){
            layer.open({shadeClose: false,content: '请打开“医网签”APP,查看待签报告完成签名操作！</br>签名完成后此窗口自动关闭。',time: 999999});
            checkIsSignEd(inParams,data);
        }else{
            layer.open({content: data.data.message,time: 2});
        }
    });
}
function checkCaPut(params) {
    $scope.caParams = params;
    $scope.caParams.httpType = 'put';
    var inParams = {
        id:$scope.GetRequest().userId,
        type:params.type,
        caseId:$scope.caseBase.caseModel.id,
        finding:params.finding,
        conclusion:params.conclusion
    }
    postCaSgin(inParams,function(data){
        if(data.data.message === 'success'){
            layer.open({shadeClose: false,content: '请打开“医网签”APP,查看待签报告完成签名操作！</br>签名完成后此窗口自动关闭。',time: 999999});
            checkIsSignEd(inParams,data);
        }else{
            layer.open({content: data.data.message,time: 2});
        }
    });
}
//postCaSgin
function postCaSgin(params,callback) {
    var jsondata = JSON.stringify(params);
    $http({
        url:$scope.api.portalapi+'/bjca/sign/CA',
        method:'POST',
        headers: {
            'SESSIONID': $scope.GetRequest().sessionId
        },
        data:jsondata
    }).success(function(data){
        if(data.code === '200'){
            layer.open({content: '请求签名成功！',time: 2});
            callback(data);
        }else{
            layer.open({content: errorCode(data),time: 2});
        }
    }).error(function(){
        layer.open({content: '请求失败，请检网络！',time: 2});
        layer.open({content: errorCode('4001'),time: 2});
    });
}
//checkIsSignEd
function checkIsSignEd(inParams,cadata) {
    $http.get($scope.api.portalapi+'/bjca/sign/tag',{
            headers:{'SESSIONID':$scope.GetRequest().sessionId},
            params:{
                uniqueId:cadata.data.data.uniqueId
            }
        }
    ).success(function(data){
        $rootScope.showSplash = false;
        if(data.code === '200'){
            if(inParams.type=='post'){
                postReportDo(inParams);
            }else if(inParams.type=='put'){
                putReportDo(inParams);
            }
            layer.closeAll();
        }else if(data.code === '404'){
            $timeout(function(){
                checkIsSignEd(inParams,cadata);
            },3000);
        }else{
            layer.open({content: errorCode(data),time: 2});
        }
    }).error(function(){
        layer.open({content: '请求失败，请检网络！',time: 2});
        layer.open({content: errorCode('4001'),time: 2});
    });
}
//取消审核
$scope.docancelAudit=function(){
    $http.get($scope.api.portalapi+'/case/'+$scope.Case.id+'/cancelAudit',{
        headers:{'SESSIONID':$scope.GetRequest().sessionId},
        params:{
            id:$scope.Case.id
        }
    }).success(function(data){
        if(data.code==200){
            layer.open({content: '已取消审核此报告！',time: 2});
            $scope.reOpenReport();
        }else{
            layer.open({content: '取消审核报告失败！',time: 2});
            $scope.reOpenReport();
        }
    });
};
//刷新报告
$scope.reOpenReport=function(){
    $scope.caseInfo();
};
//却config.json API
$scope.setApi=function(){
    $http({
    url:'js/config.json',
    method:'GET'
    }).success(function(data){
        sessionStorage.setItem('api',JSON.stringify(data));
        $scope.user = JSON.parse(sessionStorage.getItem('loginUser'));
        if($scope.user == null){
            layer.open({content: '请重新登录',time: 2});
            window.location.href='/#/login/'+$scope.GetRequest().studyUID+'/'+$scope.GetRequest().userId+'/'+$scope.GetRequest().caseId+'/'+$scope.GetRequest().id+'/';
        }else{
            $scope.userRole = Math.min.apply(null,$scope.user.roles);
            if($scope.user.roleGroups.length != 0){
                $scope.counterSign=$scope.user.roleGroups[0].counterSign;
                console.log($scope.counterSign);
            }
            $scope.userName = $scope.user.name;
            $scope.api = JSON.parse(sessionStorage.getItem('api'));
            $scope.caseInfo();
        }
    });
};
//获取URL参数
$scope.GetRequest=function() {
    var url = location.search; //获取url中"?"符后的字串
    var theRequest = {};
    if (url.indexOf('?') != -1) {
    var str = url.substr(1);
    var strs;
    strs = str.split('&');
    for(var i = 0; i < strs.length; i ++) {
    theRequest[strs[i].split('=')[0]]=unescape(strs[i].split('=')[1]);
    }
    }
    return theRequest;
};
//页面加载启动入口
$scope.load=function(){
    $scope.setApi();
    var finding = document.getElementById('finding');
    var conclusion = document.getElementById('conclusion');
    $scope.autoTextarea(finding,0,200);
    $scope.autoTextarea(conclusion);
};
$scope.load();
});
