// Ionic Starter App

angular.module('starter', ['ionic', 'starter.controllers', 'starter.services' , 'starter.routes', 'starter.filter' ,'starter.directives', 'monospaced.elastic', 'ngCordova','ionic-native-transitions'])

.run(['$ionicPlatform','UserService','groupService','$ionicModal','$ionicPopup','$ionicLoading','$location','$rootScope','$state','$timeout','$ionicHistory','$cordovaToast','$injector','showAlertService','$cordovaKeyboard','$ionicSideMenuDelegate','rongcloudService','$cordovaNetwork','HomeService','$cordovaAppVersion','appversionService','$ionicScrollDelegate',
    function($ionicPlatform,UserService,groupService,$ionicModal,$ionicPopup,$ionicLoading,$location,$rootScope, $state, $timeout, $ionicHistory,$cordovaToast,$injector,showAlertService,$cordovaKeyboard,$ionicSideMenuDelegate, rongcloudService,$cordovaNetwork,HomeService,$cordovaAppVersion,appversionService,$ionicScrollDelegate) {
      $ionicPlatform.ready(function() {
        //if(localStorage.getItem("YLappIndex") != null){
        //  $state.go('signin') ;
        //}else{
        //  localStorage.setItem("YLappIndex", "1");
        //}
        // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
        // for form inputs)
        //ionic.Platform.isFullScreen = true;
        navigator.splashscreen.hide();
        // 版本更新判断
        $cordovaAppVersion.getVersionNumber().then(function(version) {
          var currentVersion = version;
          appversionService.getLatestVersion()
            .then(function(result){
              if (!!result.result){
                for (var i in result.result){
                  if (result.result[i].confKey = 'app_latest_version'){
                    var latestVersion = result.result[i].confValue;

                    if (latestVersion > currentVersion){
                      showAlertService.PopConfirm("更新提醒","影领APP新版本已经发布，是否现在更新？","暂不更新","立即更新")
                        .then(function(res) {
                          if(res) {
                            if(ionic.Platform.isIOS()){
                              console.log('TODO')
                              // window.open("https://itunes.apple.com/cn/app/ying-ling/id1121533926?mt=8");
                              window.open("itms-apps://itunes.apple.com/cn/app/ying-ling/id1121533926?mt=8");
                            }else{
                              window.open("http://a.app.qq.com/o/simple.jsp?pkgname=com.yinglink.caseshare", "_system");
                            }
                          } else {
                          }
                        });
                    }
                    break;
                  }
                }
              }
            });
        });

        // hide splash immediately
        if(navigator && navigator.splashscreen) {
          navigator.splashscreen.hide();
        }

        if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
          cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
          cordova.plugins.Keyboard.disableScroll(true);

        }
        if (window.cordova && window.cordova.InAppBrowser) {
          window.open = window.cordova.InAppBrowser.open;
        }
        if (window.StatusBar) {
          // org.apache.cordova.statusbar required
          StatusBar.styleDefault();
        }

        //var type = $cordovaNetwork.getNetwork();
        //alert("type=="+type) ;
        //var isOnline = $cordovaNetwork.isOnline();
        //alert("isOnline=="+isOnline) ;
        //var isOffline = $cordovaNetwork.isOffline();
        //isOnConnec = isOnline ;
        //alert("ready+$isOnConnec ="+isOnConnec ) ;
        //
        //$rootScope.$on('$cordovaNetwork:online', function(event, networkState){
        //  //$rootScope.isOnConnection = true ;
        //  //$rootScope.networkState = networkState ;
        //  isOnConnec = true ;
        //  alert('连上啦'+networkState+"$rootScope.isOnLine="+isOnConnec);
        //})
        ////// listen for Offline event
        //$rootScope.$on('$cordovaNetwork:offline', function(event, networkState){
        //  //$rootScope.isOnConnection = false ;
        //  //$rootScope.networkState = networkState ;
        //  isOnConnec = false ;
        //  alert('掉线啦'+"$rootScope.isOnLine="+isOnConnec);
        //})

        document.addEventListener("deviceready", function () {

          var type = $cordovaNetwork.getNetwork();

          var isOnline = $cordovaNetwork.isOnline();

          var isOffline = $cordovaNetwork.isOffline();
          $rootScope.isOnLine = isOnline ;
          //alert("reaqdy $rootScope.isOnLine="+$rootScope.isOnLine) ;

          //alert(type,isOnline,isOffline);

          // listen for Online event
          $rootScope.$on('$cordovaNetwork:online', function (event, networkState) {
            var onlineState = networkState;
            $rootScope.isOnLine = true ;
            //alert("上线$rootScope.isOnLine===="+$rootScope.isOnLine) ;
            //$rootScope.$broadcast("error","网络连接成功,请继续使用！") ;
            //console.log("device online...");
            //$ionicLoading.hide() ;
          });

          // listen for Offline event
          $rootScope.$on('$cordovaNetwork:offline', function (event, networkState) {
            var offlineState = networkState;
            $rootScope.isOnLine = false ;
            $rootScope.$broadcast("message","网络连接失败,请稍后再试！",3000,"alert") ;
            //alert("掉线$rootScope.isOnLine===="+$rootScope.isOnLine) ;
            //$ionicLoading.show({
            //  template: '您当前没有网络连接'
            //});
            });
          }, false);

        $ionicModal.fromTemplateUrl('templates/diagnose/authority-warn.html', {
          scope: $rootScope,
          animation: 'slide-in-down'
        }).then(function(modal) {
          $rootScope.loginModal = modal;
        });

        $ionicModal.fromTemplateUrl('templates/diagnose/goLogin-warn.html', {
          scope: $rootScope,
          animation: 'slide-in-down'
        }).then(function(modal) {
          $rootScope.goLoginModal = modal;
        });

        $ionicModal.fromTemplateUrl('templates/diagnose/authority-warn.html', {
          scope: $rootScope,
          animation: 'slide-in-up'
        }).then(function(modal) {
          $rootScope.shareModal = modal;
        });

        $rootScope.msg = "" ;
        $ionicModal.fromTemplateUrl('templates/diagnose/error.html', {
          scope: $rootScope,
          animation: 'slide-in-down'
        }).then(function(modal) {
          $rootScope.messageModal = modal;
        });
      });
      //获取积分规则
      UserService.getScoreRule()
        .then(function(result){
          $rootScope.scoreRule = result.result ;
          for(var i in $rootScope.scoreRule){
            if($rootScope.scoreRule[i].ruleDetailCode == "signin"){
              $rootScope.signScore = $rootScope.scoreRule[i].ruleDetailScore ;
            }
            if($rootScope.scoreRule[i].ruleDetailCode == "use_viewer"){
              $rootScope.viewScore = $rootScope.scoreRule[i].ruleDetailScore ;
            }
            if($rootScope.scoreRule[i].ruleDetailCode == "upload_case"){
              $rootScope.uploadScore = $rootScope.scoreRule[i].ruleDetailScore ;
            }
          }
        })

      //初始化对象
      $rootScope.user = {
        id:0 ,
        //userName:"",
        personalImage:img.personalImage,
        applyStatus:0
      }

      $rootScope.picUserlist = [];
      $rootScope.newmessage={
        flag:0,
        messageCount: 0,
        messageList: [],
        innerMailCount: 0,
        innerMailList: []
      };
      $rootScope.conversation={
        conversationList: []
      };
      $rootScope.currentConversation={
        targetId: 0,
        conversationType: '',
        conversationTitle: '',
        inputText: '',
        messageList: [],
        imageList: []
      };

      $rootScope.conversationFlag = false;
      $rootScope.currentConversationInit = function(){
        $rootScope.currentConversation.targetId = 0;
        $rootScope.currentConversation.conversationType = '';
        $rootScope.currentConversation.conversationTitle = '';
        $rootScope.currentConversation.inputText = '';
        $rootScope.currentConversation.messageList = [];
        $rootScope.currentConversation.imageList = [];
      };

      $rootScope.userConfigs = [];
      $rootScope.appShowFlag = true;
      $ionicPlatform.ready(function() {
        document.addEventListener("pause", function () {
          $rootScope.appShowFlag = false;
        }, false);
        document.addEventListener("resume", function () {
          $rootScope.appShowFlag = true;
        }, false);
      });

      $rootScope.classroomCurrentId = 0;
      $rootScope.classroomTabActive = [true,false,false] ;

      $rootScope.updateSocial = {
        operAgree:"agreeNum",
        operStore:"storeNum",
        operComment:"commentNum",
        operRead:"readNum",
        operationAdd:true ,
        operationReduce:false
      }
      //判断警示高度
      $rootScope.heightOfNav = 64;


      $rootScope.friendPage = {
        friendType:true
      };
      $rootScope.friendPage.goFriendPage = function(type) {
        if (!!type){
          if (type == 'friend'){
            $rootScope.friendPage.friendType = true;
          }else{
            $rootScope.friendPage.friendType = false;
          }
        }
        $state.go("menu.tab.friends") ;
      };

      $rootScope.sessionTime = new Date().getTime() ;
      if(ionic.Platform.isIOS()){
        $rootScope.isIOSStyle = true ;
        $rootScope.loginNavStyle = {height:'60px','min-height':'60px','background-color':'#fee1e1','border-radius':'0 0 8px 8px',opacity: .95};
      }else{
        $rootScope.loginNavStyle = {height:'40px','min-height':'40px','background-color':'#fee1e1','border-radius':'0 0 8px 8px',opacity: .95};
      }

      $rootScope.goComm = function(){
        if($rootScope.user.id == 0){
          $rootScope.$broadcast('goLogin:show');
        }else if($rootScope.user.id>0){
          $state.go("menu.tab.friends");
        }
      }

      $rootScope.goDiagnose = function(){
        if($rootScope.user.id == 0){
          $rootScope.$broadcast('goLogin:show');
        }else if($rootScope.user.id>0){
          if($rootScope.user.userIdentity == 3 || $rootScope.user.userIdentity == 5){
            //如果有权限
            $state.go("menu.tab.diagnose") ;
          }else if($rootScope.user.userIdentity == 7){
            //如果没有权限
            $state.go("menu.tab.diagnose") ;
          }else{
            $state.go("menu.diagnose-authority");
          }
        }
      }

      $rootScope.loadPage = function(item){
        if($rootScope.user.id <= 0){
          $rootScope.$broadcast('goLogin:show');
        }else{
          $state.go("menu.uploadone") ;
        }
      }

      $rootScope.goLoginPage = function(){
        $rootScope.goLoginModal.hide() ;
        $state.go("signin");
      }


      //权限
      $rootScope.guest_conf_urls= []
      $rootScope.$on('login:show', function() {
        $rootScope.loginModal.show() ;
      })
      $rootScope.$on('goLogin:show', function() {
        $rootScope.goLoginModal.show() ;
      })

      $rootScope.$on('message', function(d,data,timeout,type) {
        $rootScope.msg = data ;
        $rootScope.messageModal.show() ;
        if(type == "notice"){
          $rootScope.warnNavStyle = {'height':$rootScope.loginNavStyle.height,'min-height':$rootScope.loginNavStyle.height,'background-color':'#ededed','border-radius':'0 0 8px 8px',opacity: .95};
        }else if(type == "alert"){
          $rootScope.warnNavStyle = {'height':$rootScope.loginNavStyle.height,'min-height':$rootScope.loginNavStyle.height,'background-color':'#fee1e1','border-radius':'0 0 8px 8px',opacity: .95};
        }else if(type == "error"){
          $rootScope.warnNavStyle = {'height':$rootScope.loginNavStyle.height,'min-height':$rootScope.loginNavStyle.height,'background-color':'#fee1e1','border-radius':'0 0 8px 8px',opacity: .95};
        }
        if(timeout){
          $timeout(function(){
            $rootScope.messageModal.hide() ;
          },timeout)
        }

      })

      $rootScope.$on('social', function(e,id,module,operType,operation) {
        $rootScope.$broadcast('socialOper',id,module,operType,operation);
      });

      $rootScope.$on('switch', function(e,item,learnType) {
        $rootScope.$broadcast('switchType',item,learnType);
      });

      //$rootScope.$on('deleteCase', function(e,item) {
      //  $rootScope.$broadcast('updateCommunity',item);
      //});


      $rootScope.isSignIn = function(){
        $rootScope.loginModal.hide() ;
        $rootScope.isVisible = true ;
      }

      $rootScope.toggleLeftSideMenu = function() {
        if ($rootScope.user.id > 0){
          UserService.getUserCenterInfo($rootScope.user.id)
            .then(function(result){
              $rootScope.statistics = result.result ;
              $rootScope.user.userIdentity = result.result.userIdentity ;
              $rootScope.user.diagnoseUser = result.result.diagnoseUser ;
            })
        }

        $ionicSideMenuDelegate.toggleLeft();
      };

      //返回
      $rootScope.goToBack = function() {
        if ($rootScope.isVisible){
          $rootScope.isVisible = false;
          return;
        }

        if(angular.isUndefined($ionicHistory.viewHistory().backView) || $ionicHistory.viewHistory().currentView.stateId == $ionicHistory.viewHistory().backView.stateId){
          $state.go('menu.tab.homepage') ;
        }else{
          $ionicHistory.goBack(-1) ;
        }
      };

      //转换后台文本的样式
      $rootScope.flexToHtml = function(str){
        str = str.replace(/<\/?font[^>]*>/gi,"");
        return str;
      }

      $rootScope.utf16to8 = function(str) {
        var out, i, len, c;
        out = "";
        len = str.length;
        for (i = 0; i < len; i++) {
          c = str.charCodeAt(i);
          if ((c >= 0x0001) && (c <= 0x007F)) {
            out += str.charAt(i);
          } else if (c > 0x07FF) {
            out += String.fromCharCode(0xE0 | ((c >> 12) & 0x0F));
            out += String.fromCharCode(0x80 | ((c >> 6) & 0x3F));
            out += String.fromCharCode(0x80 | ((c >> 0) & 0x3F));
          } else {
            out += String.fromCharCode(0xC0 | ((c >> 6) & 0x1F));
            out += String.fromCharCode(0x80 | ((c >> 0) & 0x3F));
          }
        }
        return out;
      }

      //设置study栏目高度
      $rootScope.setImgBgHight = function(){
        var width = window.screen.width ;
        var num = 0.5625 ;
        $rootScope.homePageHeightStyle={height:width/2.5875+'px'} ;
        $rootScope.heightStyle = {height:width*num+'px'} ;
        $rootScope.topStyle = {top:width*num+40+'px'} ;
      }
      $rootScope.setImgBgHight() ;

      //处理时间     判断当前日期跟指定日期对比
      $rootScope.GetDateDiff = function(nowData){
        //系统时间
        var systemTime = moment();
        var now_date = moment(nowData,"YYYY-MM-DD");
        var dates = systemTime.diff(now_date, 'days');
        if(dates > 7){
          return true ;
        }else{
          return false ;
        }
        ////存放系统时间的数组
        //var atrrYear = new Array();
        //var atrrDay = new Array();
        //var atrrHour = new Array();
        //
        ////分割出系统时间的年、月、日、时、分、秒
        //atrrYear = systemTime.split("-")
        //atrrDay = atrrYear[2].split(" ");
        //atrrHour = atrrDay[1].split(":");
        //
        //
        ////存放留言时间的数组
        //var atrrOnYear = new Array();
        //var atrrOnDay = new Array();
        //var atrrOnHour = new Array();
        //
        ////分割出留言时间的年、月、日、时、分、秒
        //atrrOnYear = nowData.split("-")
        //atrrOnDay = atrrOnYear[2].split(" ");
        //atrrOnHour = atrrOnDay[1].split(":");
        //
        //var year = parseInt(atrrYear[0]);	//年
        //var month =parseInt(atrrYear[1]);	//月
        //var day = parseInt(atrrDay[0]);		//日
        //var hour = parseInt(atrrHour[0]);		//时
        //var minute = parseInt(atrrHour[1]); //分
        ////console.log(year+"/"+month+"/"+day+"/"+hour+"/"+minute)
        //
        ////留言时间
        //var nowYear = parseInt(atrrOnYear[0]);
        //var nowMonth = parseInt(atrrOnYear[1]);
        //var nowDay = parseInt(atrrOnDay[0]);
        //var nowHour = parseInt(atrrOnHour[0]);
        //var nowMinute = parseInt(atrrOnHour[1]);
        ////console.log(nowYear+"/"+nowMonth+"/"+nowDay+"/"+nowHour+"/"+nowMinute)
        //
        //if(year != nowYear){
        //  return 8;
        //}else if(month != nowMonth){
        //  return 8;
        //}else if(day-nowDay>7){
        //  return 8;
        //}else {
        //  return 1;
        //}
      }

      $rootScope.encode64 = function(input) {
        var keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
        var output = "";
        var chr1, chr2, chr3 = "";
        var enc1, enc2, enc3, enc4 = "";
        var i = 0;
        do {
          chr1 = input.charCodeAt(i++);
          chr2 = input.charCodeAt(i++);
          chr3 = input.charCodeAt(i++);
          enc1 = chr1 >> 2;
          enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
          enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
          enc4 = chr3 & 63;
          if (isNaN(chr2)) {
            enc3 = enc4 = 64;
          } else if (isNaN(chr3)) {
            enc4 = 64;
          }
          output = output + keyStr.charAt(enc1) + keyStr.charAt(enc2)
            + keyStr.charAt(enc3) + keyStr.charAt(enc4);
          chr1 = chr2 = chr3 = "";
          enc1 = enc2 = enc3 = enc4 = "";
        } while (i < input.length);
        return output;
      }

      //监控UserId变化，读取个人信息
      $rootScope.$watch('user.id',function(newValue,oldValue){
        if(newValue > 0){
          UserService.getUserCenterInfo($rootScope.user.id)
            .then(function(result){
              $rootScope.statistics = result.result ;
            })
          var flag = false ;
          if(localStorage.getItem("signInTime") == null || localStorage.getItem("signInTime") == "" || localStorage.getItem("signInTime") == undefined){
            flag = true ;
          }else{
            var lastSignTimeStr = localStorage.getItem("signInTime") ;
            var lastSignTime = moment(lastSignTimeStr);
            //如果当前时间在上一次签到时间之后的一天时，调用签到API
            if(moment().isAfter(lastSignTime,'days')){
              flag = true ;
            }
          }
          if(flag){
            UserService.isSigined($rootScope.user.id)
              .then(function(result){
                if(result.code == 0){
                  localStorage.setItem("signInTime",moment().format('YYYY-MM-DD h:mm:ss')) ;
                  $timeout(function(){
                    var score = !!$rootScope.signScore ? $rootScope.signScore : 1;
                    $rootScope.$broadcast('message',"APP签到成功,积分+"+score,3000,"notice");
                  },2000);
                }
                if(result.code == 40020){
                }
                $rootScope.isSign = true ;
              },function(reason){
              })
          }
          UserService.getSwfArea();
        }
      })

      $rootScope.$on("$stateChangeStart", function (evt, toState, toParams, fromState, fromParams) {
        var isPrivate = angular.isObject(toState.data) && toState.data.isPrivate;
        var type = toParams.type ;
        var userIdentity = $rootScope.user.userIdentity ;
        if(isPrivate && (type == "email" || type == "name" || type == "location" || type == "hospital" || type == "department")){
          //路由为私有路由，并且修改类型为当前几种类型时，查看用户角色
          if(userIdentity != undefined && userIdentity != null && userIdentity > 2){
            showAlertService.PopConfirm("医生提醒","您确定要成为会员医生修改该信息吗？","取消","确定")
              .then(function(res) {
                if(res) {
                  UserService.updateUserIdentityToMember($rootScope.user.id)
                    .then(function(result){
                      if(result.code == 0){
                        $rootScope.user.userIdentity = 2 ;
                        $rootScope.$broadcast('message',"您已成为会员医生",3000,"notice");
                        $state.go(toState.name,toParams);
                      }else{
                        $rootScope.$broadcast('message',"服务器忙，请稍后再试",3000,"notice");
                      }
                    },function(reason){
                      $rootScope.$broadcast('message',"服务器忙，请稍后再试",3000,"notice");
                  })
                }
              });
             evt.preventDefault();
          }else if($rootScope.user.applyStatus == 2){
              $rootScope.$broadcast('message',"申请单正在申请中不能修改",3000,"notice");
              //console.log("申请单正在申请中不能修改") ;
              evt.preventDefault();
          }
        }
      });
      var pageIsBegin = false ;
      $rootScope.$on('$stateChangeSuccess',function (event, toState, toParams, fromState, fromParams) {
        var enterNameAry = toState.name.split(".") ;
        var enterName = enterNameAry[enterNameAry.length-1] ;
        var leaveNameAry = fromState.name.split(".") ;
        var leaveName = leaveNameAry[leaveNameAry.length-1] ;
        if(window.MobclickAgent !== undefined){
          MobclickAgent.onPageBegin(enterName) ;
          if(pageIsBegin){
            MobclickAgent.onPageEnd(leaveName) ;
          }
          pageIsBegin = true ;
        }
        $timeout(function(){
          if(toState.name == "menu.tab.personal"){
            angular.element('.nav-bar-container').hide();
          }else{
            angular.element('.nav-bar-container').show();
          }
        },1) ;
        if(fromState.name == "menu.tab.personal"){
          angular.element('.nav-bar-container').show();
        }
      });

      $rootScope.getUserPic = function(userId) {
        var userPic = img.personalImage;
        for(var i in $rootScope.picUserlist){
          if ($rootScope.picUserlist[i].id == userId){
            userPic = $rootScope.picUserlist[i].personalImage;
          }
        }
        return userPic;
      }

      $rootScope.appendNewMsg = function(msg, noBottomFlag) {
        var curMsg = rongCloudUtil.resolveMsg(msg);
        var userPic = $rootScope.getUserPic(curMsg.senderUserId);
        curMsg.userPic = userPic;
        $rootScope.currentConversation.messageList.push(curMsg);
        if (curMsg.objectName == 'RC:ImgMsg'){
          $rootScope.currentConversation.imageList.push(curMsg.content.imageUrl);
        }

        // 判断会话列表是否存在该会话
        var conversation = null;
        for (var i in $rootScope.conversation.conversationList){
          var conversationTemp = $rootScope.conversation.conversationList[i];
          if (conversationTemp.targetId == curMsg.targetId && conversationTemp.conversationType == curMsg.conversationType){
            conversation = conversationTemp;
            break;
          }
        }

        if (!!conversation){
          conversation.latestMessage = curMsg.content.text;
          conversation.sentTime = curMsg.sentTime;
        }else{
          curMsg.sentTime = new Date().getTime();
          var target;
          if(curMsg.conversationType == "PRIVATE"){
            UserService.getUserById(curMsg.targetId)
              .then(function(result){
                var name = result.result.nickName;
                var picture = !!result.result.personalImage ? result.result.personalImage : img.personalImage;
                target = {name:name,picture:picture};
                curMsg = rongCloudUtil.resolveCon(curMsg, 1, target);

                var conversation = null;
                for (var i in $rootScope.conversation.conversationList){
                  var conversationTemp = $rootScope.conversation.conversationList[i];
                  if (conversationTemp.targetId == curMsg.targetId && conversationTemp.conversationType == curMsg.conversationType){
                    conversation = conversationTemp;
                    break;
                  }
                }
                if (!conversation){
                  $rootScope.conversation.conversationList.splice(0, 0, curMsg);
                }

                $rootScope.$apply();
              })
          }else if(curMsg.conversationType == "GROUP"){
            groupService.getGroupById(curMsg.targetId)
              .then(function(result){
                var name = result.result.name;
                var picture = !!result.result.picture ? result.result.picture : img.personalImage;
                target = {name:name,picture:picture};
                curMsg = rongCloudUtil.resolveCon(curMsg, 1, target);

                var conversation = null;
                for (var i in $rootScope.conversation.conversationList){
                  var conversationTemp = $rootScope.conversation.conversationList[i];
                  if (conversationTemp.targetId == curMsg.targetId && conversationTemp.conversationType == curMsg.conversationType){
                    conversation = conversationTemp;
                    break;
                  }
                }
                if (!conversation){
                  $rootScope.conversation.conversationList.splice(0, 0, curMsg);
                }

                $rootScope.$apply();
              })
          }
        }

        $("a[class^='JoinGroupUser']").on('click',function(e){
          var classInfo = $(e.target).attr("class");
          var userId = classInfo.split(' ')[0].split('-')[1];
          $state.go("menu.userDetail",{'userId':userId}) ;
        });

        $rootScope.$apply();

        if (!noBottomFlag){
          $ionicScrollDelegate.scrollBottom(true);
        }
      }

      try {
        /***********************************双击退出***********************************/
        $ionicPlatform.registerBackButtonAction(function (e) {
          //判断处于哪个页面时双击退出
          if (($state.includes("*.tab.*") && !$state.includes("*.tab.learn-list") && !$state.includes("*.tab.diagnose-list")) || $state.includes("signin")) {
            if ($rootScope.backButtonPressedOnceToExit) {
              rongcloudService.logout();
              ionic.Platform.exitApp();
            } else {
              $rootScope.backButtonPressedOnceToExit = true;
              $cordovaToast.showShortBottom('再按一次退出系统')
                .then(function (success) {
                  // success
                }, function (error) {
                  // error
                });
              setTimeout(function () {
                $rootScope.backButtonPressedOnceToExit = false;
              }, 2000);
            }
          }
          else if ($ionicHistory.backView()) {
            angular.element('.nav-bar-container').show();
            $rootScope.$broadcast('mobile:back');
            $rootScope.goToBack();
          } else {
            $rootScope.backButtonPressedOnceToExit = true;
            $cordovaToast.showShortBottom('再按一次退出系统')
              .then(function (success) {
                // success
              }, function (error) {
                // error
              });
            setTimeout(function () {
              $rootScope.backButtonPressedOnceToExit = false;
            }, 2000);
          }
          e.preventDefault();
          return false;
        }, 101);
      }catch(e){
        alert("error="+e) ;
      }

}])

.config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider, $sceDelegateProvider,$ionicNativeTransitionsProvider) {

  // Ionic uses AngularUI Router which uses the concept of states
  // Learn more here: https://github.com/angular-ui/ui-router
  // Set up the various states which the app can be in.
  // Each state's controller can be found in controllers.js
    $ionicConfigProvider.platform.ios.tabs.style('standard');
    $ionicConfigProvider.platform.ios.tabs.position('bottom');
    $ionicConfigProvider.platform.android.tabs.style('standard');
    $ionicConfigProvider.platform.android.tabs.position('standard');

    $ionicConfigProvider.platform.ios.navBar.alignTitle('center');
    $ionicConfigProvider.platform.android.navBar.alignTitle('center');

    $ionicConfigProvider.platform.ios.backButton.previousTitleText('').icon('ion-ios-arrow-thin-left');
    $ionicConfigProvider.platform.android.backButton.previousTitleText('').icon('ion-android-arrow-back');

    $ionicConfigProvider.platform.ios.views.transition('ios');
    $ionicConfigProvider.platform.android.views.transition('android');
    $ionicConfigProvider.views.swipeBackEnabled(false);

    if(localStorage.getItem("YLappIndex") != null){
        $urlRouterProvider.otherwise('/sign-in') ;
    }else{
      localStorage.setItem("YLappIndex", "1");
    }

    if(localStorage.getItem("httpType") == null){
      localStorage.setItem("httpType", "0");
    }
    if(localStorage.getItem("httpType") == "0"){
      config.new_url = config.new_url.replace('https://', 'http://');
    }else{
      config.new_url = config.new_url.replace('http://', 'https://');
    }

    //设置页面切换动画
    $ionicNativeTransitionsProvider.setDefaultOptions({
      duration: 0, // in milliseconds (ms), default 400,
      slowdownfactor: 4, // overlap views (higher number is more) or no overlap (1), default 4
      iosdelay: -1, // ms to wait for the iOS webview to update before animation kicks in,default -1
      androiddelay: -1, // same as above but for Android, default -1
      winphonedelay: -1, // same as above but for Windows Phone, default -1,
      fixedPixelsTop: 0, // the number of pixels of your fixed header, default 0 (iOS and Android)
      fixedPixelsBottom: 0 ,// the number of pixels of your fixed footer (f.i. a tab bar), default 0 (iOS and Android)
      triggerTransitionEvent: '$ionicView.afterEnter', // internal ionic-native-transitions option
      backInOppositeDirection: false // Takes over default back transition and state back transition to use the opposite direction transition to go back
    });
    //$ionicNativeTransitionsProvider.setDefaultTransition({ type: 'Fade', direction: 0 });
    //$ionicNativeTransitionsProvider.setDefaultBackTransition({ type: 'Fade', direction: 0 });

    $sceDelegateProvider.resourceUrlWhitelist([
      'self',
      'http://yuntv.letv.com/**'
    ]);

});
