angular.module('complain-controller',[])
  .controller('ComplainCtrl',function($scope,$rootScope,$state,$stateParams,complainService,$ionicLoading){

    $scope.complain = {
      dataId: $stateParams.dataId,
      dataType: $stateParams.dataType,
      complainUserId: $rootScope.user.id,
      complainContent: '',
      status:0
    }
    $scope.submitting = false;

    $scope.submit = function(){
      if ($scope.submitting){
        return;
      }
      $scope.submitting = true;
      $ionicLoading.show();
      complainService.addComplain($scope.complain)
        .then(function(result){
          $rootScope.$broadcast('message',"您的投诉信息提交成功",3000,"notice");
          $ionicLoading.hide();
          $scope.submitting = false;
          $scope.complain.complainContent="";
          $rootScope.goToBack();
        }, function(){
          $ionicLoading.hide();
          $scope.submitting = false;
          $scope.complain.complainContent="";
          $rootScope.goToBack();
        })
    }
});
