/**
 * Created by douhao on 2016/4/6.
 */
angular.module('diagnose-controller',[])
  .controller('DiagnoseCtrl',function($scope,$ionicHistory,$state,UserService,$rootScope,showAlertService,rongcloudService,$timeout){
    $scope.user = {};
    $scope.isLoginFail = false ;
    $scope.isLoading = true ;
    $scope.tokenTime = "" ;
    //sessionTime为20小时，隔20小时验证一次
    $scope.sessionTime =  20*60*60*1000;
    //定时刷新时间
    $scope.times = [] ;

    //$scope.diagnose = function(){
    //  //获取云影登录信息
    //  UserService.getLifeccpUserInfo($rootScope.user.id)
    //    .then(function(result){
    //      $scope.$broadcast('scroll.refreshComplete');
    //      $scope.user.userName = result.result.diagnoseUser ;
    //      $scope.user.password = result.result.diagnosePwd ;
    //      //云影登录
    //      UserService.lifeLogin($scope.user)
    //        .then(function(data){
    //          if(data.code == 200){
    //            $scope.isLoginFail = false ;
    //            sessionStorage.setItem('loginUser',JSON.stringify(data.data));
    //            if(data.data.roleGroups.length == 0){
    //              showAlertService.PopAlert("提示信息","您还没有加入任何一个阅片小组！","确认","") ;
    //              return false;
    //            }
    //            //else if(data.data.roleGroups.length == 1){
    //            //  $scope.roleGroups = data.data.roleGroups;
    //            //  $state.go("menu.tab.diagnose-list",{'groupId': data.data.roleGroups[0].id});
    //            //}
    //            else{
    //              //sessionStorage.setItem('loginUser',JSON.stringify(data.data));
    //              $scope.roleGroups = data.data.roleGroups;
    //            }
    //          }else{
    //            $scope.isLoginFail = true ;
    //            //showAlertService.PopAlert("提示信息","登录失败，诊断进入失败请联系管理员处理！","确认","") ;
    //          }
    //        });
    //    })
    //}
    $scope.getConfig = function(){
      UserService.getConfByType("diagnose")
        .then(function(result){
          if(result.code == 0 && result.result){
            for(var i = 0 ; i < result.result.length; i ++){
              if(result.result[i].confKey == 'times'){
                $scope.times = result.result[i].confValue.split(',') ;
              }
            }
          }
        })
    }
    $scope.getConfig() ;
    $scope.lifeAutoLogin = function(){
      UserService.lifeAutoLogin($scope.user)
        .then(function(data){
          if(data.code == 200){
              $scope.tokenTime = moment() ;
              var timer = $timeout(
                function() {
                  $scope.getToken() ;
                },
                $scope.sessionTime
              );
              $scope.isLoginFail = false ;
              sessionStorage.setItem('loginUser',JSON.stringify(data.data));
              localStorage.setItem("userIdentity",$rootScope.user.userIdentity) ;
              if(data.data.roleGroups.length == 0){
                $scope.roleGroups = data.data.roleGroups;
                showAlertService.PopAlert("提示信息","您还没有加入任何一个阅片小组！","确认","") ;
                return false;
              }
              //else if(data.data.roleGroups.length == 1){
              //  $scope.roleGroups = data.data.roleGroups;
              //  $state.go("menu.tab.diagnose-list",{'groupId': data.data.roleGroups[0].id});
              //}
              else{
                //sessionStorage.setItem('loginUser',JSON.stringify(data.data));
                $scope.roleGroups = data.data.roleGroups;
              }
            }else{
              $scope.isLoginFail = true ;
              //showAlertService.PopAlert("提示信息","登录失败，诊断进入失败请联系管理员处理！","确认","") ;
            }
        })
        .finally(function(){
          $scope.$broadcast('scroll.refreshComplete');
          $scope.isLoading = false ;
          showAlertService.loadingHide() ;
        })
    }

    $scope.getToken = function(){
      if(localStorage.getItem("token") == null || localStorage.getItem("token") == undefined || localStorage.getItem("token") == ""){
        UserService.getToken($rootScope.user.diagnoseUser)
          .then(function(result){
            if(result.code == 0){
              $scope.userToken = result.result ;
              localStorage.setItem("token",JSON.stringify(result.result)) ;
              $scope.user.userName = $scope.userToken.diagnoseUser ;
              $scope.user.password = $scope.userToken.token ;
              $scope.lifeAutoLogin() ;
            }
          })
          .finally(function(){
            showAlertService.loadingHide() ;
          })
      }else{
        var tokenInfo = JSON.parse(localStorage.getItem("token")) ;
        if(moment(tokenInfo.endDate).diff(moment(),'minutes') <= 30){
          UserService.getToken($rootScope.user.diagnoseUser)
            .then(function(result){
              if(result.code == 0){
                $scope.userToken = result.result ;
                localStorage.setItem("token",JSON.stringify(result.result)) ;
                $scope.user.userName = $scope.userToken.diagnoseUser ;
                $scope.user.password = $scope.userToken.token ;
                $scope.lifeAutoLogin() ;
              }
            })
            .finally(function(){
              showAlertService.loadingHide() ;
            })
        }else{
          $scope.user.userName = tokenInfo.diagnoseUser ;
          $scope.user.password = tokenInfo.token ;
          $scope.lifeAutoLogin() ;
        }
      }
    }
    $scope.doRefresh = function(){
      $scope.isLoading = false ;
      $scope.getToken() ;
    }

    $scope.diagnose = function(){
       showAlertService.loadingShow() ;
       $scope.getToken() ;
    }

    //$scope.$on('$ionicView.loaded', function() {
    $scope.diagnose() ;
    //}, false);

    $scope.openGroup = function(groupId){
      $state.go("menu.tab.diagnose-list",{'groupId': groupId,'times':$scope.times});
    }
});

