/**
 * Created by sks on 2016/5/17.
 */
angular.module('diagnoseList-controller',[])
  .controller('DiagnoseListCtrl',function($scope,$rootScope,$state,diagnoseService,$stateParams,$window,$cordovaInAppBrowser,rongcloudService,innermailService,UserService,groupService,showAlertService,$ionicHistory,$ionicPlatform,$cordovaToast,friendService,$interval,$ionicModal,$sce,$timeout,$ionicScrollDelegate,$cordovaKeyboard){
    var diagnoseListScroll = $ionicScrollDelegate.$getByHandle('diagnoseListScroll');
    var viewContentScroll = $ionicScrollDelegate.$getByHandle('viewContentScroll');
    var user = JSON.parse(sessionStorage.getItem('loginUser'));
    $scope.params = {
      hasmore : true ,
      current : 1 ,
      pageSize : 10,
    }
    $scope.isRefresh = false ;
    $scope.autoInterval = null ;
    $scope.times = $stateParams.times ;
    if($scope.times != undefined && $scope.times.length > 0){
      $scope.autoRefreshTimeAry = $scope.times ;
    }else{
      $scope.autoRefreshTimeAry = [1,2,5] ;
    }
    $scope.autoRefreshTime = $scope.autoRefreshTimeAry[0] ;
    $scope.isAutoRefresh  = true ;
    $scope.dataBase = [] ;

    $scope.startInterval = function(){
      $interval.cancel($scope.autoInterval);
      $scope.autoInterval = $interval(function(){
        diagnoseListScroll.scrollTop(true) ;
        $scope.isRefresh = true ;
        $scope.autoRefresh() ;
      },$scope.autoRefreshTime*1000*60);
    }
    $scope.switchAuto = function(){
      $scope.isAutoRefresh = !$scope.isAutoRefresh ;
      if($scope.isAutoRefresh){
        $scope.startInterval() ;
      }else{
        $interval.cancel($scope.autoInterval);
      }
    }

    //页面进入后 初始化定时器
    $scope.$on('$ionicView.enter', function() {
      if($scope.isAutoRefresh) {
        $scope.startInterval() ;
      }
    }, false);

    //页面离开后 停止定时器
    $scope.$on('$ionicView.leave', function() {
      $interval.cancel($scope.autoInterval);
    }, false);

    $scope.switchTime = function(index){
      $scope.autoRefreshTime = $scope.autoRefreshTimeAry[index] ;
      $scope.startInterval() ;
    }

    $scope.autoRefresh = function(){
      var params = {};
      params.groupId = $stateParams.groupId;
      params.createFrom = moment().subtract(29, 'days').format('YYYY-MM-DD');
      params.createEnd = moment().format('YYYY-MM-DD');
      //params.createFrom = '2016-04-18';
      //params.createEnd = '2016-05-18';
      params.needPicture = 1;
      params.currentPage = 1;
      params.currentSize = $scope.params.pageSize;
      params.st = [0,1,2,3];
      diagnoseService.tasklist(params)
        .then(function(data){
          if(data.code == 200){
            $scope.dataBase = data.data.list;
            $scope.params = {
              hasmore : true ,
              current : 1 ,
              pageSize : 10,
            }
            if($scope.dataBase.length < $scope.params.pageSize){
              $scope.params.hasmore = false ;
            }else{
              $scope.params.current ++ ;
            }
          }else{

          }
        },function(reason){
          $scope.params.hasmore = false ;
        })
        .finally(function(){
          $scope.isRefresh = false ;
        });
    }

    //$scope.signIn = function(){
    //  showAlertService.loadingShow();
    //  $scope.isLogining = true ;
    //  //console.log($scope.user.userName) ;
    //
    //  //localStorageService.set("userName",user.userName) ;
    //  UserService.login($scope.user)
    //    .then(function(result){
    //      $scope.isLogining = false ;
    //      if(result.success == false){
    //        showAlertService.loadingHide();
    //        //$rootScope.$broadcast("error") ;
    //        switch (result.code){
    //          case 410:
    //            showAlertService.PopAlert("登录失败","用户不存在，请确认用户名是否正确！","确认","") ;
    //            break;
    //          case 411:
    //            showAlertService.PopConfirm("登录失败","密码错误，是否找回密码?","取消","找回密码")
    //              .then(function(res) {
    //                if(res) {
    //                  $state.go("retrievePwd") ;
    //                } else {
    //                }
    //              });
    //            break ;
    //        }
    //      }else{
    //        showAlertService.loadingHide();
    //        //$rootScope.user.userId = result.id ;
    //        //$rootScope.user.userName = result.name ;
    //        //保存信息
    //        //判断手机号码跟手机密码是否存在
    //        if(result.result.phoneNumber == null || result.result.phonePsd == null){
    //          localStorage.setItem("user", window.btoa(result.result.email));
    //          localStorage.setItem("pwd", window.btoa(result.result.emailPsd));
    //        }else{
    //          localStorage.setItem("user", window.btoa(result.result.phoneNumber));
    //          localStorage.setItem("pwd", window.btoa(result.result.phonePsd));
    //        }
    //        $rootScope.user = result.result ;
    //        //sessionStorage.user = result
    //
    //        if(!result.result.personalImage){
    //          $rootScope.user.personalImage = img.personalImage ;
    //        }
    //
    //        friendService.getFriendApply();
    //        $interval(function(){
    //          friendService.getFriendApply();
    //        }, 1000*60*5);
    //
    //        $ionicPlatform.ready(function(){
    //          // 初始化rongCloud
    //          rongcloudService.getToken($rootScope.user.id)
    //            .then(function(result){
    //              rongcloudService.init(result.result.appKey, result.result.token);
    //
    //              groupService.getGroupsByUserid($rootScope.user.id, '')
    //                .then(function(result){
    //                  var groups = {};
    //                  groups.groups = [];
    //                  if (result.success){
    //                    for(var i in result.result){
    //                      var group = {id: result.result[i].id, name: result.result[i].name, portraitUrl: !!result.result[i].picture ? result.result[i].picture : img.personalImage};
    //                      groups.groups.push(group);
    //                    }
    //                  }
    //
    //                  if (groups.groups.length > 0){
    //                    rongcloudService.syncGroup(groups);
    //                  }
    //                })
    //            })
    //        })
    //
    //      }
    //    })
    //}

    //try {
    //  /***********************************双击退出***********************************/
    //  $ionicPlatform.registerBackButtonAction(function (e) {
    //    //判断处于哪个页面时双击退出
    //    if (($state.includes("*.tab.*") && !$state.includes("*.tab.learn-list") && !$state.includes("*.tab.diagnose-list")) || $state.includes("signin")) {
    //      if ($rootScope.backButtonPressedOnceToExit) {
    //        rongcloudService.logout();
    //        ionic.Platform.exitApp();
    //      } else {
    //        $rootScope.backButtonPressedOnceToExit = true;
    //        $cordovaToast.showShortBottom('再按一次退出系统')
    //          .then(function (success) {
    //            // success
    //          }, function (error) {
    //            // error
    //          });
    //        setTimeout(function () {
    //          $rootScope.backButtonPressedOnceToExit = false;
    //        }, 2000);
    //      }
    //    }
    //    else if ($ionicHistory.backView()) {
    //      $rootScope.goToBack();
    //    } else {
    //      $rootScope.backButtonPressedOnceToExit = true;
    //      $cordovaToast.showShortBottom('再按一次退出系统')
    //        .then(function (success) {
    //          // success
    //        }, function (error) {
    //          // error
    //        });
    //      setTimeout(function () {
    //        $rootScope.backButtonPressedOnceToExit = false;
    //      }, 2000);
    //    }
    //    e.preventDefault();
    //    return false;
    //  }, 101);
    //}catch(e){
    //  alert("error="+e) ;
    //}

    $scope.goToBack = function(){
      $state.go('menu.tab.diagnose') ;
    }
    //$scope.$on('$ionicView.loaded', function() {
    //  if($ionicHistory.viewHistory().backView == null){
    //    $scope.user = {
    //      userName : window.atob(localStorage.getItem("user")),
    //      password : window.atob(localStorage.getItem("pwd")),
    //    }
    //    $scope.signIn() ;
    //  }
    //}, false);
    $scope.doRefresh = function(){
      var params = {};
      $scope.isRefresh = false ;
      $interval.cancel($scope.autoInterval);
      params.groupId = $stateParams.groupId;
      params.createFrom = moment().subtract(29, 'days').format('YYYY-MM-DD');
      params.createEnd = moment().format('YYYY-MM-DD');
      //params.createFrom = '2016-04-18';
      //params.createEnd = '2016-05-18';
      params.needPicture = 1;
      params.currentPage = 1;
      params.currentSize = $scope.params.pageSize;
      params.st = [0,1,2,3];
      diagnoseService.tasklist(params)
        .then(function(data){
          if(data.code == 200){
            $scope.dataBase = data.data.list;
            $scope.params = {
              hasmore : true ,
              current : 1 ,
              pageSize : 10,
            }
            if($scope.dataBase.length < $scope.params.pageSize){
              $scope.params.hasmore = false ;
            }else{
                $scope.params.current ++ ;
            }
          }else{

          }
        },function(reason){
          $scope.params.hasmore = false ;
        })
        .finally(function(){
          $scope.isRefresh = false ;
          if($scope.isAutoRefresh){
            $scope.startInterval() ;
          }
          $scope.$broadcast('scroll.refreshComplete');
        });
    }
    $scope.loadMore = function(){
      var params = {};
      $scope.isRefresh = false ;
      $interval.cancel($scope.autoInterval);
      params.groupId = $stateParams.groupId;
      //params.createFrom = moment().subtract(29, 'days').format('YYYY-MM-DD');
      //params.createEnd = moment().format('YYYY-MM-DD');
      params.createFrom = moment().subtract(29, 'days').format('YYYY-MM-DD');
      params.createEnd = moment().format('YYYY-MM-DD');
      //params.createFrom = '2016-04-18';
      //params.createEnd = '2016-05-18';
      params.needPicture = 1;
      params.currentPage = $scope.params.current;
      params.currentSize = $scope.params.pageSize;
      params.st = [0,1,2,3];
      diagnoseService.tasklist(params)
        .then(function(data){
        if(data.code == 200){
          $scope.dataBase = $scope.dataBase.concat(data.data.list);
          if(data.data.list.length < $scope.params.pageSize){
            $scope.params.hasmore = false ;
          }
          $scope.params.current += 1;
          $scope.$broadcast('scroll.infiniteScrollComplete');
        }else{
          $scope.params.hasmore = false ;
        }
      },function(){
          $scope.params.hasmore = false ;
      })
      .finally(function(){
        $scope.isRefresh = false ;
        if($scope.isAutoRefresh){
          $scope.startInterval() ;
        }
        $scope.$broadcast('scroll.infiniteScrollComplete');
      });
    };
    //$scope.loadMore(1,$scope.params.pageSize);
    $scope.goReport = function(item){
      //var ua = navigator.userAgent.toLowerCase();
      //if(ua.match(/MicroMessenger/i) == 'micromessenger'){
      //  wx.getNetworkType({
      //    success: function (res) {
      //      var networkType = res.networkType; // 返回网络类型2g，3g，4g，wifi
      //      if(networkType != 'wifi'){
      //        if(confirm('进入阅片会消耗大量的流浪，土豪请随意~'))
      //        {
      //          $scope.openReport(item.caseId,item.id,item.studyId,user.id,user.userName);
      //          // $state.go('report',{caseId:item.caseId,id:item.id,studyId:item.studyId,userId:user.id,userName:user.userName});
      //        }
      //      }else{
      //        $scope.openReport(item.caseId,item.id,item.studyId,user.id,user.userName);
      //        // $state.go('report',{caseId:item.caseId,id:item.id,studyId:item.studyId,userId:user.id,userName:user.userName});
      //      }
      //    }
      //  });
      //  $scope.openReport(item.caseId,item.id,item.studyId,user.id,user.userName);
      //}else{
      if(item.view == 0){
        showAlertService.PopAlert("提示信息","该报告没有图像!","确认","") ;
      }else{
        $scope.openReport(item.caseId,item.id,item.studyId,user.id,user.userName);
      }
      //}
    };
    $scope.openReport = function (caseId,id,studyId,userId,userName){
      //rongcloudService.logout();
      $interval.cancel($scope.autoInterval);
      showAlertService.loadingShow() ;
      $ionicModal.fromTemplateUrl('templates/diagnose/viewer.html', {
        scope: $scope,
        animation: 'slide-in-none'
      }).then(function (modal) {
        $scope.modal = modal;
      });
      var goUrl = 'viewer.html?studyUID='+studyId+'&userId='+userId+'&sessionId='+user.sessionId+'&caseId='+caseId+'&id='+id ;
      $scope.vm = {
        paySrc:goUrl,
      }
      $scope.vm.paySrc = $sce.trustAsResourceUrl(goUrl);
      $timeout(function(){
        $scope.modal.show();
        showAlertService.loadingHide() ;
        $timeout(function(){
          var textAreas = document.getElementById("diagnoseIFrame").contentWindow.document.getElementsByTagName("textarea");
          for(var i = 0 ; i < textAreas.length ; i ++){
            textAreas[i].addEventListener("blur", function(){
              $cordovaKeyboard.close();
              viewContentScroll.scrollTo(0,-100) ;
            });
            textAreas[i].addEventListener("focus",function(){
              viewContentScroll.scrollTo(0,100) ;
            });
            textAreas[i].addEventListener("click",function(event){
              event.stopPropagation() ;
            });
          }
          var editContent =  document.getElementById("diagnoseIFrame").contentWindow.document.getElementById("editReport") ;
          editContent.addEventListener("click", function(){
            $cordovaKeyboard.close();
          });
        },2000) ;
      },1000) ;
      //var options = {
      //  location: 'yes',
      //  clearcache: 'no',
      //  toolbar: 'no'
      //};
      //$cordovaInAppBrowser.open(goUrl, '_self', options)
      //  .then(function(event) {
      //    // success
      //    showAlertService.loadingHide() ;
      //  })
      //  .catch(function(event) {
      //    // error
      //    showAlertService.loadingHide() ;
      //  });
    }
    $scope.closeReport = function(){
      var textAreas = document.getElementById("diagnoseIFrame").contentWindow.document.getElementsByTagName("textarea") ;
      for(var i = 0 ; i < textAreas.length ; i ++){
        textAreas[i].blur() ;
      }
      $cordovaKeyboard.close();
      $timeout(function(){
        if($scope.isAutoRefresh){
          $scope.startInterval() ;
        }
        $scope.modal.remove() ;
        //document.getElementById("diagnoseIFrame").contentWindow.document.getElementById('editReport').style.zIndex = "-1" ;
      },300) ;
    }
    window.contentScorllTop = function(){
      viewContentScroll.scrollTop() ;
    }
  });
