/**
 * Created by douhao on 16/11/30.
 */
angular.module('tabs-controller',[])
  .controller('TabController',function($scope,UserService,$rootScope,$state,$timeout){
      $scope.getStatistics = function(){
        if($rootScope.user.id <= 0){
          $rootScope.$broadcast('goLogin:show');
        }else{
          UserService.getUserCenterInfo($rootScope.user.id)
            .then(function(result){
              if(result.code == 0){
                $rootScope.statistics = result.result ;
                $rootScope.user.userIdentity = result.result.userIdentity ;
                $rootScope.user.diagnoseUser = result.result.diagnoseUser ;
              }
            })
          $state.go("menu.tab.personal") ;
        }
      }

      $scope.toUpdateImage = function($event){
        $state.go('menu.personalCenterUpdateImage') ;
        $event.stopPropagation();
      }

      $scope.toPersonalValidation = function(){
        $timeout(function(){
          $state.go("menu.validation") ;
        },20)
      }
  });
