/**
 * Created by sks on 2016/12/12.
 */
angular.module('specialists-controller',[])
  .controller('SpecialistsCtrl',function($scope,UserService,$rootScope,$state,HomePageService,$ionicModal,$sce,$ionicGesture,$ionicSlideBoxDelegate,friendService,$ionicPopup,$timeout,$ionicScrollDelegate){
    var specialScroll = $ionicScrollDelegate.$getByHandle('specialScroll');
    $scope.search = {
      params:{
        hasmore : true ,
        page : 1 ,
        pageSize:10,
      },
      isSearch:false,
      isGetDataIng:false,
      searchText:"",
      specialist:[]
    }
    $scope.params = {
      hasmore : true ,
      page : 1 ,
      pageSize:10,
    }
    $scope.country = {
      focus:false,
    }
    $scope.isShowCity = false ;
    $scope.privence = "" ;
    $scope.city = "" ;
    $scope.specialist = [] ;
    $scope.content = "";
    $scope.swfArea = [] ;
    $scope.getSwfArea = function(){
      UserService.getSwfArea()
        .then(function(result){
          $scope.swfArea = result ;
        })
    }

    $scope.$on('$ionicView.afterEnter', function() {
      $scope.currentTime = new Date().getTime() ;
    }, false);
    $scope.getSwfArea() ;
    $scope.doRefresh = function(){
      $scope.hiden = true ;
      HomePageService.getSpecialists($rootScope.user.id,1,$scope.params.pageSize,$scope.content,$scope.privence,$scope.city)
        .then(function(result){
          $scope.hiden = false ;
          $scope.params = {
            hasmore : true ,
            page : 1 ,
            pageSize : 10,
          }
          if(result.code == 0){
            $scope.specialist = result.result;
            //当前页等于总页数时，禁止加载更多
            if($scope.params.pageSize > result.result.length){
              $scope.params.hasmore = false ;
            }else{
              $scope.params.page ++;
            }
          }else{
            $scope.params.hasmore = false ;
          }
        },function(reason){
          $scope.params.hasmore = false ;
        })
        .finally(function () {
          $scope.$broadcast("scroll.refreshComplete");
        });
    }
    $scope.loadMore = function(){
      HomePageService.getSpecialists($rootScope.user.id,$scope.params.page,$scope.params.pageSize,$scope.content,$scope.privence,$scope.city)
        .then(function(result){
          if(result.code == 0){
            $scope.specialist = $scope.specialist.concat(result.result);
            //当前页等于总页数时，禁止加载更多
            if($scope.params.pageSize > result.result.length){
              $scope.params.hasmore = false ;
            }else{
              $scope.params.page ++;
            }
          }else{
            $scope.params.hasmore = false ;
          }
        },function(reason){
          $scope.params.hasmore = false ;
        })
        .finally(function () {
          $scope.$broadcast("scroll.infiniteScrollComplete");
        });
    }

    $scope.search.doRefresh = function(){
      $scope.hiden = true ;
      $scope.search.isGetDataIng = true ;
      $scope.search.params = {
        hasmore: false,
        current: 1,
        pageSize: 10,
      }
      $scope.search.specialist = [] ;
      $scope.search.isSearch = true ;
      HomePageService.getSpecialists($rootScope.user.id,1,$scope.search.params.pageSize,$scope.search.searchText,"","")
        .then(function(result){
          $scope.hiden = false ;
          if(result.code == 0){
            $scope.search.specialist = result.result;
            //当前页等于总页数时，禁止加载更多
            if($scope.search.params.pageSize > result.result.length){
              $scope.search.params.hasmore = false ;
            }else{
              $scope.search.params.hasmore = true ;
              $scope.search.params.page ++;
            }
          }else{
            $scope.search.params.hasmore = false ;
          }
        },function(reason){
          $scope.search.params.hasmore = false ;
        })
        .finally(function () {
          $scope.search.isGetDataIng = false ;
        });
    }

    $scope.search.loadMore = function(){
      HomePageService.getSpecialists($rootScope.user.id,$scope.search.params.page,$scope.search.params.pageSize,$scope.search.searchText,"","")
        .then(function(result){
          if(result.code == 0){
            $scope.search.specialist = $scope.search.specialist.concat(result.result);
            //当前页等于总页数时，禁止加载更多
            if($scope.search.params.pageSize > result.result.length){
              $scope.search.params.hasmore = false ;
            }else{
              $scope.search.params.hasmore = false ;
              $scope.search.params.page ++;
            }
          }else{
            $scope.search.params.hasmore = false ;
          }
        },function(reason){
          $scope.search.params.hasmore = false ;
        })
        .finally(function () {
          $scope.$broadcast("scroll.infiniteScrollComplete");
        });
    }

    $scope.search.clearSearch = function(){
      $scope.search.searchText = '' ;
    }
    $scope.search.cancelSearch = function(){
      $scope.search.searchText = '' ;
      $scope.search.isSearch = false ;
    }

    //监控UserId变化，读取个人信息
    $rootScope.$watch('user.id',function(newValue,oldValue){
      if(newValue > 0 && $scope.specialist.length > 0){
        $scope.specialist = [] ;
        $scope.params.page = 1 ;
        $scope.params.hasmore = true ;
        specialScroll.scrollTop() ;
        $scope.loadMore();
      }
    })

    $scope.selectTime = new Date().getTime();
    $scope.showCitySelect = function(){
      var currentTime = new Date().getTime();
      if (currentTime - $scope.selectTime < 500){
        return;
      }
      $scope.selectTime = currentTime;
      $scope.getSwfArea() ;
      $scope.isShowCity = !$scope.isShowCity ;
    }

    $scope.focusCity = function(privenceIndex,cityIndex,$event){
      if(privenceIndex === '' && cityIndex ===''){
        for(var privenceIndex in $scope.swfArea){
          $scope.swfArea[privenceIndex].focus = false ;
          for(var cityIndex in $scope.swfArea[privenceIndex].child){
            $scope.swfArea[privenceIndex].child[cityIndex].focus = false ;
          }
        }
        $scope.country.focus = !$scope.country.focus ;
        $scope.privence = "";
        $scope.city = "" ;
      }else{
        $scope.country = {
          focus:false,
        }
        if(cityIndex === '' ){
          $scope.swfArea[privenceIndex].focus = !$scope.swfArea[privenceIndex].focus ;
          //如果取消选择的省份，将该省份下的城市都取消
          if(!$scope.swfArea[privenceIndex].focus){
            for(var i = 0 ; i <$scope.swfArea[privenceIndex].child.length ; i ++ ){
              $scope.swfArea[privenceIndex].child[i].focus = false ;
            }
          }
          //$scope.privence += $scope.swfArea[privenceIndex].id+",";
        }else{
          $scope.swfArea[privenceIndex].child[cityIndex].focus = !$scope.swfArea[privenceIndex].child[cityIndex].focus ;

          //$scope.city += $scope.swfArea[privenceIndex].child[cityIndex].id +",";
        }
      }
      $event.stopPropagation();
    }

    $scope.confirmCity = function(){
      $scope.privence = "" ;
      $scope.city = "" ;
      for(var privenceIndex in $scope.swfArea){
        if($scope.swfArea[privenceIndex].focus){
          $scope.privence += $scope.swfArea[privenceIndex].id+",";
        }
        for(var cityIndex in $scope.swfArea[privenceIndex].child){
          if($scope.swfArea[privenceIndex].child[cityIndex].focus){
            $scope.city += $scope.swfArea[privenceIndex].child[cityIndex].id +",";
          }
        }
      }
      $scope.privence = $scope.privence.substring(0,$scope.privence.length-1) ;
      $scope.city = $scope.city.substring(0,$scope.city.length-1) ;
      specialScroll.scrollTop() ;
      $scope.doRefresh() ;
      $scope.isShowCity = false ;
    }

    $scope.reset = function(){
      for(var privenceIndex in $scope.swfArea){
        $scope.swfArea[privenceIndex].focus = false ;
        for(var cityIndex in $scope.swfArea[privenceIndex].child){
          $scope.swfArea[privenceIndex].child[cityIndex].focus = false ;
        }
      }
      $scope.country.focus = false ;
      $scope.privence = "" ;
      $scope.city = "" ;
      $scope.doRefresh() ;
      $scope.isShowCity = false ;
    }

    $scope.addFriend = function(friednId,$event){
      if($rootScope.user.id <= 0){
        $rootScope.$broadcast('login:show');
        $event.stopPropagation();
        return ;
      }
      friendService.addFriend($rootScope.user.id, friednId, 0)
        .then(function(result){
          var myPopup = $ionicPopup.show({
            title: '添加好友申请已经发送。'
          });
          $timeout(function() {
            myPopup.close();
          }, 3000);
        })
      $event.stopPropagation();
    }
  })
