angular.module('learnDetail-controller',[])
  .controller('LearnDetailCtrl',function($ionicHistory, $scope,$rootScope,$state,$stateParams,$ionicModal,$ionicPopup,learnService,commentService,$ionicScrollDelegate,$ionicActionSheet,$sce,UserService,showAlertService,$cordovaToast,HomeService,UserService){
    $scope.share_header = "https://open.weixin.qq.com/connect/oauth2/authorize?appid=wx6939749493987808&redirect_uri=" ;
    $scope.share_footer = "&response_type=code&scope=snsapi_userinfo#wechat_redirect" ;
    $scope.learnInfo = [];
    $scope.sizeBigFlag = false;
    $scope.isNeedPay = false ;
    $scope.isMayPay = false ;
    $scope.productId = "" ;
    $scope.video_no_learn = "img/study/no_learn.png"
    $scope.shopTime = "" ;
    $scope.payedUrl = ""
    $scope.pointInfo = "" ;
    $scope.isClassRoom = false ;
    $scope.module = "video" ;
    //是否支付完成
    $scope.isPaying = false ;

    //商品有效期与系统时间对比
    $scope.compareProductTermtime = function(shopTime){
      var systemTimes = moment().format('YYYY-MM-DD') ;
      if(systemTimes>shopTime){
        return true;
      }else{
        return false;
      }
    }

    //获取详情信息
    //$scope.getLearnDetail = function(){
    //  learnService.findById($stateParams.learnId)
    //    .then(function(resu) {
    //      $scope.pointInfo = resu.PointInfo ;
    //      $scope.getUserScore() ;
    //      if (!$scope.pointInfo.success) {
    //        //alert($scope.pointInfo.message);
    //        if(pointInfo.code == 3001){
    //          //alert("当前用户还不是会员医生，请在个人中心升级！");
    //        }
    //        else if(pointInfo.code == 3002){
    //          //alert("后台服务错误(3002)，请稍后再试或联系管理员");
    //          showAlertService.PopAlert("服务器错误(3002)","请稍后再试或联系管理员","确认","") ;
    //        }
    //        else if(pointInfo.code == 3003){
    //          //alert("后台服务错误(3003)，请稍后再试或联系管理员");
    //          showAlertService.PopAlert("服务器错误(3003)","请稍后再试或联系管理员","确认","") ;
    //        }
    //      } else {
    //        var product = $scope.pointInfo.obj;
    //        if ($scope.pointInfo.success && pointInfo.code==3004) {
    //          /*******************4、没有订单信息*********************/
    //            //alert("没有订单信息");
    //          $scope.shopTime = "";
    //          $scope.isMayPay = true;
    //          $scope.shopTime = product.productTerm + " 个月";
    //          $scope.productId = product.id; // 商品id
    //        } else if($scope.pointInfo.success && pointInfo.code==0){
    //          // 订单信息
    //          $scope.isNeedPay = false;
    //          $scope.shopTime = product.orderTerm.substr(0, 10);
    //          //商品是否过期,未过期可以直接观看，过期，不可观看
    //          //if($scope.compareProductTermtime($scope.shopTime)){
    //          //  $scope.isNeedPay = true ;
    //          //}else{
    //          //  $scope.isNeedPay = false ;
    //          //}
    //        }
    //      }
    //    })
    //}

    $scope.initData = function(){
      learnService.findById($stateParams.learnId,$rootScope.user.id)
        .then(function(res) {
          var result = res.result;
          $scope.learnInfo = result.dataLearnInfo;
          $scope.learnInfo.videoSize = Math.ceil(bytesToSize(result.dataLearnInfo.initialSize));
          $scope.learnInfo.videoLength = formatTime(result.dataLearnInfo.videoDuration);
          if(result.dataLearnInfo.publishDate != null){
            $scope.learnInfo.date = result.dataLearnInfo.publishDate.substr(0,10);
          }
          var videoWidth = window.screen.width;
          //网络请求参数
          $scope.videoUrl = $sce.trustAsResourceUrl('http://yuntv.letv.com/bcloud.html?uu='+ result.dataLearnInfo.uu + '&vu=' + result.dataLearnInfo.vu + '&auto_play=0&gpcflag=1&width='+videoWidth+'&height=200');
          $scope.uu = result.dataLearnInfo.uu;
          $scope.vu = result.dataLearnInfo.vu;
          letvplayer.init({uu: $scope.uu, vu: $scope.vu, auto_play: 0, dfull: 0}, "playerid");
          learnService.read($stateParams.learnId, $rootScope.user.id);
          $scope.updateSocial($rootScope.updateSocial.operRead,$rootScope.updateSocial.operationAdd) ;

          learnService.isAgree($stateParams.learnId, $rootScope.user.id)
            .then(function(res1){
              var liked = res1.result;
              learnService.isCollect($stateParams.learnId, $rootScope.user.id)
                .then(function(res2){
                  var stored = res2.result;
                  $scope.socialInfo.init($scope.learnInfo.agreeNum, $scope.learnInfo.storeNum, $scope.learnInfo.readNum, $scope.learnInfo.commentNum, liked, stored);
                })
            })

          if ($scope.learnInfo.videoSize > 20){
            $scope.sizeBigFlag = true;
          }else{
            $scope.sizeBigFlag = false;
          }

          //1、判断是否收费
          if ("1" == $scope.learnInfo.dataLearnType) {
            $scope.isNeedPay = true ;
            //登录用户才可以购买
            if($rootScope.user.id > 0){
              $scope.getUserScore();
              $scope.pointInfo = eval("("+result.PointInfo+")");
              var product = $scope.pointInfo.obj;
              if($scope.pointInfo.success){
                if( $scope.pointInfo.code == 0){
                  //存在订单
                  $scope.shopTime = product.orderTerm.substr(0, 10);
                  if($scope.compareProductTermtime($scope.shopTime)){
                    $scope.isNeedPay = true ;
                    $scope.productId = product.productId ;
                  }else{
                    $scope.isNeedPay = false ;
                  }
                }else{
                  $scope.isNeedPay = true ;
                  $scope.productId = product.id ;
                  $scope.shopTime = product.productTerm + " 个月";
                }
              }else{
                $scope.shopTime = $scope.learnInfo.productTerm +"个月" ;
                //if($scope.pointInfo.code == 3001){
                //  //alert("当前用户还不是会员医生");
                //}
                //else if($scope.pointInfo.code == 3002){
                //  //alert("后台服务错误(3002)，请稍后再试或联系管理员");
                //  showAlertService.PopAlert("服务器错误(3002)","请稍后再试或联系管理员","确认","") ;
                //  return ;
                //}
                //else if($scope.pointInfo.code == 3003){
                //  //alert("您的积分不足， 请在个人中心查看积分策略！");
                //  showAlertService.PopAlert("服务器错误(3003)","请稍后再试或联系管理员","确认","") ;
                //  return ;
                //}
              }
            }else{
              $scope.shopTime = $scope.learnInfo.productTerm +"个月" ;
            }
          }else{
            $scope.isNeedPay = false ;
          }

          //$scope.pointInfo = result.PointInfo ;
          //
          ////判断是否收费
          //if("1"==$scope.learnInfo.dataLearnType){
          //  // 积分系统对象
          //  $scope.pointInfo = eval("("+result.PointInfo+")");
          //  if(0==$rootScope.user.id){
          //    //alert("登录后才能购买") ;
          //    $rootScope.isVisible = true ;
          //    $rootScope.$broadcast("error","登录后才能购买") ;
          //  }else {
          //    //如果后台返回未登录，需要重新登录一次
          //    if("n"==result.isUserExist){
          //      var user = {
          //        userName:window.atob(localStorage.getItem("user")),
          //        password:window.atob(localStorage.getItem("pwd"))
          //      } ;
          //      UserService.login(user)
          //        .then(function(data){
          //          $scope.getLearnDetail() ;
          //        })
          //    }else{
          //      //用户存在，直接判断是否可以观看
          //      $scope.getUserScore() ;
          //      //alert("s1") ;
          //      if (false == $scope.pointInfo.success) {
          //        //alert("s2") ;
          //        //alert($scope.pointInfo.message);
          //      } else {
          //        var product = $scope.pointInfo.obj;
          //        //alert("s3") ;
          //        if (true == $scope.pointInfo.success && $scope.pointInfo.code == 1) {
          //          /*******************4、没有订单信息*********************/
          //            //alert("没有订单信息");
          //          //alert("s4") ;
          //          $scope.shopTime = "";
          //          $scope.isMayPay = true;
          //          $scope.shopTime = product.productTerm + " 个月";
          //          $scope.productId = product.id; // 商品id
          //        } else {
          //          //alert("s5") ;
          //          // 订单信息
          //          $scope.isNeedPay = false;
          //          $scope.shopTime = product.orderTerm.substr(0, 10);
          //        }
          //      }
          //    }
          //  }
          //}else{
          //  $scope.isNeedPay = false ;
          //}

//      http://yuntv.letv.com/bcloud.html?uu=eaggvuwd1x&vu=48d2884c51&auto_play=0&gpcflag=1&width=360&height=200
        })

    }

    $scope.initData();
    $rootScope.$watch('user.id',function(newValue,oldValue){
      if(newValue > 0 && newValue != oldValue && $ionicHistory.viewHistory().currentView.stateId.startsWith('menu.learn-detail_learnId=')){
        $scope.initData();
      }
    })

    $ionicModal.fromTemplateUrl('templates/learn/buy.html', {
      scope: $scope,
      animation:'slo'
    }).then(function(modal) {
      $scope.modal = modal;
    });

    $scope.getUserScore = function(){
      learnService.getUserScore($rootScope.user.id)
        .then(function(result){
          $scope.userScoreInfo = JSON.parse(result.result);
        })
    }

    //  购买确认页面
    $scope.showBuyConfirm = function() {
      if(0==$rootScope.user.id){
        $rootScope.$broadcast('login:show');
        return ;
      }
      if(false==$scope.userScoreInfo.success){
        //alert("请前往个人中心升级为会员医生!");
        showAlertService.PopAlert("提示信息","请前往个人中心升级为会员医生!","确认","") ;
        $scope.modal.hide() ;
        return;
      }
      //alert("s7") ;
      if($scope.productId==""){
        //alert("该商品已下架!");
        showAlertService.PopAlert("提示信息","该商品已下架!","确认","") ;
        $scope.modal.hide() ;
        return;
      }
      //alert("s8") ;
      var usableScore = $scope.userScoreInfo.obj.usableScore;
      if(usableScore - $scope.learnInfo.dataLearnScore<0){
        //alert("积分余额不足!");
        showAlertService.PopAlert("提示信息","积分余额不足!","确认","") ;
        $scope.modal.hide() ;
        return;
      }
      if($scope.pointInfo.code == 3001){
        //alert("当前用户还不是会员医生");
      }
      else if($scope.pointInfo.code == 3002){
        //alert("后台服务错误(3002)，请稍后再试或联系管理员");
        showAlertService.PopAlert("服务器错误(3002)","服务器错误(3002),请稍后再试或联系管理员","确认","") ;
        return ;
      }
      else if($scope.pointInfo.code == 3003){
        //alert("您的积分不足， 请在个人中心查看积分策略！");
        showAlertService.PopAlert("服务器错误(3003)","服务器错误(3003),请稍后再试或联系管理员","确认","") ;
        return ;
      }else if($scope.pointInfo.code == 3006){
        showAlertService.PopAlert("服务器错误(3006)","服务器错误(3006),请稍后再试或联系管理员","确认","") ;
        return ;
      }
      //alert("s6") ;
      //alert("s9") ;
      $scope.modal.show() ;
    };
    //取消
    $scope.cancel = function(){
      $scope.modal.hide() ;
    }
    //购买
    $scope.pay = function() {
      var orderRemark = "购买资料";
      $scope.isPaying = true ;
      learnService.pay($stateParams.learnId, $scope.productId, $rootScope.user.id, orderRemark)
        .then(function (result) {
          $scope.modal.hide();
          // 积分系统对象
          /*******************3、积分系统返回异常*********************/
          if (result.code != 0) {
            $rootScope.$broadcast("message","请稍后再试！",3000,"alert") ;
          } else {
            var returnPointInfo = eval("("+result.result+")");
            //是否支付完成
            $scope.isPaying = false ;
            if(returnPointInfo.code == 3001){
              showAlertService.PopAlert("提示信息","请前往个人中心升级为会员医生!","确认","") ;
            }
            else if(returnPointInfo.code == 3002){
              //alert("后台服务错误(3002)，请稍后再试或联系管理员");
              showAlertService.PopAlert("服务器错误(3002)","服务器错误(3002),请稍后再试或联系管理员","确认","") ;
              return ;
            }
            else if(returnPointInfo.code == 3003){
              //alert("您的积分不足， 请在个人中心查看积分策略！");
              showAlertService.PopAlert("服务器错误(3003)","服务器错误(3003),请稍后再试或联系管理员","确认","") ;
              return ;
            }else if(returnPointInfo.code == 3006){
              showAlertService.PopAlert("服务器错误(3006)","服务器错误(3006),请稍后再试或联系管理员","确认","") ;
              return ;
            }
            // 购买成功
            //alert("购买成功!", "提示信息");
            showAlertService.PopAlert("提示信息","购买成功!","确认","") ;
            $scope.buyCount += 1 ;
            $scope.updateSocial("buyCount",true) ;
            $scope.shopTime = moment().add('M',$scope.pointInfo.obj.productTerm).format('YYYY-MM-DD');
            $scope.isNeedPay = false;
          }
        },function(reason){
          $scope.modal.hide();
          $rootScope.$broadcast("message","请稍后再试！",3000,"alert") ;
        })
    }

    //操作列表页的社交数据
    $scope.updateSocial = function(operType,operation){
      $scope.$emit("social", $stateParams.learnId,$scope.module,operType,operation);
    }

    //分享
    $scope.isShare = false ;
    $scope.share = function(type){
      $scope.isShare = false ;
        for(var i in $rootScope.share_urls){
          if($rootScope.share_urls[i].confKey == "share_learn"){
            //$scope.shareUrl = $scope.share_header+encodeURIComponent($rootScope.share_urls[i].confValue + "?id="+$stateParams.learnId+"&vu="+$scope.vu+"&uu="+$scope.uu)+$scope.share_footer ;
            //$scope.shareUrl = $rootScope.share_urls[i].confValue + "?id="+$stateParams.learnId+"&vu="+$scope.vu+"&uu="+$scope.uu;
            $scope.shareUrl = $rootScope.share_urls[i].confValue.replace("{id}",$stateParams.learnId).replace("{uu}",$scope.uu).replace("{vu}",$scope.vu) ;
          }
        }
        //alert($scope.shareUrl) ;
        //分享参数
        switch(type){
          case 0:
            $scope.scene = Wechat.Scene.SESSION;
            break ;
          case 1:
            $scope.scene = Wechat.Scene.TIMELINE;
            break ;
        }
        Wechat.isInstalled(function (installed) {
          if(installed == "No"){
            $scope.isShare = false ;
            showAlertService.PopAlert("提示信息","请先安装微信再分享","确认","") ;
            return ;
          }else{
            var thumbImg = $scope.learnInfo.dataLearnPic == ""?img.shareImg:$scope.learnInfo.dataLearnPic ;
            Wechat.share({
              message:{
                title: $scope.learnInfo.dataLearnTitle,
                description: $scope.learnInfo.dataLearnDesc==null?"":$scope.learnInfo.dataLearnDesc,
                thumb: thumbImg,
                mediaTagName: "影领-TAG-001",
                messageExt: "影领",
                messageAction: "<action>dotalist</action>",
                media: {
                  type:Wechat.Type.LINK ,
                  webpageUrl:$scope.share_header+encodeURIComponent($scope.shareUrl)+$scope.share_footer
                  //webpageUrl: $scope.shareUrl
                }
              },
              scene: $scope.scene
            }, function () {
              //$cordovaToast.showShortBottom('分享成功') ;
              HomeService.addShareRecord($rootScope.user.id,$stateParams.learnId,3,$scope.shareUrl)
                .then(function(result){
                }) ;
            }, function (reason) {
              //$cordovaToast.showShortBottom('分享失败') ;
            });
          }
        });
    }
    //显示分享
    $scope.showShare = function() {
      if($rootScope.share_urls == null || $rootScope.share_urls == undefined){
        $rootScope.$broadcast('message',"正在获取分享信息，请稍后再试！",3000,"notice");
        UserService.getConfByType('share')
          .then(function(result){
            if(result.success){
              $rootScope.share_urls= result.result ;
            }
          })
        return ;
      }
      $scope.isShare = true ;
    };
    //取消分享
    $scope.cancelShare = function(){
      $scope.isShare = false ;
    }


    /********* 社交功能开始 *********/
    $scope.socialInfo = {};
    // 控制社交功能区展示
    $scope.socialInfo.show = {};
    // 控制社交数值展示
    $scope.socialInfo.text = {};
    // 控制社交图标展示
    $scope.socialInfo.icon = {};

    $scope.socialInfo.show.likeFlag = true;
    $scope.socialInfo.show.storeFlag = true;
    $scope.socialInfo.show.readFlag = true;
    $scope.socialInfo.show.commentFlag = false;

    $scope.socialInfo.init = function(likeNum, storeNum, readNum, commentNum, liked, stored){
      $scope.socialInfo.text.likeNum = likeNum;
      $scope.socialInfo.text.storeNum = storeNum;
      $scope.socialInfo.text.readNum = readNum;
      $scope.socialInfo.text.commentNum = commentNum;
      $scope.socialInfo.icon.liked = liked;
      $scope.socialInfo.icon.stored = stored;
    }

    $scope.socialInfo.like = function(flag){
      if (!flag) {
        // 不支持取消点赞
        return;
      }
      $scope.socialInfo.icon.liked = true;
      $scope.socialInfo.text.likeNum += 1;
      learnService.like($stateParams.learnId, $rootScope.user.id)
        .then(function(result){
          $scope.updateSocial($rootScope.updateSocial.operAgree,$rootScope.updateSocial.operationAdd) ;
        },function(error){
          $scope.socialInfo.icon.liked = false;
          $scope.socialInfo.text.likeNum -= 1;
        })
    }

    $scope.socialInfo.store = function(flag){
      if (!flag) {
        // 不支持取消收藏
        return;
      }
      $scope.socialInfo.icon.stored = true;
      $scope.socialInfo.text.storeNum += 1;
      learnService.store($stateParams.learnId, $rootScope.user.id)
        .then(function(result){
          $scope.updateSocial($rootScope.updateSocial.operStore,$rootScope.updateSocial.operationAdd) ;
        },function(error){
          $scope.socialInfo.icon.stored = false;
          $scope.socialInfo.text.storeNum -= 1;
        })
    }
    /********* 社交功能结束 *********/


    /********* 评论功能开始 *********/
    $scope.comment = {
      comments: [],
      send_content: '',
      reply_head: '',
      expandId: -1,
      carrierId: $stateParams.learnId,
      carrierType: 3,
      complainType: 3,
      isSubmited: true
    };
    $scope.comment.params = {
      hasmore : false,
      from : 1,
      pageSize:3
    };

    $scope.comment.replyModel = {};

    $scope.comment.keyDown = function(e){
      var keyCode = window.event?e.keyCode:e.which;
      // 删除
      if (keyCode == 8){
        //console.log($scope.comment.send_content)
        //console.log($scope.comment.reply_head)
        if ($scope.comment.send_content + ' ' == $scope.comment.reply_head || $scope.comment.send_content == $scope.comment.reply_head){
          $scope.comment.replyModel = {};
          $scope.comment.send_content = '';
          $scope.comment.reply_head = '';
        }
      }
    }

    $scope.comment.submitComment = function(){
      if (!$scope.comment.send_content && !$scope.comment.send_content.trim()){
        return;
      }

      var comment = $scope.comment.send_content.replace($scope.comment.reply_head, '');
      if (!comment && !comment.trim()){
        return;
      }

      $scope.comment.isSubmited = false ;
      $scope.comment.replyModel.carrierId = $scope.comment.carrierId;
      $scope.comment.replyModel.carrierType = $scope.comment.carrierType;
      $scope.comment.replyModel.userId = $rootScope.user.id;
      $scope.comment.replyModel.comment = comment.replace(/\n/g, '<br/>');
      commentService.submitComment($scope.comment.replyModel)
        .then(function(result){
          if (!$scope.comment.replyModel.parentId){
            $scope.comment.flushComment() ;
            $scope.comment.replyModel = {};
          }else{
            commentService.getSubComment($scope.comment.carrierType, $scope.comment.replyModel.parentId)
              .then(function(result){
                for(var i in $scope.comment.comments){
                  if ($scope.comment.comments[i].id == $scope.comment.replyModel.parentId){
                    $scope.comment.comments[i].subComments=$scope.comment.changeImgUrl(result.result);
                    $scope.comment.replyModel = {};
                  }
                }
              })
          }
          $scope.comment.send_content = '';
          $scope.comment.reply_head = '';
        })
        .finally(function(){
          $scope.comment.isSubmited = true ;
        })
    }
    /********* 评论功能结束 *********/
});

//ionic视图的生命周期
//		$ionicview.beforeleave(){
//
//		}
