/**
 * Created by douhao on 2016/10/28.
 */
angular.module('personalInvite-controller',[])
  .controller('personalInviteCtrl',function($scope,$state,UserService,$rootScope,$timeout,HomeService,showAlertService){
    var url = location.href.split('#')[0];
    $scope.qrcode = "" ;
    $scope.isShowShare = false ;
    $scope.getDetail = function(){
        UserService.getPersonaQrcode($rootScope.user.id)
            .then(function(result){
                if(result.code == 0 ){
                    $scope.qrcode = result.result.qrcodeImage.replace("oss","img") ;
                }else{

                }
            },function(reason){

            })
    }
    //获取积分
    $scope.getScore = function(){
        for(var i in $rootScope.scoreRule){
            if($rootScope.scoreRule[i].ruleDetailCode == "invitation"){
                $scope.score = $rootScope.scoreRule[i].ruleDetailScore ;
            }
            if($rootScope.scoreRule[i].ruleDetailCode == "register"){
                $scope.registerScore = $rootScope.scoreRule[i].ruleDetailScore ;
            }
        }
    }
    $scope.getScore() ;

    //显示分享
    $scope.showShare = function() {
      $scope.isShare = true ;
    };
    //取消分享
    $scope.cancelShare = function(){
      $scope.isShare = false ;
    }

    $scope.share = function(type){
      $scope.isShare = false ;
      for(var i in $rootScope.share_urls){
        if($rootScope.share_urls[i].confKey == "share_personal_qrcode"){
          $scope.shareUrl = $rootScope.share_urls[i].confValue.replace("{qrcodeImage}",$scope.qrcode) ;
        }
      }
      //分享参数
      switch(type){
        case 0:
          $scope.scene = Wechat.Scene.SESSION;
          break ;
        case 1:
          $scope.scene = Wechat.Scene.TIMELINE;
          break ;
      }
      Wechat.isInstalled(function (installed) {
        if(installed == "No"){
          $scope.isShare = false ;
          showAlertService.PopAlert("提示信息","请先安装微信再分享","确认","") ;
          return ;
        }else{
          Wechat.share({
            message:{
              title: "注册会员邀请",
              description: "使用我的二维码注册即可获得"+$scope.registerScore+"积分，快来注册吧！",
              thumb: img.shareInviteImg,
              mediaTagName: "影领-TAG-001",
              messageExt: "影领",
              messageAction: "<action>dotalist</action>",
              media: {
                type:Wechat.Type.LINK ,
                webpageUrl:$scope.shareUrl
              }
            },
            scene: $scope.scene
          }, function () {
            HomeService.addShareRecord($rootScope.user.id,$rootScope.user.id,8,$scope.shareUrl)
              .then(function(result){
              }) ;
          }, function (reason) {
          });
        }
      });
    }

    $scope.getDetail() ;
})
