/**
 * Created by douhao on 2016/5/11.
 */
angular.module('retrievePwd-controller',[])
  .controller('RetrievePwdCtrl',function($scope,$state,$ionicScrollDelegate,$interval,UserService,$rootScope,$timeout){
    var viewScroll = $ionicScrollDelegate.$getByHandle('messageDetailsScroll');
    //验证Email是否存在

    $scope.timer = 60 ;
    $scope.isSendCode = false ;
    $scope.isSubmited = false ;
    $scope.phone = "" ;
    //验证码是否通过
    $scope.isCodeChecked = false ;
    $scope.isChecked = false ;
    $scope.updatePwd = {
      'phone':"",
      'code':"",
      'newPassword':"",
      'confirmPwd':""
    },

    //$scope.retrievePwd = function(){
    //
    //}

    $scope.goToBack = function(){
      if($rootScope.isVisible){
        $rootScope.isVisible = false ;
        $rootScope.goToBack() ;
      }else{
        $rootScope.goToBack() ;
      }
    }

    $scope.focusInput = function(){
      $scope.isChecked = false;
    }

    $scope.submitForm = function(myForm) {
        //console.log($scope.user_update) ;
      $scope.isChecked = true ;
      if($scope.myForm.$error.required != undefined && $scope.myForm.$error.required.length > 0){
        for(var i in $scope.myForm.$error.required){
          $scope.myForm.$error.required[i].$dirty = true ;
        }
        return ;
      }
      if($scope.myForm.$error.pattern != undefined && $scope.myForm.$error.pattern.length > 0){
        for(var i in $scope.myForm.$error.pattern){
          $scope.myForm.$error.pattern[i].$dirty = true ;
        }
        return ;
      }

      UserService.getPhoneExist($scope.updatePwd.phone)
        .then(function(result){
          if(result.result){
            $scope.submited = true ;
            $scope.isChecked = false;
            UserService.randomcodeChec($scope.updatePwd.phone,$scope.updatePwd.code)
              .then(function(result){
                if(result.code == 0){
                  $scope.isCodeChecked = true ;
                }else if(result.code == 40021){
                  $scope.submited = false ;
                  $rootScope.$broadcast('message',"无效的验证码！",3000,"alert");
                }
              },function(){
                $scope.submited = false ;
                $rootScope.$broadcast('message',"验证失败，请稍后再试！",3000,"alert");
              })
          }else{
            $scope.myForm.phone.$dirty = true ;
            $scope.myForm.phone.$invalid = true ;
            return ;
          }
        })
    };

    $scope.sendCode = function(){
      $scope.isChecked = true ;
      if($scope.myForm.phone.$error.required || $scope.myForm.$error.pattern){
        $scope.myForm.phone.$dirty = true ;
        return ;
      } ;

      UserService.getPhoneExist($scope.updatePwd.phone)
        .then(function(result){
          if(result.result){
            $scope.isSendCode = true ;
            UserService.sendCode($scope.updatePwd.phone)
              .then(function(result){
                if(result.code == 0){
                  var inter = $interval(function(){
                    $scope.timer -= 1 ;
                    if($scope.timer == 0){
                      $interval.cancel(inter);
                      $scope.timer = 60 ;
                      $scope.isSendCode = false ;
                    }
                  },1000)
                }else{
                  $scope.isSendCode = false ;
                  $rootScope.$broadcast('message',"获取验证码失败，请稍后再试!",3000,"alert");
                }
                $scope.submited = true ;
              },function(reason){
                $scope.isSendCode = false ;
                $scope.submited = true ;
                $rootScope.$broadcast('message',"获取验证码失败，请稍后再试!",3000,"alert");
              })
          }else{
            $scope.myForm.phone.$dirty = true ;
            $scope.myForm.phone.$invalid = true ;
            return ;
          }
        })
    }

    $scope.updatePwd = function(){
      $scope.isChecked = true ;
      if($scope.myForm.$error.required != undefined && $scope.myForm.$error.required.length > 0){
        for(var i in $scope.myForm.$error.required){
          $scope.myForm.$error.required[i].$dirty = true ;
        }
        return ;
      }
      if($scope.myForm.$error.pattern != undefined && $scope.myForm.$error.pattern.length > 0){
        for(var i in $scope.myForm.$error.pattern){
          $scope.myForm.$error.pattern[i].$dirty = true ;
        }
        return ;
      }
      if($scope.updatePwd.newPassword != $scope.updatePwd.confirmPwd){
        return ;
      }
      UserService.updatePhonePassword($scope.updatePwd.phone,$scope.updatePwd.newPassword)
        .then(function(result){
          //$rootScope.goToBack() ;
          if(result.code == 0){
            $rootScope.$broadcast('message',"密码修改成功!",3000,"alert");
            $state.go("signin") ;
          }else{
            $rootScope.$broadcast("message","修改失败,请稍后再试！",3000,"alert") ;
          }
        },function(reason){
          $rootScope.$broadcast("message","修改失败,请稍后再试！",3000,"alert") ;
        })
    }
    //验证手机账号是否存在
    window.addEventListener("native.keyboardshow", function(e){
      viewScroll.scrollBottom();
    });
  });
