/**
 * Created by douhao on 2016/4/6.
 */
angular.module('signin-controller',['ionic'])
  .controller('SignInCtrl',function($scope,$state,$ionicScrollDelegate,UserService,$rootScope,$ionicModal,rongcloudService,innermailService, groupService,showAlertService,$cordovaNetwork,$interval,friendService,appversionService,$cordovaAppVersion,$timeout,$cordovaKeyboard){
    var viewScroll = $ionicScrollDelegate.$getByHandle('messageDetailsScroll');
    $scope.isVisible = false ;
    $scope.isAutoLogin = false ;
    $scope.loginUser = {
      userName:"" ,
      password:""
    }
    $scope.isLogining = false;
    $ionicModal.fromTemplateUrl('templates/diagnose/authority-warn.html', {
      scope: $scope,
      animation: 'slide-in-down'
    }).then(function(modal) {
      $scope.modal = modal;
    });

    //$scope.signIn = function(){
    //  showAlertService.PopConfirm("是否登录","s是否登录","否","是")
    //    .then(function(res) {
    //      if(res) {
    //        console.log('是');
    //      } else {
    //        console.log('否');
    //      }
    //    });
    //}

    $scope.weChatLogin = function(){
      showAlertService.loadingShow() ;
      //微信登录
      var scope = "snsapi_userinfo";
      Wechat.auth(scope, function (response) {
        // you may use response.code to get the access token.
        var code = response.code ;
        UserService.getUnionid(code)
          .then(function(result){
            var accessToken = result.result.access_token ;
            var openid = result.result.openid ;
            var unionid = result.result.unionid ;
            UserService.getUserInfoByUnionid(unionid)
              .then(function(result){
                if(result.code == 0 && !!result.result){
                  showAlertService.loadingHide() ;
                  $rootScope.user = result.result ;
                  //判断手机号码跟手机密码是否存在
                  if(result.result.phoneNumber == null || result.result.phonePsd == null){
                    localStorage.setItem("user", window.btoa(result.result.email));
                    localStorage.setItem("pwd", window.btoa(result.result.emailPsd));
                  }else{
                    localStorage.setItem("user", window.btoa(result.result.phoneNumber));
                    localStorage.setItem("pwd", window.btoa(result.result.phonePsd));
                  }

                  if(!result.result.personalImage){
                    $rootScope.user.personalImage = img.personalImage ;
                  }

                  // 记录访问信息
                  UserService.addAccessSource();

                  //增加登录记录
                  UserService.addLoginRecord() ;

                  // 定期获取好友申请
                  friendService.getFriendApply();
                  $interval(function(){
                    friendService.getFriendApply();
                  }, 1000*60*5);

                  $state.go('menu.tab.homepage') ;

                  // 初始化rongCloud
                  rongcloudService.getToken($rootScope.user.id)
                    .then(function(result){
                      rongcloudService.init(result.result.appKey, result.result.token);
                      groupService.getGroupsByUserid($rootScope.user.id, '')
                        .then(function(result){
                          var groups = {};
                          groups.groups = [];
                          if (result.code == 0){
                            for(var i in result.result){
                              var group = {id: result.result[i].id, name: result.result[i].name, portraitUrl: !!result.result[i].picture ? result.result[i].picture : img.personalImage};
                              groups.groups.push(group);
                            }
                          }

                          if (groups.groups.length > 0){
                            rongcloudService.syncGroup(groups);
                          }
                        })
                    })
                }else{
                    UserService.getWeChatUserInfo(accessToken,openid)
                      .then(function(result){
                        showAlertService.loadingHide() ;
                        var weChatUserInfo = result.result ;
                        $state.go("bound",{"weChatUserInfo":weChatUserInfo}) ;
                      },function(response){
                        showAlertService.loadingHide() ;
                        showAlertService.PopAlert("提示信息","获取信息失败，请稍后再试!","确认","") ;
                    })
                }
              },function(response){
                showAlertService.loadingHide() ;
                showAlertService.PopAlert("提示信息","获取个人信息失败，请稍后再试!","确认","") ;
              })
          },function(reasonUnionid){
            showAlertService.loadingHide() ;
            showAlertService.PopAlert("提示信息","获取信息失败，请稍后再试!","确认","") ;
          })
      }, function (response) {
        showAlertService.loadingHide() ;
      });
    }

    $scope.focusInput = function(){
      $scope.isChecked = false;
    }

    $scope.signIn = function(){
      $scope.isChecked = true ;
      if($scope.mySignForm != undefined && !$scope.isAutoLogin){
        if($scope.mySignForm.$error.required != undefined && $scope.mySignForm.$error.required.length > 0){
          for(var i in $scope.mySignForm.$error.required){
            $scope.mySignForm.$error.required[i].$dirty = true ;
          }
          return ;
        }
        if($scope.mySignForm.$error.pattern != undefined && $scope.mySignForm.$error.pattern.length > 0){
          for(var i in $scope.mySignForm.$error.pattern){
            $scope.mySignForm.$error.pattern[i].$dirty = true ;
          }
          return ;
        }
      }
      showAlertService.loadingShow();
      $scope.isLogining = true ;
      console.log($scope.loginUser.userName) ;

      //localStorageService.set("userName",user.userName) ;
      UserService.login($scope.loginUser)
        .then(function(result){
          $scope.isLogining = false ;
          if(result.code != 0){
            showAlertService.loadingHide();
            if(localStorage.getItem("user") != null && localStorage.getItem("user") != ""){
              localStorage.setItem("user", "");
              localStorage.setItem("pwd", "");
              $scope.isVisible = true  ;
              $scope.isLogining = false ;
              $state.go("signin") ;
            }else{
              switch (result.code){
                case 40015:
                  showAlertService.PopConfirm("登录失败","用户名或密码有误，是否找回密码?","取消","找回密码")
                    .then(function(res) {
                      if(res) {
                        $state.go("retrievePwd") ;
                      } else {
                      }
                    });
                  break ;
              }
            }
            //$rootScope.$broadcast("error") ;
          }else{
            showAlertService.loadingHide();
            //$rootScope.user.userId = result.id ;
            //$rootScope.user.userName = result.name ;
            //保存信息
            //判断手机号码跟手机密码是否存在
            if(result.result.phoneNumber == null || result.result.phonePsd == null){
              localStorage.setItem("user", window.btoa(result.result.email));
              localStorage.setItem("pwd", window.btoa(result.result.emailPsd));
            }else{
              localStorage.setItem("user", window.btoa(result.result.phoneNumber));
              localStorage.setItem("pwd", window.btoa(result.result.phonePsd));
            }

            $rootScope.user = result.result ;
            //sessionStorage.user = result

            // 版本更新判断
            $cordovaAppVersion.getVersionNumber().then(function(version) {
              appversionService.setUserAppVersion($rootScope.user.id,version);
            });

            if(!result.result.personalImage){
              $rootScope.user.personalImage = img.personalImage ;
            }

            //友盟登录统计
            MobclickAgent.profileSignInWithPUID($rootScope.user.id) ;
            // 记录访问信息
            UserService.addAccessSource();

            //增加登录记录
            UserService.addLoginRecord() ;

            // 定期获取好友申请
            friendService.getFriendApply();
            $interval(function(){
              friendService.getFriendApply();
            }, 1000*60);

            $state.go('menu.tab.homepage') ;

            // 初始化rongCloud
            rongcloudService.getToken($rootScope.user.id)
              .then(function(result){
                rongcloudService.init(result.result.appKey, result.result.token);
                groupService.getGroupsByUserid($rootScope.user.id, '')
                  .then(function(result){
                    var groups = {};
                    groups.groups = [];
                    if (result.code == 0){
                      for(var i in result.result){
                        var group = {id: result.result[i].id, name: result.result[i].name, portraitUrl: !!result.result[i].picture ? result.result[i].picture : img.personalImage};
                        groups.groups.push(group);
                      }
                    }

                    if (groups.groups.length > 0){
                      rongcloudService.syncGroup(groups);
                    }
                  })
              })

          }
      },function(result){
          showAlertService.loadingHide();
          $rootScope.$broadcast("message","网络连接失败,请稍后再试！",3000,"alert") ;
          $scope.isLogining = false ;
          if(localStorage.getItem("user") != null && localStorage.getItem("user") != ""){
            localStorage.setItem("user", "");
            localStorage.setItem("pwd", "");
            $scope.isVisible = true  ;
            $state.go("signin") ;
          }
        })
    }

    $scope.autoLogin = function(){
      if(localStorage.getItem("user") != null && localStorage.getItem("user") != ""){
        $scope.loginUser.userName = window.atob(localStorage.getItem("user"));
        $scope.loginUser.password = window.atob(localStorage.getItem("pwd"));
        //alert("$rootScope.isOnline="+$rootScope.isOnline) ;
        $scope.isAutoLogin = true ;
        $scope.signIn() ;


        //if($rootScope.isOnline){
        //  $scope.signIn() ;
        //}else{
        //  $state.go("menu.tab.cases") ;
        //}

      }else{
        $scope.isVisible = true  ;
      }
    }

    document.addEventListener("deviceready", function () {

      var type = $cordovaNetwork.getNetwork();

      var isOnline = $cordovaNetwork.isOnline();

      var isOffline = $cordovaNetwork.isOffline();
      if(isOnline){
        $scope.autoLogin() ;
      }else{
        $scope.isVisible = true  ;
      }
    }, false);

    $scope.toRegister = function(){
      $timeout(function(){
        $state.go("register") ;
      },20)
    }

    $scope.$on('$ionicView.afterEnter', function() {
      $cordovaKeyboard.close();
    }, false);
     //$scope.autoLogin();

    window.addEventListener("native.keyboardshow", function(e){
      viewScroll.scrollBottom();
    });
});

