/**
 * Created by douhao on 2016/4/18.
 */
angular.module('resizeFootBarDirective', [])

  .directive('resizeFootBar', ['$ionicScrollDelegate', function($ionicScrollDelegate){
    // Runs during compile
    return {
      replace: false,
      link: function(scope, iElm, iAttrs, controller) {
        scope.$on("taResize", function(e, ta) {
          if (!ta) return;
          var scroll = document.body.querySelector("#message-detail-content");
          var scrollBar = $ionicScrollDelegate.$getByHandle('messageDetailsScroll');
          // console.log(scroll);
          var taHeight = ta[0].offsetHeight;
          var newFooterHeight = taHeight + 10;
          newFooterHeight = (newFooterHeight > 44) ? newFooterHeight : 44
          iElm[0].style.height = newFooterHeight + 'px';
          scroll.style.bottom = newFooterHeight + 'px';
          scrollBar.scrollBottom();
        });
      }
    };
  }])
