/**
 * Created by douhao on 2016/6/24.
 */
angular.module('showAlert-service',[])
  .factory('showAlertService',function($ionicPopup,$ionicLoading,$timeout,$http,$q) {
    return {
      //查找所有
      PopAlert: function (t,c,b,type) {
        var alertPopup = $ionicPopup.alert({
          buttons:[{ text: b ,type: 'button-positive'}],
          //title: t,
          template: c
        });
        return alertPopup ;
      },
      PopConfirm:function(title,content,cancel,ok){
        return $ionicPopup.confirm({
          //title: title,
          template: content,
          cancelText: cancel, // String (默认: 'Cancel')。一个取消按钮的文字。
          cancelType: '', // String (默认: 'button-default')。取消按钮的类型。
          okText: ok, // String (默认: 'OK')。OK按钮的文字。
          okType: '', // String (默认: 'button-positive')。OK按钮的类型。
        })
      },
      PopShow: function(title,content,time){
        var myPopup = $ionicPopup.show({
          template: '',
          //title: title,
          subTitle: content,
          //scope: $scope,
        });
        $timeout(function() {
          myPopup.close(); // 3秒后关闭弹窗
        }, time);
      },
      loadingShow:function(){
        $ionicLoading.show({
          template: '<ion-spinner icon="lines" class="spinner-calm"></ion-spinner>'
        });
      },
      loadingHide:function(){
        $ionicLoading.hide();
      }
    }
  })
