angular.module('userConfig-service',[])
  .factory('UserConfigService',function($http,$q) {
    return {
      getUserConfigs: function (userId) {
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url + "/userconfig/"+userId
        }).success(function (data, status, headers, config) {
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          q.reject(data);
        });
        return q.promise;
      },

      updateUserConfigs:function(userConfig){
        var q = $q.defer();
        $http({
          method: 'PUT',
          url: config.new_url+"/userconfig",
          data:userConfig
        }).success(function (data, status, headers, config) {
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          q.reject(data);
        });
        return q.promise;
      }
    }
  })
