/**
 * Created by douhao on 2016/4/6.
 */
angular.module('case-controller',['ionic'])
  .controller('CaseCtrl',function($scope,$rootScope,$state,caseService,deviceService,$ionicPopover,UserService,$ionicModal,$timeout,innermailService,rongcloudService,$ionicHistory,groupService,showAlertService,HomeService,$ionicScrollDelegate){
    $scope.isActive = localStorage.getItem("cookieEquipmentType")==null?0:localStorage.getItem("cookieEquipmentType") ;
    if(ionic.Platform.isIOS()){
      $scope.topStyle = {top:'100px'};
    }else{
      $scope.topStyle = {top:'80px'};
    }

    $scope.caseTypeOne = "瀑布流视图";
    $scope.caseTypeTwo = "列表视图";
    showAlertService.loadingShow();

    $scope.equipemntParams = "" ;
    $scope.isShowSelection = {
      type:false,
      sort:false,
      show:false
    }
    $scope.tilesFlag = (localStorage.getItem("tilesFlag") == null) ? 0 : localStorage.getItem("tilesFlag");
    $scope.changeTilesFlag = function(tilesFlag){
      //$scope.showmodal.hide();
      $scope.isShowSelection.show = false ;
      if ($scope.tilesFlag == tilesFlag){
        return;
      }

      $timeout(function(){
        $scope.tilesFlag = tilesFlag;
        localStorage.setItem("tilesFlag", tilesFlag);
        $scope.cases = [];
        $ionicScrollDelegate.scrollTop();
        $scope.doRefresh();
      }, 100)
    }

    $scope.order = (localStorage.getItem("order") == null) ? 0 : localStorage.getItem("order");
    $scope.bodyPartIsActive = [] ;
    $scope.equipmenIsActive = [] ;
    $scope.params = {
      hasmore : true ,
      current : 1 ,
      pageSize : 10,
    }
    //alert("case-$rootScope.isOnLine  ="+$rootScope.isOnLine) ;
    $scope.module = "case" ;
    $scope.img_url = img.case_url ;
    $scope.cases = [];
    $scope.bodyPartsNames = [] ;
    $scope.equipmentNames = [] ;
    $scope.isSelBody = true ;
    $scope.isSelEquipment = true ;
    $scope.selectEquipNames = (localStorage.getItem("cookieEquipmentName") == null) ? "":localStorage.getItem("cookieEquipmentName") ;
    $scope.selectBodyNames = (localStorage.getItem("cookieBodyName") == null) ? "":localStorage.getItem("cookieBodyName") ;
    //更改图片路径
    $scope.changeImgUrl = function(list){
      var img_path = "/jpeg" ;
      for(var i in list.thumbnails){
        if(!list.thumbnails[i]){
          list.thumbnails[i] = "img/study/no_learn.png";
        }else{
          if(list.thumbnails[i].substr(0,7)!="http://" && list.thumbnails[i].substr(0,8)!="https://"){
            list.thumbnails[i] = $scope.img_url +"/" +list.id +img_path +"/"+list.thumbnails[i] ;
          }else{
            list.thumbnails[i] = list.thumbnails[i] ;
          }
        }
      }
      return list;
    }

    //初始化筛选选项条件
    deviceService.findDeviceType()
      .then(function(result){
        $scope.bodyPartsNames = result.result.bodysystems ;

        for(var i in $scope.bodyPartsNames){
          if($scope.selectBodyNames.indexOf($scope.bodyPartsNames[i].code) != -1){
            $scope.bodyPartIsActive.push(true) ;
            $scope.isSelBody = false ;
          }else{
            $scope.bodyPartIsActive.push(false) ;
          }
        }

        $scope.equipmentNames = result.result.equipments ;
        for(var i in $scope.equipmentNames) {
            if ($scope.equipmentNames[i].dpTag == $scope.isActive) {
              $scope.equipemntParams += $scope.equipmentNames[i].code + ",";
            }
          }
        $scope.equipemntParams = $scope.equipemntParams.substring(0,$scope.equipemntParams.length-1) ;
        //$scope.params.hasmore = true ;
        for(var i in $scope.equipmentNames){
          if($scope.selectEquipNames.indexOf($scope.equipmentNames[i].code) != -1){
            $scope.equipmenIsActive.push(true) ;
            $scope.isSelEquipment = false ;
          }else{
            $scope.equipmenIsActive.push(false) ;
          }
        }
          $scope.toSlideTitle($scope.isActive) ;
          //$scope.equipemntParams = $scope.selectEquipNames==""?$scope.equipemntParams:$scope.selectEquipNames ;
      })

    $scope.doRefresh = function() {
      $scope.$broadcast("scroll.infiniteScrollComplete");
      $scope.hiden = true ;
      //瀑布流图片加载完数量
      $scope.imgLoadedCount = 0 ;
      caseService.findCaseAll(0,$scope.isActive,1,$scope.params.pageSize,$scope.equipemntParams,$scope.selectBodyNames,$scope.order)
        .then(function(result) {
          $scope.hiden = false ;
          var caseIds = "" ;
          $scope.params = {
            hasmore : true ,
            current : 1 ,
            pageSize : 10,
          }
          for(var i in result.result.objects){
            result.result.objects[i] = $scope.changeImgUrl(result.result.objects[i]);
            caseIds += result.result.objects[i].caseId +",";
          }
          if($scope.params.current >= result.result.pageTotal){
            $scope.params.hasmore = false ;
          }else{
            $scope.params.current ++ ;
          }
          $scope.cases = result.result.objects;

          if($rootScope.user.id > 0){
            //判断是否是已阅读
            caseService.answeredcases($rootScope.user.id,caseIds)
              .then(function(resu){
                if(resu.code == 0){
                  for(var i in $scope.cases){
                    if(resu.result.indexOf($scope.cases[i].caseId) != -1){
                      $scope.cases[i].isAnswer = true ;
                    }
                  }
                }
              })
          }
            $scope.$broadcast('scroll.refreshComplete');
        })
        .finally(function () {
          showAlertService.loadingHide();
          $scope.$broadcast('scroll.refreshComplete');
        });
    };

    $scope.loadMore = function(){
      caseService.findCaseAll(0,$scope.isActive,$scope.params.current,$scope.params.pageSize,$scope.equipemntParams,$scope.selectBodyNames,$scope.order)
        .then(function(result) {
          var caseIds = "" ;
          for(var i in result.result.objects){
            result.result.objects[i] = $scope.changeImgUrl(result.result.objects[i]);
            caseIds += result.result.objects[i].caseId +",";
          }
          $scope.cases = $scope.cases.concat(result.result.objects);

          //当前页等于总页数时，禁止加载更多
          if($scope.params.current >= result.result.pageTotal){
            $scope.params.hasmore = false ;
          }else{
            $scope.params.current ++ ;
          }

          if($rootScope.user.id > 0){
            //判断是否是已阅读
            caseService.answeredcases($rootScope.user.id,caseIds)
              .then(function(resu){
                if(resu.code == 0){
                  for(var i in $scope.cases){
                    if(resu.result.indexOf($scope.cases[i].caseId) != -1){
                      $scope.cases[i].isAnswer = true ;
                    }
                  }
                }
              })
          }
        },function(reason){
          $scope.$broadcast("scroll.infiniteScrollComplete");
        })
        .finally(function () {
          showAlertService.loadingHide();
          //$scope.$broadcast("scroll.infiniteScrollComplete");
        });
    };

    $scope.imgLoadedCount = 0 ;
    window.imageLoaded = function(img){
      tailsImageLoaded(img,$scope.imgLoadedCount) ;
      var index = parseInt(img.getAttribute('index'));
      if($scope.imgLoadedCount >= ($scope.cases.length - 1)){
        $scope.$broadcast("scroll.infiniteScrollComplete");
      }
      $scope.imgLoadedCount ++ ;
    }

    //修改社交信息
    //$scope.$on('social', function(e, id) {
    //  console.log("add") ;
    //  //for(var caseInfo in $scope.cases){
    //  //  if(caseInfo.id == id){
    //  //    caseInfo.agreeNum = caseInfo.agreeNum + 1;
    //  //  }
    //  //}
    //});

    //更新社交数据
    $rootScope.$on('socialOper', function(e,id,module,operType,operation) {
      if(module == $scope.module){
        for(var i in $scope.cases){
          if($scope.cases[i].caseId == id){
            if(operation){
              $scope.cases[i][operType] ++;
            }else{
              $scope.cases[i][operType] --;
            }
          }
        }
      }
    });

    //页面加载完判断是否是从注册页面跳转过来，如果是为新用户注册，提醒用户完善个人信息
    $scope.$on('$ionicView.loaded', function() {
      if (!(localStorage.getItem("explainImg") == null || localStorage.getItem("explainImg") == "" || localStorage.getItem("explainImg") == undefined)) {
        if ($ionicHistory.viewHistory().backView && $ionicHistory.viewHistory().backView.stateId == "register") {
          showAlertService.PopConfirm("提示信息", "您现在希望去个人中心完善信息吗？", "取消", "完善")
            .then(function (res) {
              if (res) {
                $state.go("menu.personalCenter");
              } else {
              }
            });
        }
      }
    });
    $scope.toSlideTitle = function(index){
      $scope.isActive = index == 0 ?0:1;
      $scope.equipemntParams = "" ;
      for(var i in $scope.equipmentNames) {
        if (parseInt($scope.equipmentNames[i].dpTag) == $scope.isActive) {
          if($scope.equipmenIsActive[i] == true){
            $scope.equipemntParams += $scope.equipmentNames[i].code + ",";
          }
        }
      }
      //如果没有选中的设备，将设备选为不限，equipemntParams 为所选的所有的设备。
      if($scope.equipemntParams == "") {
        for (var i in $scope.equipmentNames) {
          if (parseInt($scope.equipmentNames[i].dpTag) == $scope.isActive) {
            $scope.equipemntParams += $scope.equipmentNames[i].code + ",";
          }
        }
        $scope.isSelEquipment = true ;
      }else{
        $scope.isSelEquipment = false ;
      }
      $scope.equipemntParams = $scope.equipemntParams.substring(0,$scope.equipemntParams.length-1) ;
      localStorage.setItem("cookieEquipmentType", $scope.isActive);
      $scope.comfirmSelectedBodyPart() ;
    }


    //分类查询设备按钮
    $scope.isSelectedEquipmen = function(index){
      if(index == -1){
        $scope.isSelEquipment = $scope.isSelEquipment?false:true ;
        $scope.equipemntParams = "" ;
        $scope.selectEquipNames = "" ;
        //如果选择了 "不限" 将其他都置为false;
        if($scope.isSelEquipment){
          for(var i in $scope.equipmenIsActive){
            if(parseInt($scope.equipmentNames[i].dpTag) == $scope.isActive){
              $scope.equipmenIsActive[i] = false ;
            }else if($scope.equipmenIsActive[i] == true){
              $scope.selectEquipNames +=$scope.equipmentNames[i].code + ",";
            }
          }
          $scope.selectEquipNames = $scope.selectEquipNames.substring(0,$scope.selectEquipNames.length-1) ;
        }
      }else{
        $scope.equipmenIsActive[index] = $scope.equipmenIsActive[index]?false:true ;
        //如果有一个被选择，将"不限"置为false ;
        $scope.selectEquipNames = "" ;
        $scope.equipemntParams = "" ;
        for(var i in $scope.equipmenIsActive){
          if($scope.equipmenIsActive[i] == true){
            $scope.selectEquipNames += $scope.equipmentNames[i].code + ",";
            if (parseInt($scope.equipmentNames[i].dpTag) == $scope.isActive) {
              $scope.equipemntParams += $scope.equipmentNames[i].code + ",";
            }
          }
        }
        $scope.selectEquipNames = $scope.selectEquipNames.substring(0,$scope.selectEquipNames.length-1) ;
        $scope.equipemntParams = $scope.equipemntParams.substring(0,$scope.equipemntParams.length-1) ;
      }

      if($scope.equipemntParams == ""){
        $scope.isSelEquipment = true ;
        for(var i in $scope.equipmentNames) {
          if (parseInt($scope.equipmentNames[i].dpTag) == $scope.isActive) {
            $scope.equipemntParams += $scope.equipmentNames[i].code + ",";
          }
        }
        $scope.equipemntParams = $scope.equipemntParams.substring(0,$scope.equipemntParams.length-1) ;
      }else{
        $scope.isSelEquipment = false ;
      }

      localStorage.setItem("cookieEquipmentName", $scope.selectEquipNames);
    }
    //分类查询部位按钮
    $scope.isSelectedBodyPart = function(index){
      if(index == -1){
        $scope.isSelBody = $scope.isSelBody?false:true ;
        //如果选择了 "不限" 将其他都置为false;
        if($scope.isSelBody){
          for(var i in $scope.bodyPartIsActive){
            $scope.bodyPartIsActive[i] = false ;
          }
        }
        $scope.selectBodyNames = "" ;
      }else{
        $scope.bodyPartIsActive[index] = $scope.bodyPartIsActive[index]?false:true ;
        //如果有一个被选择，将"不限"置为false ;
        $scope.selectBodyNames = "" ;
        for(var i in $scope.bodyPartIsActive){
          if($scope.bodyPartIsActive[i] == true){
            $scope.selectBodyNames += $scope.bodyPartsNames[i].code + ",";
          }
        }
        $scope.selectBodyNames = $scope.selectBodyNames.substring(0,$scope.selectBodyNames.length-1) ;
      }

      if($scope.selectBodyNames == ""){
        $scope.isSelBody = true ;
      }else{
        $scope.isSelBody = false ;
      }
      localStorage.setItem("cookieBodyName", $scope.selectBodyNames);
    }

    $scope.goToCaseDetail = function(id){
      $state.go("menu.case-detail",{'caseId': id}) ;
    }

    // 当隐藏的模型时执行动作
    //$scope.$on('modal.hidden', function(m) {
    //  console.log(m)
    //  //筛选
    //  $scope.params.hasmore = true ;
    //  $scope.params.current = 2;
    //  $timeout(function() {
    //    $scope.doRefresh() ;
    //  }, 300);
    //});

    $ionicModal.fromTemplateUrl('templates/case/typeModal.html', {
      scope: $scope,
      animation: 'slide-in-none'
    }).then(function(modal) {
      $scope.typemodal = modal;
    });
    $ionicModal.fromTemplateUrl('templates/case/sortModal.html', {
      scope: $scope,
      animation: 'slide-in-none'
    }).then(function(modal) {
      $scope.sortmodal = modal;
    });
    $ionicModal.fromTemplateUrl('templates/case/showModal.html', {
      scope: $scope,
      animation: 'slide-in-none'
    }).then(function(modal) {
      $scope.showmodal = modal;
    });

    //$scope.showTypeModal = function(){
    //  $scope.typemodal.show() ;
    //}
    $scope.showTypeModal = function(){
      $scope.isShowSelection.type =  !$scope.isShowSelection.type ;
      $scope.isShowSelection.sort =  false ;
      $scope.isShowSelection.show =  false ;
    }
    //$scope.showSortModal = function(){
    //  $scope.sortmodal.show() ;
    //}
    $scope.showSortModal = function(){
      $scope.isShowSelection.sort =  !$scope.isShowSelection.sort ;
      $scope.isShowSelection.show =  false;
      $scope.isShowSelection.type =  false ;
    }
    //$scope.showShowModal = function(){
    //  $scope.showmodal.show() ;
    //}
    $scope.showShowModal = function(){
      $scope.isShowSelection.show =  !$scope.isShowSelection.show ;
      $scope.isShowSelection.type =  false ;
      $scope.isShowSelection.sort =  false ;
    }

    $scope.resetSelectedBodyPart = function(){
      $scope.isSelBody = true ;
      $scope.isSelEquipment = true;
      for(var i in $scope.bodyPartIsActive){
        $scope.bodyPartIsActive[i] = false ;
      }
      for(var i in $scope.equipmenIsActive){
        $scope.equipmenIsActive[i] = false ;
      }
      $scope.selectBodyNames = "" ;
      $scope.selectEquipNames = "";
      $scope.equipemntParams = "" ;
      for(var i in $scope.equipmentNames) {
        if (parseInt($scope.equipmentNames[i].dpTag) == $scope.isActive) {
          $scope.equipemntParams += $scope.equipmentNames[i].code + ",";
        }
      }
      $scope.equipemntParams = $scope.equipemntParams.substring(0,$scope.equipemntParams.length-1) ;
    }


    $scope.comfirmSelectedBodyPart = function(){
      $scope.isShowSelection.type = false ;
      localStorage.setItem("cookieEquipmentName", $scope.selectEquipNames);
      localStorage.setItem("cookieBodyName", $scope.selectBodyNames);
      $scope.doRefresh();
    }

    $scope.changeSort = function(sort){

      if ($scope.order != sort){
        $timeout(function(){
          $scope.order = sort;
          localStorage.setItem("order", sort);
          $scope.doRefresh();
          $scope.isShowSelection.sort = false ;
        }, 100)
      }
    }
  });

