angular.module('groupUpdate-controller',[])
  .controller('groupUpdateCtrl',function($scope,$rootScope,$state,$stateParams,showAlertService,UserService,groupService){
    $scope.type = $stateParams.type;
    $scope.group = {};

    $scope.init = function(){
      groupService.getGroupById($stateParams.groupId)
        .then(function(result) {
          $scope.group = result.result;
        })
    }
    $scope.init();

    $scope.updateAnnouncement = function(){
      // if ($rootScope.user.id != $scope.group.manageUserid){
      //   showAlertService.PopAlert("提示信息","只有管理员可以修改","确认","") ;
      //   return;
      // }

      if (!$scope.group.announcement){
        showAlertService.PopAlert("提示信息","群公告不能为空","确认","") ;
        return;
      }

      showAlertService.PopConfirm("提示信息","该公告会通知全部群成员，是否发布?","取消","发布")
        .then(function(res) {
          if(res) {
            groupService.updateAnnouncement($scope.group.id, $scope.group.announcement)
              .then(function(result) {
                RongCloudLibPlugin.sendTextMessage({
                    conversationType: 'GROUP',
                    targetId: $scope.group.id.toString(),
                    text: '@所有人\r\n'+$scope.group.announcement,
                    extra:new Date().getTime() + ' | ' + $rootScope.user.nickName + ' | -1'
                  },
                  function(ret, err) {
                    if (ret) {
                      if (ret.status == "prepare") {
                        $rootScope.appendNewMsg(ret.result.message);
                      }
                    }
                  }
                );
                $rootScope.goToBack();
              })
          } else {
          }
        });
    }
  })
