/**
 * Created by douhao on 2016/12/6.
 */
angular.module('homepageDetail-controller',[])
  .controller('HomepageDetailCtrl',function($scope,UserService,$stateParams,$rootScope,$state,HomePageService,$ionicModal,$sce,showAlertService,$timeout,HomeService,$ionicSlideBoxDelegate,$ionicGesture){
    $scope.content = $stateParams.content ;
    $scope.type = $stateParams.type;
    $scope.detail = "" ;
    $scope.timerAlert ;
    $scope.isLoadingIframe = true ;
    $scope.module = "homepage" ;
    $scope.loadTimtOut = 36000 ;

    $ionicModal.fromTemplateUrl('templates/homepage/detail-modal.html', {
      scope: $scope,
      animation: 'slide-in-none'
    }).then(function(modal) {
      $scope.iframeModal = modal;
      $scope.getdetail() ;
      $scope.initIframe() ;
    });

    $scope.hrefAddEvent = function(){
      $timeout(function(){
        $scope.pptImgList = document.getElementById("homeDetail").getElementsByTagName("img") ;
        $('.ng-binding a').click(function(event){
          goUrl = event.target.href ;
          $scope.vm = {
            paySrc:goUrl,
          }
          if (goUrl.includes('weixin.qq.com')){
            $.ajax({
              crossOrigin: true,
              url: goUrl,
              success: function(data) {
                data = data.replace(/data-src/g, "src");
                //var sourceHtml =  $sce.trustAsHtml(data);
                var sourceHtml = 'data:text/html;charset=utf-8,' + data;
                $("#homepageIframe").attr("src" , sourceHtml);
              }
            });
          }else{
            $scope.vm.paySrc = $sce.trustAsResourceUrl(goUrl);
          }
          $ionicModal.fromTemplateUrl('templates/homepage/detail-modal.html', {
            scope: $scope,
            animation: 'slide-in-none'
          }).then(function(modal) {
            $scope.iframeModal = modal ;
            $scope.iframeModal.show() ;
          })
          event.preventDefault();
        })
        $('.ng-binding img').click(function(event){
          $scope.openOverScreen(event.currentTarget.src) ;
        });
      },500) ;
    }

    $scope.getdetail = function(){
      $scope.vm = {}
      $scope.detail = "" ;
      $scope.isLoadingIframe = true ;
      var goUrl = "" ;
      if($scope.content.contentType == 1){
        goUrl = $scope.content.contentUrl ;

        if (goUrl.includes('weixin.qq.com')){
          $.ajax({
            crossOrigin: true,
            url: goUrl,
            success: function(data) {
              data = data.replace(/data-src/g, "src");
              //var sourceHtml =  $sce.trustAsHtml(data);
              var sourceHtml = 'data:text/html;charset=utf-8,' + data;
              $("#homepageIframe").attr("src" , sourceHtml);
            }
          });
        }else{
          $scope.vm.paySrc = $sce.trustAsResourceUrl(goUrl);
        }

        $scope.iframeModal.show() ;
        $scope.timerAlert = $timeout(function(){
          if($scope.isLoadingIframe){
            $rootScope.$broadcast("message","网络比较缓慢，请稍后再试！",3000,"alert") ;
          }
        },$scope.loadTimtOut) ;
      }else if($scope.content.contentType == 2) {
        goUrl = $scope.content.contentH5url ;
        HomePageService.getNewContents(goUrl)
          .then(function(result){
            $scope.detail = $sce.trustAsHtml(result) ;
            $scope.hrefAddEvent() ;
          })
      }
      if($rootScope.user.id > 0 && $scope.type > 0){
        HomePageService.addReadRecord($scope.type,$scope.content.id,$rootScope.user.id)
          .then(function(result){
            $scope.updateSocial($rootScope.updateSocial.operRead,$rootScope.updateSocial.operationAdd);
          },function(reason){
          }) ;
      }
    }

    //操作列表页的社交数据
    $scope.updateSocial = function(operType,operation){
      if($scope.type == 2){
        $scope.$emit("social", $scope.content.id,$scope.module,operType,operation);
      }
    }

    $scope.closeModal = function(){
      if($scope.content.contentType == 1){
        $rootScope.goToBack() ;
      }
      $timeout.cancel($scope.timerAlert) ;
      if(document.getElementById("homepageIframe").contentWindow){
        var textAreas = document.getElementById("homepageIframe").contentWindow.document.getElementsByTagName("textarea") ;
        var textInputs = document.getElementById("homepageIframe").contentWindow.document.getElementsByTagName("input") ;
        for(var i = 0 ; i < textAreas.length ; i ++){
          textAreas[i].blur() ;
        }
        for(var i = 0 ; i < textInputs.length ; i ++){
          textInputs[i].blur() ;
        }
      }

      $timeout(function(){
        $scope.iframeModal.remove() ;
      },100) ;
    }

    /**分享**/
    $scope.isShare = false ;
    $scope.share = function(type){
      $scope.isShare = false ;
      for (var i in $rootScope.share_urls) {
        if ($scope.type == 1 && $rootScope.share_urls[i].confKey == "share_ad") {
          $scope.shareUrl = $rootScope.share_urls[i].confValue.replace("{id}", $scope.content.id);
        }
        if ($scope.type == 2 && $rootScope.share_urls[i].confKey == "share_news") {
          $scope.shareUrl = $rootScope.share_urls[i].confValue.replace("{id}", $scope.content.id);
        }
      }
      var shareImg = img.shareImg ;
      if($scope.content.imageUrl != undefined) {
        shareImg = $scope.content.imageUrl ;
        if(shareImg.indexOf("@") != -1){
          shareImg = shareImg.split("@")[0] + "@120w_120h_4e_0-0-0bgc_1o";
        }else{
          shareImg = shareImg.replace("oss","img") ;
          shareImg = shareImg.split("@")[0] + "@120w_120h_4e_0-0-0bgc_1o";
        }
      }

      //分享参数
      switch (type) {
        case 0:
          $scope.scene = Wechat.Scene.SESSION;
          break;
        case 1:
          $scope.scene = Wechat.Scene.TIMELINE;
          break;
      }
      Wechat.isInstalled(function (installed) {
        if (installed == "No") {
          $scope.isShare = false;
          showAlertService.PopAlert("提示信息", "请先安装微信再分享", "确认", "");
          return;
        } else {
          Wechat.share({
            message: {
              title: $scope.content.title,
              description: $scope.content.desc==null?"":$scope.content.desc,
              thumb: shareImg,
              mediaTagName: "yinglink-TAG-001",
              messageExt: "",
              messageAction: "<action>dotalist</action>",
              media: {
                type: Wechat.Type.LINK,
                webpageUrl: $scope.shareUrl
                //webpageUrl: $scope.shareUrl
              }
            },
            scene: $scope.scene
          }, function () {
            //$cordovaToast.showShortBottom('分享成功') ;
            //showAlertService.PopShow("提示信息","分享成功",1000) ;
            if ($scope.type == 1) {
              HomeService.addShareRecord($rootScope.user.id, $scope.content.id, 9, $scope.shareUrl)
                .then(function (result) {
                });
            } else if($scope.type == 2) {
              HomeService.addShareRecord($rootScope.user.id, $scope.content.id, 10, $scope.shareUrl)
                .then(function (result) {
                });
            }
          }, function (reason) {
            //$cordovaToast.showShortBottom('分享失败') ;
            //showAlertService.PopShow("提示信息","分享失败",1000) ;
          });
        }
      });
    }
    //显示分享
    $scope.showShare = function() {
      if($rootScope.share_urls == null || $rootScope.share_urls == undefined){
        $rootScope.$broadcast('message',"正在获取分享信息，请稍后再试！",3000,"notice");
        UserService.getConfByType('share')
          .then(function(result){
            if(result.success){
              $rootScope.share_urls= result.result ;
            }
          })
        return ;
      }
      $scope.isShare = true ;
    };
    //取消分享
    $scope.cancelShare = function(){
      $scope.isShare = false ;
    }
    /**分享end**/

    $scope.initIframe = function(){
      $scope.$on('$ionicView.afterEnter', function() {
        if($scope.content.contentType == 1){
          var homepageIframe = document.getElementById("homepageIframe");
          if(homepageIframe.attachEvent) {
            homepageIframe.attachEvent("onload", function () {
              $scope.isLoadingIframe = false ;
              $timeout.cancel($scope.timerAlert) ;
            });
          }else {
            homepageIframe.onload = function () {
              $scope.isLoadingIframe = false ;
              $timeout.cancel($scope.timerAlert) ;
            };
          }
        }
        if($scope.content.contentType == 2){
          //$scope.$on('$ionicView.afterEnter', function() {
          //  $timeout(function(){
          //    $('.ng-binding a').click(function(event){
          //      goUrl = event.target.href ;
          //      $scope.vm = {
          //        paySrc:goUrl,
          //      }
          //      if (goUrl.includes('weixin.qq.com')){
          //        $.ajax({
          //          crossOrigin: true,
          //          url: goUrl,
          //          success: function(data) {
          //            data = data.replace(/data-src/g, "src");
          //            //var sourceHtml =  $sce.trustAsHtml(data);
          //            var sourceHtml = 'data:text/html;charset=utf-8,' + data;
          //            $("#homepageIframe").attr("src" , sourceHtml);
          //          }
          //        });
          //      }else{
          //        $scope.vm.paySrc = $sce.trustAsResourceUrl(goUrl);
          //      }
          //      $ionicModal.fromTemplateUrl('templates/homepage/detail-modal.html', {
          //        scope: $scope,
          //        animation: 'slide-in-none'
          //      }).then(function(modal) {
          //        $scope.iframeModal = modal ;
          //        $scope.iframeModal.show() ;
          //      })
          //      event.preventDefault();
          //    })
          //  },500) ;
          //});
        }
      }, false);
    }

    /********ppt start**********/
    $scope.imgIndex = 0;
    $scope.slideHasChanged = function (index) {
      var lastImg = angular.element('#img-homedetail-' + $scope.imgIndex);
      lastImg.css("webkitTransform", "translate(0px,0px) scale(1)");
      $scope.imgIndex = index;
    }

    $scope.openOverScreen = function(url){
      $scope.isOverScreen = true ;
      var index = -1;

      for (var i = 0 ;i < $scope.pptImgList.length ; i ++){
        if ($scope.pptImgList[i].src == url){
          index = i;
          break;
        }
      }

      $scope.count ++ ;
      $ionicSlideBoxDelegate.update() ;
      $ionicSlideBoxDelegate.slide(index);
      $timeout(function(){
        $(".big-picture").css('visibility','visible');
      },200);
      $scope.imgIndex = index ;
      //第一次点击出现大图时增加事件
      $scope.slideTimeout = $timeout(function(){
          var pinchDragEvent = null;
          var slide = angular.element('#HomeDetailSlide') ;
          // 计算拖动开始时两指间距离
          var intervalPinch = 0;
          var startX1 =  0;
          var startY1 =  0;
          var startX2 =  0;
          var startY2 =  0;
          var startDist = 0;
          var isIOS = ionic.Platform.isIOS();
          var intervalPx = 8;
          if (isIOS){
            intervalPx = 15;
          }

          $ionicGesture.on("pinch",function(e){
            var img = angular.element('#img-homedetail-'+$scope.imgIndex) ;
            if (pinchDragEvent == null){
              pinchDragEvent = e;
              // 计算拖动开始时两指间距离
              var startTouch1 = pinchDragEvent.gesture.touches[0];
              var startTouch2 = pinchDragEvent.gesture.touches[1];
              startX1 =  startTouch1.pageX;
              startY1 =  startTouch1.pageY;
              startX2 =  startTouch2.pageX;
              startY2 =  startTouch2.pageY;
              startDist = Math.sqrt(Math.pow((startX2-startX1),2) + Math.pow((startY2-startY1),2));
              return;
            }

            intervalPinch++;
            if (intervalPinch%3 != 0){
              return;
            }

            //// 计算当前两指间距离
            var endTouch1 = e.gesture.touches[0];
            var endTouch2 = e.gesture.touches[1];
            var endX1 =  endTouch1.pageX;
            var endY1 =  endTouch1.pageY;
            var endX2 =  endTouch2.pageX;
            var endY2 =  endTouch2.pageY;
            var endDist = Math.sqrt(Math.pow((endX2-endX1),2) + Math.pow((endY2-endY1),2));
            var left = 0 ;
            var top = 0 ;
            var rate = 1 ;
            var reg = /\-?[0-9]+\.?[0-9]*/g ;

            if (Math.abs(endDist - startDist) > intervalPx){
              if (endDist > startDist){
                var width = screen.width ;
                var length = parseFloat(Math.abs(endDist - startDist)) ;
                var scale = img.css("webkitTransform") ;
                var array = scale.match(reg) ;
                left = parseFloat(array[4]) ;
                top = parseFloat(array[5]) ;
                rate = parseFloat(array[0]);
                var num = rate + parseFloat(length/width) ;
                img.css("webkitTransform","translate("+left+"px,"+top+"px) scale("+num+")") ;
              }else{
                var width = screen.width ;
                var length = parseFloat(Math.abs(endDist - startDist)) ;

                var scale = img.css("webkitTransform") ;
                var array = scale.match(reg) ;
                left = parseFloat(array[4]) ;
                top = parseFloat(array[5]) ;
                rate = parseFloat(array[0]);
                var num = rate - parseFloat(length/width) ;
                if(num >= 1){
                  img.css("webkitTransform","translate("+left+"px,"+top+"px) scale("+num+")") ;
                }
              }
            }
            else{
              var x = endX1-startX1 ;
              var y = endY1-startY1 ;
              var scale = img.css("webkitTransform") ;
              var array = scale.match(reg) ;
              left = parseFloat(array[4]) + parseFloat(x);
              top = parseFloat(array[5]) + parseFloat(y);
              rate = parseFloat(array[0]);
              img.css("webkitTransform","translate("+left+"px,"+top+"px) scale("+rate+")") ;
            }
            pinchDragEvent = e;
            var startTouch1 = pinchDragEvent.gesture.touches[0];
            var startTouch2 = pinchDragEvent.gesture.touches[1];
            startX1 =  startTouch1.pageX;
            startY1 =  startTouch1.pageY;
            startX2 =  startTouch2.pageX;
            startY2 =  startTouch2.pageY;
            startDist = Math.sqrt(Math.pow((startX2-startX1),2) + Math.pow((startY2-startY1),2));
          }, slide);
          $ionicGesture.on("release",function(){
            pinchDragEvent = null;
            startX1 =  0;
            startY1 =  0;
            startX2 =  0;
            startY2 =  0;
            startDist = 0;
            intervalPinch = 0;
          }, slide);
      },200) ;
    }

    $scope.repeatFinish = function(){
      $ionicSlideBoxDelegate.update() ;
      $ionicSlideBoxDelegate.slide($scope.imgIndex);
    }

    $scope.closeOverScreen = function(){
      $scope.isOverScreen = false ;
      $timeout.cancel($scope.slideTimeout);
    }
    /********ppt end**********/
  })
