/**
 * Created by douhao on 2016/6/6.
 */
angular.module('classroomDetail-controller',[])
  .controller('ClassroomDetailCtrl',function($ionicHistory, $scope,$rootScope,$state,$stateParams,$ionicModal,$ionicPopup,learnService,commentService,$ionicScrollDelegate,$ionicActionSheet,$timeout,UserService,showAlertService,$cordovaToast,HomeService,groupService,rongcloudService,$ionicGesture,$ionicSlideBoxDelegate,$cordovaCamera,$cordovaMedia,$cordovaFile,$cordovaImagePicker,UserService,$interval,$cordovaKeyboard){
    $scope.share_header = "https://open.weixin.qq.com/connect/oauth2/authorize?appid=wx6939749493987808&redirect_uri=" ;
    $scope.share_footer = "&response_type=code&scope=snsapi_userinfo#wechat_redirect" ;
    $scope.learnInfo = [];
    $scope.sizeBigFlag = false;
    $scope.systemTime = new Date() ;
    $scope.endEnterTime = "" ;
    $scope.liveTime = "" ;
    $scope.jhendTime = "" ;
    $scope.shopTime = "";
    $scope.isMayPay = false ;
    $scope.isNeedPay = false ;
    $scope.productId = "" ;
    $scope.isClassRoom = true ;
    $scope.isHasPiontInfo = false ;
    $scope.module = "classRoom" ;
    $scope.dataEnterInfo = null ;
    $scope.videoPlaying = false;


    $scope.switch = function(index){
      angular.forEach($rootScope.classroomTabActive,function(data,i,array){
        if(i == index){
          array[i] = true ;

          // 在线答疑设置信息可点击
          if (i == 2){
            $timeout(function(){
              $("a[class^='JoinGroupUser']").on('click',function(e){
                var classInfo = $(e.target).attr("class");
                var userId = classInfo.split(' ')[0].split('-')[1];
                $state.go("menu.userDetail",{'userId':userId}) ;
              });
              $ionicScrollDelegate.scrollBottom(true);
            }, 200);
          }
        }else{
          array[i] = false ;
        }
      });
    }
    $scope.count_down = {
      hours:"",
      minutes:"",
      seconds:"",
    }

    //倒计时
    //$scope.countDown = function(nowTime,end_time){
    //  var seconds_left = (end_time - nowTime) / 1000;
    //
    //  $scope.count_down.hours = $scope.pad( parseInt(seconds_left / 3600) );
    //  seconds_left = seconds_left % 3600;
    //
    //  $scope.count_down.minutes = $scope.pad( parseInt(seconds_left / 60) );
    //  $scope.count_down.seconds = $scope.pad( parseInt( seconds_left % 60 ) );
    //  $scope.timer = $timeout(function(){
    //    var nowTime = new Date().getTime();
    //    var endTime = Date.parse($scope.endEnterTime);
    //    $scope.countDown(nowTime,endTime);
    //  },999);
    //  if($scope.count_down.hours == "00" && $scope.count_down.minutes == "00" && $scope.count_down.seconds == "00" ){
    //    $timeout.cancel($scope.timer);
    //  }
    //  console.log($scope.count_down.hours+":"+$scope.count_down.minutes+":"+$scope.count_down.seconds)
    //}
    //倒计时
    $scope.liveCountDown = function(nowTime,end_time){
      //var seconds_left = (end_time - nowTime) / 1000;
      var seconds_left = end_time.diff(nowTime) / 1000;

      $scope.count_down.hours = $scope.pad( parseInt(seconds_left / 3600) );
      seconds_left = seconds_left % 3600;

      $scope.count_down.minutes = $scope.pad( parseInt(seconds_left / 60) );
      $scope.count_down.seconds = $scope.pad( parseInt( seconds_left % 60 ) );
      $scope.timer = $timeout(function(){
        //var nowTime = new Date().getTime();
        //var endTime = Date.parse($scope.liveTime);
        //var endTime = Date.parse($scope.liveTime.replace(/-/g, '/'));
        var nowTime = moment(new Date());
        var endTime = moment($scope.liveTime);
        $scope.liveCountDown(nowTime,endTime);
      },999);
      if($scope.count_down.hours == "00" && $scope.count_down.minutes == "00" && $scope.count_down.seconds == "00" ){
        $timeout.cancel($scope.timer);
        //有订单才显示视频
        if("1"==$scope.learnInfo.dataLearnType){
          if($scope.pointInfo.code == 0){
            $scope.isNeedPay = false;
          }
        }else{
          if(typeof($scope.dataEnterInfo) == "undefined" || $scope.dataEnterInfo == null){
            //未报名
            $scope.isNeedPay = true;
          }else{
            $scope.isNeedPay = false;
          }
          //if(!$scope.compareJheadTime()){
          //  $scope.isNeedPay = false;
          //}else{
          //  $scope.isNeedPay = true;
          //}
        }
      }
      //console.log($scope.count_down.hours+":"+$scope.count_down.minutes+":"+$scope.count_down.seconds)
    }
    $scope.pad = function pad(n) {
      return (n < 10 ? '0' : '') + n;
    }

    //页面离开，停止倒计时
    $scope.$on('$ionicView.beforeLeave', function() {
      $rootScope.currentConversationInit();
      $timeout.cancel($scope.timer);
      $timeout.cancel($scope.getHistoryMsgTimer);

    }, false);

    //$scope.timer = $interval(function(){$scope.countDown(new Date().getTime())},1000);

    //报名截止时间与系统时间对比
    $scope.comparetime = function(){
      //var beginTimes = $scope.systemTime.substring(0,10).split('-');
      //var endTimes   = $scope.endEnterTime.substring(0,10).split('-');
      //$scope.systemTime = beginTimes[1]+'-'+beginTimes[2]+'-'+beginTimes[0]+' '+$scope.systemTime.substring(10,19);
      //$scope.endEnterTime    = endTimes[1]+'-'+endTimes[2]+'-'+endTimes[0]+' '+$scope.endEnterTime.substring(10,19);
      //var a =(Date.parse($scope.endEnterTime)-Date.parse($scope.systemTime))/3600/1000;
      //var systemTimes = new Date().getTime() ;
      //var endTimes = Date.parse($scope.endEnterTime) ;

      var systemTimes = moment(new Date());
      var endTimes = moment($scope.endEnterTime);
      //console.log(liveTimes) ;
      //alert(systemTimes.diff(liveTimes) ) ;
      if(systemTimes.diff(endTimes) > 0){
        return false ;
      }else{
        return true ;
      }

      //if(systemTimes>endTimes){
      //  return false ;
      //}else{
      //  return true ;
      //}
    }

    //直播时间与系统时间对比
    $scope.comparetimes = function(){
      //var beginTimes = $scope.systemTime.substring(0,10).split('-');
      //var liveTimes = $scope.liveTime.substring(0,10).split('-');
      //$scope.systemTime = beginTimes[1]+'-'+beginTimes[2]+'-'+beginTimes[0]+' '+$scope.systemTime.substring(10,19);
      //$scope.liveTime = liveTimes[1]+'-'+liveTimes[2]+'-'+liveTimes[0]+' '+$scope.liveTime.substring(10,19);
      //var b =(Date.parse($scope.liveTime)-Date.parse($scope.systemTime))/3600/1000;
      //return b;
      //var systemTimes = new Date().getTime() ;
      ////var liveTimes = Date.parse($scope.liveTime);
      //var dateLiveTime = $scope.liveTime.replace(/-/g, '/').replace(':','/') ;
      //console.log(dateLiveTime) ;
      //var liveTimes = Date.parse(dateLiveTime);
      //
      //if(systemTimes>liveTimes){
      //  return false ;
      //}else{
      //  return true ;
      //}
      var systemTimes = moment(new Date());
      var liveTimes = moment($scope.liveTime);
      //console.log(liveTimes) ;
      //alert(systemTimes.diff(liveTimes) ) ;
      if(systemTimes.diff(liveTimes) > 0){
        return false ;
      }else{
        return true ;
      }
    }

    //商品有效期与系统时间对比
    $scope.compareOrderTermtime = function(shopTime){
      //var systemTimes = new Date().getTime() ;
      //var shopTime = Date.parse(shopTime);
      var systemTimes = moment(new Date());
      var shopTime = moment(shopTime);

      if(systemTimes.diff(shopTime) > 0){
        return false ;
      }else{
        return true ;
      }
      //if(systemTimes>shopTime){
      //  return false ;
      //}else{
      //  return true ;
      //}
    }

    // 当前时间与答疑结束时间对比
    $scope.compareJheadTime = function(){
      //var systemTimes = new Date().getTime() ;
      //var jhendTimes = Date.parse($scope.jhendTime);
      var systemTimes = moment(new Date());
      var jhendTimes = moment($scope.jhendTime);

      if(systemTimes.diff(jhendTimes) > 0){
        return false ;
      }else{
        return true ;
      }
      //if(systemTimes>jhendTimes){
      //  return false ;
      //}else{
      //  return true ;
      //}
    }

    $scope.getUserScore = function(){
      learnService.getUserScore($rootScope.user.id)
        .then(function(result){
          $scope.userScoreInfo = JSON.parse(result.result);
        })
    }

    window.letvplayerCallback = function (type,data){
      if (type == 'videoStop' || type == 'videoPause'){
        $scope.videoPlaying = false;
        $scope.$apply();
      }
      if (type == 'videoStart' || type == 'videoResume'){
        $scope.videoPlaying = true;
        $scope.currentVadioId = -1;
        $scope.$apply();
        if (!!$scope.vadioTimer){
          $timeout.cancel($scope.vadioTimer);
        }
        //if (!!mediaRec){
        //  mediaRec.stop();
        //}
      }
    }

    $scope.initData = function(){
      $rootScope.currentConversationInit();
      if ($stateParams.classId != $rootScope.classroomCurrentId){
        $rootScope.classroomCurrentId = $stateParams.classId;
        $rootScope.classroomTabActive = [true,false,false] ;
      }

      learnService.findById($stateParams.classId,$rootScope.user.id)
        .then(function(res) {
          var result = res.result;
          $scope.learnInfo = result.dataLearnInfo;
          $scope.learnInfo.videoSize = Math.ceil(bytesToSize(result.dataLearnInfo.initialSize));
          $scope.learnInfo.videoLength = formatTime(result.dataLearnInfo.videoDuration);
          if(result.dataLearnInfo.publishDate != null){
            $scope.learnInfo.date = result.dataLearnInfo.publishDate.substr(0,10);
          }
          $scope.endEnterTime = result.dataLearnInfo.endEnterTime;
          $scope.liveTime = result.dataLearnInfo.liveTime;
          $scope.jhendTime = result.dataLearnInfo.jhendTime;
          if ($scope.learnInfo.videoSize > 20){
            $scope.sizeBigFlag = true;
          }else{
            $scope.sizeBigFlag = false;
          }

          var videoWidth = window.screen.width;
          $scope.uu = result.dataLearnInfo.uu;
          $scope.vu = result.dataLearnInfo.vu;

          letvplayer.init({callbackJs:'letvplayerCallback', uu: $scope.uu, vu: $scope.vu, auto_play: 0, dfull: 0}, "playerid");
          $scope.videoUrl = 'http://yuntv.letv.com/bcloud.html?uu='+ result.dataLearnInfo.uu + '&vu=' + result.dataLearnInfo.vu + '&auto_play=0&gpcflag=1&width='+videoWidth+'&height=200';

          learnService.read($stateParams.classId, $rootScope.user.id);
          $scope.updateSocial($rootScope.updateSocial.operRead,$rootScope.updateSocial.operationAdd) ;

          learnService.isAgree($stateParams.classId, $rootScope.user.id)
            .then(function(res1){
              var liked = res1.result;
              learnService.isCollect($stateParams.classId, $rootScope.user.id)
                .then(function(res2){
                  var stored = res2.result;
                  $scope.socialInfo.init($scope.learnInfo.agreeNum, $scope.learnInfo.storeNum, $scope.learnInfo.readNum, $scope.learnInfo.commentNum, liked, stored);
                })
            })

          //1、判断是否收费
          if("1"==$scope.learnInfo.dataLearnType){
            $scope.isNeedPay = true ;
            $scope.isMayPay = true ;
            //登录用户
            if($rootScope.user.id > 0) {
              $scope.getUserScore() ;
              $scope.pointInfo = eval("("+result.PointInfo+")");
              var product = $scope.pointInfo.obj;
              if($scope.pointInfo.success){
                if( $scope.pointInfo.code == 0){
                  //存在订单
                  $scope.shopTime = product.orderTerm.substr(0, 10);
                  $scope.isHasPiontInfo = true ;
                  $scope.isMayPay = false ;
                  if($scope.comparetimes()){
                    //var nowTime = new Date().getTime();
                    //var endTime = Date.parse($scope.liveTime);
                    var nowTime = moment(new Date());
                    var endTime = moment($scope.liveTime);
                    $scope.liveCountDown(nowTime,endTime) ;
                  }else{
                    //直播时间到了可以播放
                    // 判断订单是否到期
                    if($scope.compareOrderTermtime($scope.pointInfo.obj.orderTerm)){
                      $scope.isNeedPay = false ;
                    }else{
                      $scope.productId = product.productId ;
                      $scope.isNeedPay = true ;
                      $scope.isMayPay = true ;
                    }
                  }
                }
                if($scope.pointInfo.code == 3004){
                  //没有订单信息
                  $scope.isMayPay = true ;
                  $scope.productId = product.id ;
                  //报名时间已过
                  //var nowTime = new Date().getTime();
                  //var endTime = Date.parse($scope.liveTime);
                  var nowTime = moment(new Date());
                  var endTime = moment($scope.liveTime);
                  $scope.liveCountDown(nowTime,endTime) ;
                }
              }else{
                //var nowTime = new Date().getTime();
                //var endTime = Date.parse($scope.liveTime);
                var nowTime = moment(new Date());
                var endTime = moment($scope.liveTime);
                $scope.liveCountDown(nowTime,endTime) ;
                $scope.shopTime = $scope.learnInfo.productTerm +"个月" ;
                $scope.isMayPay = true ;
                $scope.isNeedPay = true ;
                //if($scope.pointInfo.code == 3001){
                //  showAlertService.PopAlert("提示信息","请前往个人中心升级为会员医生!","确认","") ;
                //}
                //else if($scope.pointInfo.code == 3002){
                //  //alert("后台服务错误(3002)，请稍后再试或联系管理员");
                //  showAlertService.PopAlert("服务器错误(3002)","请稍后再试或联系管理员","确认","") ;
                //  return ;
                //}
                //else if($scope.pointInfo.code == 3003){
                //  //alert("您的积分不足， 请在个人中心查看积分策略！");
                //  showAlertService.PopAlert("服务器错误(3003)","请稍后再试或联系管理员","确认","") ;
                //  return ;
                //}
              }
            }else{
              //var nowTime = new Date().getTime();
              //var endTime = Date.parse($scope.liveTime);
              var nowTime = moment(new Date());
              var endTime = moment($scope.liveTime);
              $scope.liveCountDown(nowTime,endTime) ;
              $scope.shopTime = $scope.learnInfo.productTerm +"个月" ;
              $scope.isNeedPay = true ;
              $scope.isMayPay = true ;
            }
          }else{
            $scope.getUserScore() ;
            $scope.isNeedPay = true ;
            $scope.isMayPay = true ;
            //直播时间是否已过
            $scope.dataEnterInfo =  result.dataEnterInfo;
            if($scope.comparetimes()){
              //var nowTime = new Date().getTime();
              //var endTime = Date.parse($scope.liveTime);
              var nowTime = moment(new Date());
              var endTime = moment($scope.liveTime);
              $scope.liveCountDown(nowTime,endTime) ;
              //判断是否有报名,有报名就不显示报名按钮
              if(typeof($scope.dataEnterInfo) == "undefined" || $scope.dataEnterInfo == null){
                //未报名
                $scope.isMayPay = true ;
                //if($scope.comparetime()){
                //  $scope.isMayPay = true ;
                //}else{
                //  $scope.isMayPay = false ;
                //}
              }else{
                $scope.isMayPay = false ;
              }
            }else{
              if(typeof($scope.dataEnterInfo) == "undefined" || $scope.dataEnterInfo == null){
                //未报名
                if($scope.comparetime()){
                  //报名时间未超过
                  $scope.isMayPay = true ;
                  //if(typeof($scope.dataEnterInfo) == "undefined" || $scope.dataEnterInfo == null){
                  //  //未报名
                  //  $scope.isMayPay = true ;
                  //}else{
                  //  $scope.isMayPay = false ;
                  //}
                }else if(!$scope.compareJheadTime()){
                  $scope.isNeedPay = false ;
                  $scope.isMayPay = false ;
                  //报名时间已过
                  //if($scope.compareJheadTime()){
                  //  $scope.isMayPay = true ;
                  //}else{
                  //  $scope.isMayPay = true ;
                  //}
                }else{
                  $scope.isMayPay = true ;
                }
              }else{
                $scope.isNeedPay = false ;
              }
            }



            //if(typeof(dataEnterInfo) == "undefined" || dataEnterInfo == null){
            //  //未报名
            //  $scope.isMayPay = true ;
            //}else{
            //  if($rootScope.user.id >0){
            //    //已登录 已报名
            //    $scope.isMayPay = false ;
            //  }else{
            //    //未登录
            //    $scope.isMayPay = true ;
            //  }
            //}
            //免费未报名
            //直播时间已到
            //答疑时间未过
            //答疑时间已过  可以观看
            //免费已报名
            //直播时间已到，可以观看
            //if($scope.comparetime()){
            //  //alert("免费当前时间未超过报名时间，可以报名");
            //  //当前时间未超过报名时间，倒计时开始
            //  $scope.isNeedPay = true ;
            //  $scope.isHasPiontInfo = true ;
            //  var nowTime = new Date().getTime();
            //  var endTime = Date.parse($scope.liveTime);
            //  $scope.liveCountDown(nowTime,endTime) ;
            //}else{
            //  //当前时间超过报名时间，报名截止，不能报名
            //  //$scope.isMayPay = false ;
            //  $scope.isHasPiontInfo = true ;
            //  //alert("免费当前时间超过报名时间，报名截止，不能报名");
            //  //当前时间超过答疑结束时间，未报名用户可以购买视频,显示立即兑换
            //  if($scope.comparetimes()){
            //    $scope.isNeedPay = true ;
            //    var nowTime = new Date().getTime();
            //    var endTime = Date.parse($scope.liveTime);
            //    $scope.liveCountDown(nowTime,endTime) ;
            //  }else{
            //    //$scope.isNeedPay = false ;
            //  }
            //}
            //alert("$scope.isNeedPay="+$scope.isNeedPay) ;
          }
        })
    }
    $rootScope.$watch('user.id',function(newValue,oldValue){
      if(newValue > 0 && newValue != oldValue && $ionicHistory.viewHistory().currentView.stateId.startsWith('menu.classroom-detail_classId=')){
        $scope.comm.init();
        $scope.initData();
      }
    })

    $scope.initData();
    $ionicModal.fromTemplateUrl('templates/learn/buy.html', {
      scope: $scope,
      animation:'slo'
    }).then(function(modal) {
      $scope.modal = modal;
    });
    //  购买确认页面
    $scope.showBuyConfirm = function() {
      if(0==$rootScope.user.id){
        $rootScope.$broadcast('login:show');
        return ;
      }
      if(false==$scope.userScoreInfo.success){
        showAlertService.PopAlert("提示信息","请前往个人中心升级为会员医生后再购买!","确认","") ;
        return;
      }

      if($scope.comparetime()){
        //报名时间未过
      }else{
        if($scope.compareJheadTime()){
          showAlertService.PopAlert("提示信息","报名时间已过!","确认","") ;
          return ;
        }
      }
      if("1"==$scope.learnInfo.dataLearnType) {
        if($scope.productId==""){
          showAlertService.PopAlert("提示信息","该商品已下架!","确认","") ;
          $scope.modal.hide() ;
          return;
        }
        var usableScore = $scope.userScoreInfo.obj.usableScore;
        if (usableScore - $scope.learnInfo.dataLearnScore < 0) {
          //alert("积分余额不足!");
          showAlertService.PopAlert("提示信息", "积分余额不足!", "确认", "");
          $scope.modal.hide();
          return;
        }
        if($scope.pointInfo.code == 3001){
          showAlertService.PopAlert("提示信息","请前往个人中心升级为会员医生后再购买!","确认","") ;
          return ;
        }
        else if($scope.pointInfo.code == 3002){
          //alert("后台服务错误(3002)，请稍后再试或联系管理员");
          showAlertService.PopAlert("服务器错误(3002)","服务器错误(3002),请稍后再试或联系管理员","确认","") ;
          return ;
        }
        else if($scope.pointInfo.code == 3003){
          //alert("您的积分不足， 请在个人中心查看积分策略！");
          showAlertService.PopAlert("服务器错误(3003)","服务器错误(3003),请稍后再试或联系管理员","确认","") ;
          return ;
        }
      }
      $scope.modal.show() ;
    };

    //微课堂报名
    $scope.saveDataLearnEnter = function(){
      var orderRemark = "购买资料";
      //不是免费的
      if("1"==$scope.learnInfo.dataLearnType){
        if($scope.productId==""){
          showAlertService.PopAlert("提示信息","该商品已下架!","确认","") ;
          $scope.modal.hide() ;
          return;
        }
        //var usableScore = $scope.userScoreInfo.obj.usableScore;
        //if(usableScore - $scope.learnInfo.dataLearnScore<0){
        //  showAlertService.PopAlert("提示信息","积分余额不足!","确认","") ;
        //  $scope.modal.hide() ;
        //  return;
        //}
        if($scope.pointInfo.code == 3001){
          showAlertService.PopAlert("提示信息","请前往个人中心升级为会员医生后再购买!","确认","") ;
        }
        else if($scope.pointInfo.code == 3002){
          //alert("后台服务错误(3002)，请稍后再试或联系管理员");
          showAlertService.PopAlert("服务器错误(3002)","服务器错误(3002),请稍后再试或联系管理员","确认","") ;
          return ;
        }
        else if($scope.pointInfo.code == 3003){
          //alert("您的积分不足， 请在个人中心查看积分策略！");
          showAlertService.PopAlert("服务器错误(3003)","服务器错误(3003),请稍后再试或联系管理员","确认","") ;
          return ;
        }
        $scope.isPaying = true ;
        learnService.saveDataLearnEnter($stateParams.classId,$rootScope.user.id)
          .then(function(result){
            if(result.code!=0){
              //alert(result.message);
            }else{
              learnService.pay($stateParams.classId,$scope.productId,$rootScope.user.id,orderRemark)
                .then(function(result){
                  $scope.modal.hide() ;
                  // 积分系统对象
                  /*******************3、积分系统返回异常*********************/
                  if(result.code!=0){
                    //alert(result.message);
                  }else{
                    // 购买成功
                    //alert("购买成功!");
                    //  修改学习次数
                    showAlertService.PopAlert("提示信息","报名成功!","确认","") ;
                    groupService.getGroupByDataLearnId($stateParams.classId)
                      .then(function(result){
                        if (result.code == 0 && !!result.result){
                          if (!result.result.picture){
                            result.result.picture = img.personalImage;
                          }
                          rongcloudService.joinGroup(result.result);

                          RongCloudLibPlugin.sendCommandNotificationMessage({
                              conversationType: 'GROUP',
                              targetId: result.result.id,
                              name: 'JoinGroup',
                              data: '<a class="JoinGroupUser-'+ $rootScope.user.id +'">"'+ $rootScope.user.nickName + '"</a> 加入了本群'
                            },
                            function(ret, err) {
                              if (ret) {
                                if (ret.status == "prepare") {
                                  //$rootScope.appendNewMsg(ret.result.message);
                                }
                              }
                            }
                          );
                        }
                      })
                    $scope.comm.init() ;
                    $scope.buyCount += 1 ;
                    $scope.isPaying = false ;
                    $scope.shopTime = moment().add('M',$scope.pointInfo.obj.productTerm).format('YYYY-MM-DD');
                    $scope.isMayPay = false ;
                  }
                },function(result){
                  //alert(result.message) ;
                })
              $scope.enterCount += 1 ;
              $scope.updateSocial("enterCount",true) ;
              $scope.modal.hide() ;
            }
          },function(result){
            //alert(result.message) ;
          })
      }else{
        $scope.isPaying = true ;
        learnService.saveDataLearnEnter($stateParams.classId,$rootScope.user.id)
          .then(function(result){
            if(result.code!=0){
              //alert(result.message);
            }else{
              showAlertService.PopAlert("提示信息","报名成功!","确认","") ;
              groupService.getGroupByDataLearnId($stateParams.classId)
                .then(function(result){
                  if (result.code == 0 && !!result.result){
                    if (!result.result.picture){
                      result.result.picture = img.personalImage;
                    }
                    rongcloudService.joinGroup(result.result);

                    RongCloudLibPlugin.sendCommandNotificationMessage({
                        conversationType: 'GROUP',
                        targetId: result.result.id,
                        name: 'JoinGroup',
                        data: '<a class="JoinGroupUser-'+ $rootScope.user.id +'">"'+ $rootScope.user.nickName + '"</a> 加入了本群'
                      },
                      function(ret, err) {
                        if (ret) {
                          if (ret.status == "prepare") {
                            //$rootScope.appendNewMsg(ret.result.message);
                          }
                        }
                      }
                    );
                  }
                })
              $scope.comm.init() ;
              $scope.enterCount += 1 ;
              $scope.updateSocial("enterCount",true) ;
              $scope.isPaying = true ;
              $scope.isMayPay = false ;
              $scope.modal.hide() ;
            }
          },function(result){
            //alert(result.message) ;
          })
      }
    }

    //取消
    $scope.cancel = function(){
      $scope.modal.hide() ;
    }

    //购买
    $scope.pay = function(){
      var orderRemark = "购买资料";
      //console.log("支付") ;
      $scope.isPaying = true ;
      learnService.pay($stateParams.classId,$scope.productId,$rootScope.user.id,orderRemark)
        .then(function(result){
          $scope.modal.hide() ;
          // 积分系统对象
          /*******************3、积分系统返回异常*********************/
          if(result.code!=0){
            //alert(result.message);
            $rootScope.$broadcast("message","请稍后再试！",3000,"alert") ;
          }else{
            var returnPointInfo = eval("("+result.result+")");
            $scope.isPaying = true ;
            if (returnPointInfo.code == 3001) {
              showAlertService.PopAlert("提示信息", "请前往个人中心升级为会员医生!", "确认", "");
            }
            else if (returnPointInfo.code == 3002) {
              //alert("后台服务错误(3002)，请稍后再试或联系管理员");
              showAlertService.PopAlert("服务器错误(3002)", "服务器错误(3002),请稍后再试或联系管理员", "确认", "");
              return;
            }
            else if (returnPointInfo.code == 3003) {
              //alert("您的积分不足， 请在个人中心查看积分策略！");
              showAlertService.PopAlert("服务器错误(3003)", "服务器错误(3003),请稍后再试或联系管理员", "确认", "");
              return;
            }
            else if (returnPointInfo.code == 3006) {
              //alert("您的积分不足， 请在个人中心查看积分策略！");
              showAlertService.PopAlert("服务器错误(3006)", "服务器错误(3006),请稍后再试或联系管理员", "确认", "");
              return;
            }
            // 购买成功
            showAlertService.PopAlert("提示信息","购买成功!","确认","") ;
            $scope.buyCount += 1 ;
            $scope.updateSocial("enterCount",true) ;
            $scope.shopTime = moment().add('M',$scope.pointInfo.obj.productTerm).format('YYYY-MM-DD');
            ////如果直播时间超过系统时间，播放
              $scope.isNeedPay = false ;
          }
        },function(result){
          //alert(result.message) ;
          $scope.modal.hide();
          $rootScope.$broadcast("message","请稍后再试！",3000,"alert") ;
        })
    }

    //操作列表页的社交数据
    $scope.updateSocial = function(operType,operation){
      $scope.$emit("social", $stateParams.classId,$scope.module,operType,operation);
    }

    //分享
    $scope.isShare = false ;
    $scope.share = function(type){
      $scope.isShare = false ;
      try{
        for(var i in $rootScope.share_urls){
          if($rootScope.share_urls[i].confKey == "share_classroom"){
            //$scope.shareUrl = $scope.share_header+encodeURIComponent($rootScope.share_urls[i].confValue + "?id="+$stateParams.classId+"&vu="+$scope.vu+"&uu="+$scope.uu)+$scope.share_footer ;
            //$scope.shareUrl = $rootScope.share_urls[i].confValue + "?id="+$stateParams.classId+"&vu="+$scope.vu+"&uu="+$scope.uu ;
            $scope.shareUrl = $rootScope.share_urls[i].confValue.replace("{id}",$stateParams.classId).replace("{uu}",$scope.uu).replace("{vu}",$scope.vu) ;
          }
        }
        //alert($scope.shareUrl) ;
        //分享参数
        switch(type){
          case 0:
            $scope.scene = Wechat.Scene.SESSION;
            break ;
          case 1:
            $scope.scene = Wechat.Scene.TIMELINE;
            break ;
        }
        Wechat.isInstalled(function (installed) {
          if(installed == "No"){
            $scope.isShare = false ;
            showAlertService.PopAlert("提示信息","请先安装微信再分享","确认","") ;
            return ;
          }else{
            var thumbImg = $scope.learnInfo.dataLearnPic == ""?img.shareImg:$scope.learnInfo.dataLearnPic ;
            Wechat.share({
              message:{
                title: $scope.learnInfo.dataLearnTitle,
                description: $scope.learnInfo.dataLearnDesc==null?"":$scope.learnInfo.dataLearnDesc,
                thumb: thumbImg,
                mediaTagName: "影领-TAG-001",
                messageExt: "影领",
                messageAction: "<action>dotalist</action>",
                media: {
                  type:Wechat.Type.LINK ,
                  webpageUrl:$scope.share_header+encodeURIComponent($scope.shareUrl)+$scope.share_footer
                  //webpageUrl: $scope.shareUrl
                }
              },
              scene: $scope.scene
            }, function () {
              //$cordovaToast.showShortBottom('分享成功') ;
              //showAlertService.PopShow("提示信息","分享成功",1000) ;
              HomeService.addShareRecord($rootScope.user.id,$stateParams.classId,5,$scope.shareUrl)
                .then(function(result){
                }) ;
            }, function (reason) {
              //$cordovaToast.showShortBottom('分享失败') ;
              //showAlertService.PopShow("提示信息","分享失败",1000) ;
            });
          }
        });
      }catch(e){
        alert(e) ;
      }
    }
    //显示分享
    $scope.showShare = function() {
      if($rootScope.share_urls == null || $rootScope.share_urls == undefined){
        $rootScope.$broadcast('message',"正在获取分享信息，请稍后再试！",3000,"notice");
        UserService.getConfByType('share')
          .then(function(result){
            if(result.success){
              $rootScope.share_urls= result.result ;
            }
          })
        return ;
      }
      $scope.isShare = true ;
    };
    //取消分享
    $scope.cancelShare = function(){
      $scope.isShare = false ;
    }


    /********* 社交功能开始 *********/
    $scope.socialInfo = {};
    // 控制社交功能区展示
    $scope.socialInfo.show = {};
    // 控制社交数值展示
    $scope.socialInfo.text = {};
    // 控制社交图标展示
    $scope.socialInfo.icon = {};

    $scope.socialInfo.show.likeFlag = true;
    $scope.socialInfo.show.storeFlag = true;
    $scope.socialInfo.show.readFlag = true;
    $scope.socialInfo.show.commentFlag = false;

    $scope.socialInfo.init = function(likeNum, storeNum, readNum, commentNum, liked, stored){
      $scope.socialInfo.text.likeNum = likeNum;
      $scope.socialInfo.text.storeNum = storeNum;
      $scope.socialInfo.text.readNum = readNum;
      $scope.socialInfo.text.commentNum = commentNum;
      $scope.socialInfo.icon.liked = liked;
      $scope.socialInfo.icon.stored = stored;
    }

    $scope.socialInfo.like = function(flag){
      if (!flag) {
        // 不支持取消点赞
        return;
      }

      $scope.socialInfo.icon.liked = true;
      $scope.socialInfo.text.likeNum += 1;
      learnService.like($stateParams.classId, $rootScope.user.id)
        .then(function(result){
          $scope.updateSocial($rootScope.updateSocial.operAgree,$rootScope.updateSocial.operationAdd) ;
        },function(error){
          $scope.socialInfo.icon.liked = false;
          $scope.socialInfo.text.likeNum -= 1;
        })
    }

    $scope.socialInfo.store = function(flag){
      if (!flag) {
        // 不支持取消收藏
        return;
      }
      $scope.socialInfo.icon.stored = true;
      $scope.socialInfo.text.storeNum += 1;
      learnService.store($stateParams.classId, $rootScope.user.id)
        .then(function(result){
          $scope.updateSocial($rootScope.updateSocial.operStore,$rootScope.updateSocial.operationAdd) ;
        },function(error){
          $scope.socialInfo.icon.stored = false;
          $scope.socialInfo.text.storeNum -= 1;
        })
    }
    /********* 社交功能结束 *********/

    /********* 评论功能开始 *********/
    $scope.comment = {
      comments: [],
      send_content: '',
      reply_head: '',
      expandId: -1,
      carrierId: $stateParams.classId,
      carrierType: 3,
      complainType: 5,
      isSubmited: true
    };
    $scope.comment.params = {
      hasmore : false,
      from : 1,
      pageSize:3
    };

    $scope.comment.replyModel = {};

    $scope.comment.keyDown = function(e){
      var keyCode = window.event?e.keyCode:e.which;
      // 删除
      if (keyCode == 8){
        //console.log($scope.comment.send_content)
        //console.log($scope.comment.reply_head)
        if ($scope.comment.send_content + ' ' == $scope.comment.reply_head || $scope.comment.send_content == $scope.comment.reply_head){
          $scope.comment.replyModel = {};
          $scope.comment.send_content = '';
          $scope.comment.reply_head = '';
        }
      }
    }

    $scope.comment.submitComment = function(){
      if (!$scope.comment.send_content && !$scope.comment.send_content.trim()){
        return;
      }

      var comment = $scope.comment.send_content.replace($scope.comment.reply_head, '');
      if (!comment && !comment.trim()){
        return;
      }

      $scope.comment.isSubmited = false ;
      $scope.comment.replyModel.carrierId = $scope.comment.carrierId;
      $scope.comment.replyModel.carrierType = $scope.comment.carrierType;
      $scope.comment.replyModel.userId = $rootScope.user.id;
      $scope.comment.replyModel.comment = comment.replace(/\n/g, '<br/>');
      commentService.submitComment($scope.comment.replyModel)
        .then(function(result){
          if (!$scope.comment.replyModel.parentId){
            $scope.comment.flushComment() ;
            $scope.comment.replyModel = {};
          }else{
            commentService.getSubComment($scope.comment.carrierType, $scope.comment.replyModel.parentId)
              .then(function(result){
                for(var i in $scope.comment.comments){
                  if ($scope.comment.comments[i].id == $scope.comment.replyModel.parentId){
                    $scope.comment.comments[i].subComments=$scope.comment.changeImgUrl(result.result);
                    $scope.comment.replyModel = {};
                  }
                }
              })
          }
          $scope.comment.send_content = '';
          $scope.comment.reply_head = '';
        })
        .finally(function(){
          $scope.comment.isSubmited = true ;
        })
    }
    /********* 评论功能结束 *********/
    $scope.comm = {
      disableFlag: true,
      groupId: -1,
      isGROUP: true
    }

    $scope.comm.init = function(){
      if ($rootScope.user.id <= 0){
        return;
      }

      learnService.getGroupIdByUser($stateParams.classId, $rootScope.user.id)
        .then(function(result){
          if (!!result && result.result > -1){
            $scope.comm.disableFlag = false;
            $scope.comm.groupId = result.result;
          }
        })
    }
    $scope.comm.init();


    $scope.userListFlag=false;
    $scope.showMsgTipFlag=false;
    $scope.doRefreshFlag=false;
    $scope.doRefreshMessageId=-1;
    $scope.failMessageList = [];
    $scope.atUser = null;
    $scope.isGroupHost=false;
    $scope.groupBannedFlag=false;
    $scope.messageTextChange = function(){
      if ($rootScope.currentConversation.conversationType != 'GROUP'){
        return;
      }
      if ($rootScope.currentConversation.inputText.endsWith('@')){
        $cordovaKeyboard.close();
        $scope.userListFlag=true;
      }
    }
    $scope.keyDown = function(e){
      if ($rootScope.currentConversation.conversationType != 'GROUP'){
        return;
      }
      var keyCode = window.event?e.keyCode:e.which;
      if (keyCode == 8){
        if ($rootScope.currentConversation.inputText.trim().endsWith('@'+$scope.atUser.name)){
          $rootScope.currentConversation.inputText = $rootScope.currentConversation.inputText.replace('@'+$scope.atUser.name, '');
          $scope.atUser = null;
        }
      }
    }
    $scope.selectAtUser = function(member){
      $scope.atUser = {id:member.id,name:member.groupNickname};
      $rootScope.currentConversation.inputText += $scope.atUser.name+' ';
      $scope.userListFlag=false;
    }

    $scope.onHoldUserPic = function(id, name){
      if ($scope.videoMessageFlag){
        $scope.videoMessageFlag = false;
      }

      name = name.split(' | ')[1];
      $scope.atUser = {id:id,name:name};
      $rootScope.currentConversation.inputText += '@'+$scope.atUser.name+' ';
    }

    $scope.getAtUserId = function(){
      if (!!$scope.atUser){
        return $scope.atUser.id;
      }
      return '';
    }

    $scope.sendNotificationMessage = function(name, data){
      RongCloudLibPlugin.sendCommandNotificationMessage({
          conversationType: $rootScope.currentConversation.conversationType,
          targetId: $rootScope.currentConversation.targetId,
          name: name,
          data: data
        },
        function(ret, err) {
          $scope.atUser = null;
          if (ret) {
            if (ret.status == "prepare") {
              $rootScope.appendNewMsg(ret.result.message);
            }
          }
        }
      );
    };

    $scope.sendTextMessage = function(text, reSendFlag){
      RongCloudLibPlugin.sendTextMessage({
          conversationType: $rootScope.currentConversation.conversationType,
          targetId: $rootScope.currentConversation.targetId+"",
          text: text,
          extra: new Date().getTime() + ' | ' + $rootScope.user.nickName + ' | ' + $scope.getAtUserId()
        },
        function(ret, err) {
          $scope.atUser = null;
          if (ret) {
            if (ret.status == "prepare") {
              if (!reSendFlag){
                $rootScope.appendNewMsg(ret.result.message);
              }
            }
          }
          if (err) {
            var messageId = err.result;
            $scope.failMessageList.push({"messageId":messageId, "messageType":"text", "text":text});
            $scope.setFailFlag(messageId, true);
          }
        }
      );
    };
    $scope.sendImgMessage = function(url, reSendFlag){
      RongCloudLibPlugin.sendImageMessage({
          conversationType: $rootScope.currentConversation.conversationType,
          targetId: $rootScope.currentConversation.targetId+"",
          imagePath: url,
          extra: new Date().getTime() + ' | ' + $rootScope.user.nickName + ' | ' + $scope.getAtUserId()
        },
        function(ret, err) {
          if (ret) {
            if (ret.status == "prepare") {
              if (!reSendFlag){
                $rootScope.appendNewMsg(ret.result.message, $scope.isOverScreen);
              }
            }
          }
          if (err) {
            var messageId = err.result.message.messageId;
            $scope.failMessageList.push({"messageId":messageId, "messageType":"img", "url":url});
            $scope.setFailFlag(messageId, true);
          }
        }
      );
    };

    $scope.sendVoiceMessage = function(path, dur, reSendFlag){
      RongCloudLibPlugin.sendVoiceMessage({
          conversationType: $rootScope.currentConversation.conversationType,
          targetId: $rootScope.currentConversation.targetId+"",
          voicePath: path,
          duration: dur,
          extra: new Date().getTime() + ' | ' + $rootScope.user.nickName + ' | ' + $scope.getAtUserId()
        },
        function(ret, err) {
          if (ret) {
            if (ret.status == "prepare") {
              if (!reSendFlag){
                $rootScope.appendNewMsg(ret.result.message);
              }
            }
          }
          if (err) {
            var messageId = err.result.message.messageId;
            $scope.failMessageList.push({"messageId":messageId, "messageType":"voice", "path":path, "dur":dur});
            $scope.setFailFlag(messageId, true);
          }
        }
      );
    };

    $scope.reSend = function(messageId){
      $scope.setFailFlag(messageId, false);
      var message = null;
      for (var i in $scope.failMessageList){
        if ($scope.failMessageList[i].messageId == messageId){
          message = $scope.failMessageList[i];
        }
      }

      if (!!message){
        if (message.messageType == 'text'){
          $scope.sendTextMessage(message.text, true);
        }else if (message.messageType == 'img'){
          $scope.sendImgMessage(message.url, true);
        }else if (message.messageType == 'voice'){
          $scope.sendVoiceMessage(message.path, message.dur, true);
        }
      }
    }

    $scope.setFailFlag = function(messageId, failFlag){
      for (var i in $rootScope.currentConversation.messageList){
        if ($rootScope.currentConversation.messageList[i].messageId == messageId){
          $rootScope.currentConversation.messageList[i].failFlag = failFlag;
          $rootScope.$apply();
          break;
        }
      }
    }

    var isIOS = ionic.Platform.isIOS();
    var isAndroid = ionic.Platform.isAndroid();

    $scope.sendPhoto = function(){
      var options = {
        maximumImagesCount: 9,
        maxSize: 100
      };

      $cordovaImagePicker.getPictures(options)
        .then(function (imageURIs) {
          if (imageURIs.length == 0){
            return;
          }

          var i = 0;
          $interval(function(){
            var imageURI;
            if(isIOS){
              imageURI= imageURIs[i].replace('file://','');
            }else{
              if (!imageURIs[i].startsWith('file://')){
                imageURI = 'file://'+ imageURIs[i];
              }else{
                imageURI = imageURIs[i];
              }
            }
            $scope.sendImgMessage(decodeURI(imageURI), false);
            i++;
          }, 1000, imageURIs.length);
        }, function (err) {
          console.log(err);
        });
    }

    //$scope.sendPhoto = function(){
    //  var options = {
    //    quality: 100,
    //    saveToPhotoAlbum: false,
    //    sourceType: 0,
    //    destinationType: Camera.DestinationType.FILE_URI
    //  };
    //
    //  $cordovaCamera.getPicture(options).then(function(imageURI) {
    //    var picPath = imageURI;
    //    if(isIOS){
    //      picPath = imageURI.replace('file://','');
    //    }
    //    if(isAndroid){
    //      var index = imageURI.indexOf('?');
    //      if (index > 0){
    //        picPath = imageURI.substring(0, imageURI.indexOf('?'));
    //      }
    //    }
    //
    //    $scope.sendImgMessage(picPath, false);
    //  }, function(err) {
    //    console.error(err);
    //  });
    //}

    $scope.sendCamera = function(){
      var options = {
        quality: 100,
        sourceType: Camera.PictureSourceType.CAMERA,
        destinationType: Camera.DestinationType.FILE_URI
      };

      $cordovaCamera.getPicture(options)
        .then(function(imageURI) {

          if(isIOS){
            imageURI= imageURI.replace('file://','');
          }

          $scope.sendImgMessage(imageURI, false);
        }, function(err) {
          console.error(err);
        });
    }

    $scope.sendText = function(){
      if (!$rootScope.currentConversation.inputText){
        return;
      }
      $scope.sendTextMessage($rootScope.currentConversation.inputText, false);
      $rootScope.currentConversation.inputText = '';

    }
    $scope.getHistoryMsgTimer = null;
    $scope.getHistoryMsg = function(oldestMessageId) {
      RongCloudLibPlugin.getHistoryMessages({
          conversationType: $rootScope.currentConversation.conversationType,
          targetId: $rootScope.currentConversation.targetId+"",
          count: 10,
          oldestMessageId: oldestMessageId
        },
        function(ret, err) {
          if (ret) {
            var result = new Array(),tmp;
            for (var i = ret.result.length - 1; i >= 0; i--) {
              tmp = ret.result[i];
              tmp = rongCloudUtil.resolveMsg(tmp);
              var userPic = $rootScope.getUserPic(tmp.senderUserId);
              tmp.userPic = userPic;
              result.push(tmp);
            }
            var hisArr = result.concat($rootScope.currentConversation.messageList);
            $rootScope.currentConversation.messageList = hisArr;

            var cancelMessageList = [];
            for(var i in $rootScope.currentConversation.messageList){
              if (!!$rootScope.currentConversation.messageList[i].content.data && $rootScope.currentConversation.messageList[i].content.name.startsWith('CancelMessage')){
                cancelMessageList.push($rootScope.currentConversation.messageList[i].content.name.split('-')[1]);
              }
            }

            if (cancelMessageList.length > 0){
              var messageLists = [];
              for (var i in cancelMessageList){
                var index = -1;
                for (var j in $rootScope.currentConversation.messageList){
                  if (!!$rootScope.currentConversation.messageList[j].content.extra && $rootScope.currentConversation.messageList[j].content.extra.split(' | ')[0] == cancelMessageList[i]){
                    messageLists.push($rootScope.currentConversation.messageList[j].messageId);
                    index = j;
                    break;
                  }
                }
                if (index > -1){
                  $rootScope.currentConversation.messageList.splice(index, 1);
                }
              }

              if (messageLists.length > 0){
                RongCloudLibPlugin.deleteMessages({
                  messageIds: messageLists
                }, function (ret, err) {
                  console.log(JSON.stringify(ret))
                })
              }
            }

            if (oldestMessageId > -1 && ret.result.length > 0 && !!$('#messageDiv-'+oldestMessageId).position()){
              $scope.getHistoryMsgTimer = $interval(function(){
                var position = $('#messageDiv-'+oldestMessageId).position().top;
                if (position > 50){
                  var delegate = $ionicScrollDelegate.$getByHandle('messageDetailsScrollTwo');
                  delegate.scrollTo(0, position - 60, false);
                  $interval.cancel($scope.getHistoryMsgTimer);
                  $scope.doRefreshFlag=false;
                }
              }, 50);
            }else{
              $scope.doRefreshFlag=false;
              $scope.$apply();
            }

            //if (oldestMessageId == -1){
            //  $ionicScrollDelegate.scrollBottom(true);
            //}

            $rootScope.currentConversation.imageList = [];
            for (var i in $rootScope.currentConversation.messageList){
              if ($rootScope.currentConversation.messageList[i].objectName == 'RC:ImgMsg'){
                $rootScope.currentConversation.imageList.push($rootScope.currentConversation.messageList[i].content.imageUrl);
              }
            }
            if (!$scope.isOverScreen){
              $scope.imgsShowList = $rootScope.currentConversation.imageList.concat();
            }

            $("a[class^='JoinGroupUser']").on('click',function(e){
              var classInfo = $(e.target).attr("class");
              var userId = classInfo.split(' ')[0].split('-')[1];
              $state.go("menu.userDetail",{'userId':userId}) ;
            });
          }
          if (err) {
          }
        }
      );
    }

    $scope.clearMessagesUnreadStatus = function() {
      $rootScope.newmessage.messageCount = 0;
      for (var i in $rootScope.conversation.conversationList){
        var conversationTemp = $rootScope.conversation.conversationList[i];
        if (conversationTemp.targetId == $rootScope.currentConversation.targetId && conversationTemp.conversationType == $rootScope.currentConversation.conversationType){
          conversationTemp.unreadMessageCount = 0;
          conversationTemp.atFlag = false;
          $rootScope.$apply();
        }else{
          $rootScope.newmessage.messageCount += conversationTemp.unreadMessageCount;
        }
      }

      RongCloudLibPlugin.clearMessagesUnreadStatus({
          conversationType: $rootScope.currentConversation.conversationType,
          targetId: $rootScope.currentConversation.targetId
        },
        function (ret, err) {
          if (err) {
          }
        }
      );
    }

    $scope.doRefresh = function() {
      if ($scope.doRefreshFlag){
        return;
      }

      var oldestMessageId = -1;
      if ($rootScope.currentConversation.messageList.length > 0){
        oldestMessageId = $rootScope.currentConversation.messageList[0].messageId;
        if ($('#messageDiv-'+oldestMessageId).length == 0){
          oldestMessageId = -1;
        }
      }

      if (oldestMessageId == -1){
        $rootScope.currentConversation.messageList=[];
        $scope.doRefreshFlag=true;
        $scope.getHistoryMsg(oldestMessageId);
      }else{
        var position = $('#messageDiv-'+oldestMessageId).position().top;
        if (position > -1){
          $scope.doRefreshFlag=true;
          $scope.doRefreshMessageId=oldestMessageId;
          $timeout(function(){
            $scope.getHistoryMsg(oldestMessageId);
          }, 500);
        }
      }
    };

    $scope.groupMembers = {};
    $scope.groupMembersSearch = {
      text: ''
    };

    $scope.getMember = function () {
      groupService.getGroupMembers($scope.comm.groupId ,$scope.groupMembersSearch.text,"1","1000")
        .then(function (result) {
          $scope.groupMembers = result.result;
        })
    }
    $scope.$watch('comm.groupId', function(newValue, oldValue) {
      if (newValue != -1){
        if (!$rootScope.conversationFlag){
          $rootScope.$emit('message',"通信模块初始化失败，暂无法使用",3000,"notice");
          return;
        }

        $rootScope.currentConversation.targetId = newValue;
        $rootScope.currentConversation.conversationType = 'GROUP';

        groupService.getGroupById(newValue)
          .then(function(result){
            if (!!result.result){
              $scope.groupBannedFlag = result.result.isBanned == 1 ? true : false;

              for (var i in result.result.hosts){
                if (result.result.hosts[i] == $rootScope.user.id){
                  $scope.isGroupHost = true;
                  break;
                }
              }
            }
          })

        $scope.doRefresh();
        $scope.clearMessagesUnreadStatus();
        $scope.getMember();
      }
    });

    $scope.videoMessageFlag = false;
    $scope.videoMessageText = "按住 说话";
    $scope.changeVideo = function(){
      $scope.videoMessageFlag = !$scope.videoMessageFlag;
    }

    $scope.showBigPic = false;
    $scope.showBigPicPath = 'img/sload.gif';
    $scope.openImage = function(url){
      $scope.showBigPicPath = url;
      $scope.showBigPic = true;
      angular.element('.nav-bar-container').hide();
    }
    $scope.closeImage = function(){
      $scope.showBigPic = false;
      $scope.showBigPicPath = 'img/sload.gif';
      angular.element('.nav-bar-container').show();
    }

    var src = "cordovaIMVoice.amr";
    var mediaRec;
    var path = "";
    if(isIOS){
      path = cordova.file.documentsDirectory;
      src = "cordovaIMVoice.wav";
    }else{
      path = cordova.file.externalApplicationStorageDirectory;
    }

    $scope.getMediaURL = function(s) {
      if (device.platform.toLowerCase() === "android") return path + s;
      return (path + s).replace('file://', '');
    }

    $scope.getNewMediaURL = function(s) {
      if (device.platform.toLowerCase() === "android") return path + s;
      return "documents://" + s;
    }

    $scope.start = function(){
      if (mediaRec) {
        mediaRec.release();
      }
      mediaRec = new Media($scope.getNewMediaURL(src),
        // 录音执行函数
        function() {
          //console.log("start():Audio Success");
        },
        // 录音失败执行函数
        function(err) {
          //console.log("start():Audio Error: " + JSON.stringify(err)+ "----"+getMediaURL(src));
        }
      );
    }

    $scope.currentVadioId = -1;
    $scope.backgroundColorChange = function(msgId, changeColor, currentColor){
      $('#triangle-'+msgId).css('border-color', 'transparent '+changeColor+' transparent transparent');
      $('#triangleself-'+msgId).css('border-color', 'transparent transparent transparent '+changeColor);
      $('#vadio-'+msgId).css('background-color', changeColor);
      $('#vadioself-'+msgId).css('background-color', changeColor);


      $timeout(function(){
        $('#triangle-'+msgId).css('border-color', 'transparent '+changeColor+' transparent transparent');
        $('#triangleself-'+msgId).css('border-color', 'transparent transparent transparent '+currentColor);
        $('#vadio-'+msgId).css('background-color', currentColor);
        $('#vadioself-'+msgId).css('background-color', currentColor);
      }, 500);
    }

    $scope.vadioTimer = null;
    $scope.play = function(message, nextFlag) {
      if ($scope.videoPlaying){
        $rootScope.$broadcast('message',"视频播放时不能使用语音消息。",3000,"notice");
        return;
      }

      if (!!mediaRec){
        mediaRec.stop();
      }

      if (!nextFlag && !!$scope.vadioTimer){
        $timeout.cancel($scope.vadioTimer);
      }

      // 再次点击语音  停止播放
      if (message.messageId == $scope.currentVadioId){
        $scope.currentVadioId = -1;
        return;
      }

      mediaRec = $cordovaMedia.newMedia(message.content.voicePath,
        function() {
          $cordovaMedia.release();
        },
        function(err) {
        }
      );
      //开始播放录音
      $scope.currentVadioId = message.messageId;
      $scope.vadioTimer = $timeout(function(){
        var nextMessage = null;
        for (var i in $rootScope.currentConversation.messageList){
          if ($rootScope.currentConversation.messageList[i].messageId <= message.messageId){
            continue;
          }
          if ($rootScope.currentConversation.messageList[i].objectName == 'RC:VcMsg'){
            nextMessage = $rootScope.currentConversation.messageList[i];
            break;
          }
        }

        if (!!nextMessage && $scope.currentVadioId != -1){
          $scope.play(nextMessage, true);
        }else{
          $scope.currentVadioId = -1
        }
      }, message.content.duration * 1000 + 1000);
      mediaRec.play({ numberOfLoops: 1 });
      return false;
    };

    $scope.startRecord = function(){
      $scope.videoMessageText = "松开 结束";
      $scope.start();
      mediaRec.startRecord();
    }
    $scope.endRecord = function(){
      if (mediaRec) {
        mediaRec.stopRecord();
        mediaRec.release();
      }
      mediaRec = new Media($scope.getMediaURL(src),
        function() {
        },
        // 失败操作
        function(err) {
          //console.log("touchend():Audio Error: " + err.code);
        }
      );

      //开始播放录音
      mediaRec.play();
      mediaRec.stop();

      var counter = 0;
      var timerDur = setInterval(function() {
        counter = counter + 100;
        if (counter > 2000) {
          clearInterval(timerDur);
        }
        var dur = mediaRec.getDuration();
        if (dur > 0 && dur < 10000) {
          clearInterval(timerDur);
          var tmpPath = mediaRec.src;
          if(isIOS){
            tmpPath = path + src;
          }
          tmpPath = tmpPath.replace('file://', '');

          $scope.sendVoiceMessage(tmpPath, dur, false)

          mediaRec.release();
        }
      }, 100);

      $scope.videoMessageText = "按住 说话";
      return false;
    }

    $scope.goBack = function(){
      if ($scope.userListFlag){
        $scope.userListFlag = false;
      }else{
        $scope.currentVadioId = -1
        if (!!$scope.vadioTimer){
          $timeout.cancel($scope.vadioTimer);
        }

        if (!!mediaRec){
          mediaRec.stop();
        }
        $rootScope.goToBack();
      }
    }

    $scope.imgIndex = 0;
    $scope.slideHasChanged = function (index) {
      var lastImg = angular.element('#img-dir-' +$rootScope.currentConversation.targetId+'-'+ ($scope.imgIndex-1));
      var currentImg = angular.element('#img-dir-'+$rootScope.currentConversation.targetId+'-' + $scope.imgIndex);
      var nextImg = angular.element('#img-dir-'+$rootScope.currentConversation.targetId+'-' + ($scope.imgIndex+1));
      if (lastImg.length > 0){
        bigPictureOnLoad(lastImg[0]);
      }
      if (currentImg.length > 0){
        bigPictureOnLoad(currentImg[0]);
      }
      if (nextImg.length > 0){
        bigPictureOnLoad(nextImg[0]);
      }
      $scope.imgIndex = index;
    }

    $scope.count = 0 ;
    $scope.imgsShowList = [];
    $scope.openPicNumber = 0;
    $scope.openOverScreen = function(url){
      $scope.openPicNumber ++;
      $('#message-detail-content-dir').css('top', '0px');
      var index = -1;
      $scope.imgsShowList = $rootScope.currentConversation.imageList.concat();

      for (var i in $scope.imgsShowList){
        if ($scope.imgsShowList[i] == url){
          index = i;
          break;
        }
      }

      $scope.count ++ ;
      //$ionicSlideBoxDelegate.$getByHandle("myActiveSlide2").update() ;
      $ionicSlideBoxDelegate.update() ;
      $ionicSlideBoxDelegate.slide(parseInt(index),0);
      if ($scope.openPicNumber == 1){
        angular.element('.nav-bar-container').hide();
        $scope.isOverScreen = true ;
      }
      $timeout(function(){
        $(".big-picture").css('visibility','visible');
        $ionicSlideBoxDelegate.update() ;
        $ionicSlideBoxDelegate.slide(parseInt(index),0);
        if ($scope.openPicNumber > 1){
          angular.element('.nav-bar-container').hide();
          $scope.isOverScreen = true ;
        }
      },500);
      $scope.imgIndex = index ;
      //第一次点击出现大图时增加事件
      if($scope.count == 1){
        var pinchDragEvent = null;
        var slide = angular.element('#slide-dir-'+$rootScope.currentConversation.targetId) ;
        // 计算拖动开始时两指间距离
        var intervalPinch = 0;
        var startX1 =  0;
        var startY1 =  0;
        var startX2 =  0;
        var startY2 =  0;
        var startDist = 0;
        var isIOS = ionic.Platform.isIOS();
        var intervalPx = 8;
        if (isIOS){
          intervalPx = 15;
        }

        $ionicGesture.on("pinch",function(e){
          var img = angular.element('#img-dir-'+$rootScope.currentConversation.targetId+'-'+$scope.imgIndex) ;
          if (pinchDragEvent == null){
            pinchDragEvent = e;
            // 计算拖动开始时两指间距离
            var startTouch1 = pinchDragEvent.gesture.touches[0];
            var startTouch2 = pinchDragEvent.gesture.touches[1];
            startX1 =  startTouch1.pageX;
            startY1 =  startTouch1.pageY;
            startX2 =  startTouch2.pageX;
            startY2 =  startTouch2.pageY;
            startDist = Math.sqrt(Math.pow((startX2-startX1),2) + Math.pow((startY2-startY1),2));
            return;
          }

          intervalPinch++;
          if (intervalPinch%3 != 0){
            return;
          }

          //// 计算当前两指间距离
          var endTouch1 = e.gesture.touches[0];
          var endTouch2 = e.gesture.touches[1];
          var endX1 =  endTouch1.pageX;
          var endY1 =  endTouch1.pageY;
          var endX2 =  endTouch2.pageX;
          var endY2 =  endTouch2.pageY;
          var endDist = Math.sqrt(Math.pow((endX2-endX1),2) + Math.pow((endY2-endY1),2));
          var left = 0 ;
          var top = 0 ;
          var rate = 1 ;
          var reg = /\-?[0-9]+\.?[0-9]*/g ;

          if (Math.abs(endDist - startDist) > intervalPx){
            if (endDist > startDist){
              var width = screen.width ;
              var length = parseFloat(Math.abs(endDist - startDist)) ;
              var scale = img.css("webkitTransform") ;
              var array = scale.match(reg) ;
              left = parseFloat(array[4]) ;
              top = parseFloat(array[5]) ;
              rate = parseFloat(array[0]);
              var num = rate + parseFloat(length/width) ;
              img.css("webkitTransform","translate("+left+"px,"+top+"px) scale("+num+")") ;
            }else{
              var width = screen.width ;
              var length = parseFloat(Math.abs(endDist - startDist)) ;

              var scale = img.css("webkitTransform") ;
              var array = scale.match(reg) ;
              left = parseFloat(array[4]) ;
              top = parseFloat(array[5]) ;
              rate = parseFloat(array[0]);
              var num = rate - parseFloat(length/width) ;
              if(num >= 1){
                img.css("webkitTransform","translate("+left+"px,"+top+"px) scale("+num+")") ;
              }
            }
          }
          else{
            var x = endX1-startX1 ;
            var y = endY1-startY1 ;
            var scale = img.css("webkitTransform") ;
            var array = scale.match(reg) ;
            left = parseFloat(array[4]) + parseFloat(x);
            top = parseFloat(array[5]) + parseFloat(y);
            rate = parseFloat(array[0]);
            img.css("webkitTransform","translate("+left+"px,"+top+"px) scale("+rate+")") ;
          }
          pinchDragEvent = e;
          var startTouch1 = pinchDragEvent.gesture.touches[0];
          var startTouch2 = pinchDragEvent.gesture.touches[1];
          startX1 =  startTouch1.pageX;
          startY1 =  startTouch1.pageY;
          startX2 =  startTouch2.pageX;
          startY2 =  startTouch2.pageY;
          startDist = Math.sqrt(Math.pow((startX2-startX1),2) + Math.pow((startY2-startY1),2));
        }, slide);
        $ionicGesture.on("release",function(){
          pinchDragEvent = null;
          startX1 =  0;
          startY1 =  0;
          startX2 =  0;
          startY2 =  0;
          startDist = 0;
          intervalPinch = 0;
        }, slide);
      }
    }

    $scope.closeOverScreen = function(){

      var img = angular.element('#img-dir-' +$rootScope.currentConversation.targetId+'-'+ ($scope.imgIndex));
      if (img.length > 0){
        bigPictureOnLoad(img[0]);
      }

      $('#message-detail-content-dir').css('top', '44px');
      angular.element('.nav-bar-container').show();
      $('.rj-stable-content').css('overflow','');
      $scope.isOverScreen = false ;
      $scope.imgsShowList = $rootScope.currentConversation.imageList.concat();
      $ionicSlideBoxDelegate.update() ;
      $ionicSlideBoxDelegate.slide($scope.imgIndex);
    }

    $scope.getUserDetail = function (id) {
      $state.go("menu.userDetail",{'userId':id}) ;
    }

    $scope.showMsgTip = function(id){
      var message = null;
      for (var i in $rootScope.currentConversation.messageList){
        if ($rootScope.currentConversation.messageList[i].messageId == id){
          message = $rootScope.currentConversation.messageList[i];
          break;
        }
      }

      if (!message){
        return;
      }

      var overtime = 30 * 1000;
      var msgSendTime = message.sentTime;
      if (new Date().getTime() - msgSendTime > overtime){
        return;
      }

      var msgTipDivHeight = 40;
      var msgContentTop = $('#messageDiv-'+id).position().top + $ionicScrollDelegate.$getByHandle('messageDetailsScrollTwo').getScrollPosition().top;
      var msgTimeHeight = $('#messageTime-'+id).length > 0 ? 26 : 0;

      var top = msgContentTop - msgTipDivHeight + msgTimeHeight;
      $('#messageTipDiv').css('top', top>0 ? top:0);

      $scope.showMsgTipId = id;
      $scope.showMsgTipFlag=true;
    }

    $scope.hideMsgTip = function(){
      if ($scope.showMsgTipFlag){
        $scope.showMsgTipFlag = false;
      }
    }

    $scope.cancelMessage = function(){
      var index = -1;
      for (var i in $rootScope.currentConversation.messageList){
        if ($rootScope.currentConversation.messageList[i].messageId == $scope.showMsgTipId){
          index = i;
          break;
        }
      }

      RongCloudLibPlugin.deleteMessages({
        messageIds: [$scope.showMsgTipId]
      }, function (ret, err) {
        console.log(JSON.stringify(ret))
      })

      if (index > -1){
        $scope.sendNotificationMessage('CancelMessage-'+$rootScope.currentConversation.messageList[index].content.extra.split(' | ')[0], '"'+ $rootScope.user.nickName +'" 撤回了一条消息');
        $rootScope.currentConversation.messageList.splice(index, 1);
      }
    }

    $scope.textAreaMoveEnd = function(event){
      //console.log("点击事件触发");
      commentService.moveEnd(event.currentTarget.children[0]);
    }

    $scope.$on("groupBannedFlag:open", function(){
      $scope.groupBannedFlag=true;
    })
    $scope.$on("groupBannedFlag:close", function(){
      $scope.groupBannedFlag=false;
    })
    $scope.$on("groupHostFlag:open", function(){
      $scope.isGroupHost=true;
    })
    $scope.$on("groupHostFlag:close", function(){
      $scope.isGroupHost=false;
    })
    $scope.$on("imgMsg", function(){
      if (!$scope.isOverScreen){
        $scope.imgsShowList = $rootScope.currentConversation.imageList.concat();
      }
    })
    $scope.$on("mobile:back", function(){
      if ($scope.userListFlag){
        $scope.userListFlag = false;
      }else{
        $scope.currentVadioId = -1
        if (!!$scope.vadioTimer){
          $timeout.cancel($scope.vadioTimer);
        }

        if (!!mediaRec){
          mediaRec.stop();
        }
      }
    })
  });

