/**
 * Created by douhao on 2016/5/19.
 */
angular.module('personalCenterUp-controller',[])
  .controller('personalCenterUpCtrl',function($scope,$rootScope,$state,$stateParams,UserService,deviceService, ossService,$ionicLoading,showAlertService,rongcloudService){
    $scope.type = $stateParams.type ;
    $scope.isSubmited = true ;

    //初始化地区信息
    $scope.initSwfArea = function(){
      UserService.getSwfArea()
        .then(function(result){
        $scope.LAreaData = result ;
        if($rootScope.user.location !=undefined && $rootScope.user.location != null ){
          var ary =$rootScope.user.location.split(",") ;
          var str = "" ;
          var province = ""
          var city = "" ;
          var area = "" ;
          var sorts = [] ;
          if(ary[0] != undefined){
            province = $scope.LAreaData.filter(function(a) {
              return a.id == ary[0];
            })[0]
          }
          if(ary[1] != undefined && province != undefined){
            city =province.child.filter(function(a) {
              return a.id == ary[1];
            })[0]
          }
          if(ary[2] != undefined && city != undefined){
            area = city.child.filter(function(a) {
              return a.id == ary[0];
            })[0]
          }
          if(province != "" && province != undefined){
            str += province.name ;
            sorts.push(province.sort-1) ;
          }
          if(city != "" && city != undefined){
            str += ","+city.name ;
            sorts.push(city.sort-1) ;
          }
          if(area != "" && area != undefined){
            str += ","+area.name ;
            sorts.push(area.sort-1) ;
          }

          $rootScope.user.swfArea = str==""?$rootScope.user.location:str ;
          $rootScope.user.swfAreaSorts = sorts ;
        }
      })
    }
    $scope.initSwfArea() ;
    //页面加载完成初始化地区选择插件
    $scope.$on('$ionicView.afterEnter', function() {
       UserService.getSwfArea()
        .then(function(result){
           var LAreaData = result ;
           if($scope.type == "location"){
             var area1 = new LArea();
             area1.init({
               'trigger': '#cityname2',
               'valueTo': '#cityvalue2',
               'keys': {
                 id: 'id',
                 name: 'name'
               },
               'type': 1,
               'data': LAreaData
             });
             if($rootScope.user.swfAreaSorts != null && $rootScope.user.swfAreaSorts.length > 0){
               area1.value=$rootScope.user.swfAreaSorts;
             }
           }
        })
    }, false);


    $scope.user_update = {
      id: $rootScope.user.id ,
      personalImage: $rootScope.user.personalImage,
      name: $rootScope.user.name,
      password: "" ,
      newPassword:"",
      confirmPwd: "" ,
      nickName: $rootScope.user.nickName,
      email: $rootScope.user.email,
      location: $rootScope.user.location,
      swfArea:$rootScope.user.swfArea,
      hospital: $rootScope.user.hospital,
      department: $rootScope.user.department,
      introduction:$rootScope.user.introduction,
      specialtyPaper:$rootScope.user.specialtyPaper,
    }

    $scope.focusInput = function(){
      $scope.isChecked = false;
    }

    $scope.submit = function(){
      //console.log($scope.user_update) ;
      $scope.isChecked = true ;
      if($scope.myForm.$error.required != undefined && $scope.myForm.$error.required.length > 0){
        for(var i in $scope.myForm.$error.required){
          $scope.myForm.$error.required[i].$dirty = true ;
        }
        return ;
      }
      if($scope.myForm.$error.pattern != undefined && $scope.myForm.$error.pattern.length > 0){
        for(var i in $scope.myForm.$error.pattern){
          $scope.myForm.$error.pattern[i].$dirty = true ;
        }
        return ;
      }
      if($scope.type == "location"){
        $scope.user_update.location = angular.element("#cityvalue2")[0].value ;
      }
      UserService.updateUserBaseInfo($scope.user_update)
        .then(function(result){
          $rootScope.user.name = $scope.user_update.name ;
          $rootScope.user.nickName = $scope.user_update.nickName ;
          $rootScope.user.email = $scope.user_update.email ;
          $rootScope.user.location = $scope.user_update.location ;
          $rootScope.user.swfArea = $scope.user_update.swfArea ;
          $rootScope.user.hospital = $scope.user_update.hospital ;
          $rootScope.user.department = $scope.user_update.department ;
          $rootScope.user.introduction = $scope.user_update.introduction ;
          $rootScope.user.specialtyPaper = $scope.user_update.specialtyPaper ;
          $rootScope.goToBack() ;
        })
    }
    $scope.updatePersonalImage = function(){
      //更改数据库头像地址
      UserService.updatePersonalImage($rootScope.user.id,$scope.user_update.personalImage)
        .then(function(result){
          $rootScope.user.personalImage = $scope.user_update.personalImage;
          $rootScope.goToBack() ;
        })
    }

    $scope.updatePassword = function(){
      //判断form表单是否有输入错误
      $scope.isChecked = true ;
      if($scope.myForm.$error.required != undefined && $scope.myForm.$error.required.length > 0){
        for(var i in $scope.myForm.$error.required){
          $scope.myForm.$error.required[i].$dirty = true ;
        }
        return ;
      }
      if($scope.myForm.$error.pattern != undefined && $scope.myForm.$error.pattern.length > 0){
        for(var i in $scope.myForm.$error.pattern){
          $scope.myForm.$error.pattern[i].$dirty = true ;
        }
        return ;
      }
      if($scope.isEmptyObj($scope.myForm.$error)){
          if($scope.user_update.newPassword == $scope.user_update.confirmPwd){
            //修改密码
            UserService.updatePassword($rootScope.user.id,$scope.user_update.password,$scope.user_update.newPassword)
              .then(function(result){
                if (result.code == 0){
                  $scope.isChecked = false;
                  $scope.user_update.password = '';
                  $scope.user_update.newPassword = '';
                  $scope.user_update.confirmPwd = '';
                  rongcloudService.logout();
                  UserService.logoutApp();
                }else if (result.code == 40015){
                  showAlertService.PopAlert("提示信息","原密码错误，不能修改密码！","确认","") ;
                }
              })
          }
      }
    }

    $scope.isEmptyObj = function(obj){
      if (typeof obj === "object" && !(obj instanceof Array)){
        var hasProp = false;
        for (var prop in obj){
          hasProp = true;
          break;
        }
        if (hasProp){
          return false ;
        }else{
          return true;
        }
      }
    }



    $scope.personImgInfo = {
      imgList : [],
      imgUrl : ''
    }

    $scope.uploadPersonImg = {
      accessid : '',
      accesskey : '',
      host : '',
      policyBase64 : '',
      signature : '',
      expire : 0,
      key : '',
      callbackbody : '',
      finalFileName : ''
    };

    $scope.uploadPersonImg.sendRequest = function() {
      var xmlhttp = null;
      if (window.XMLHttpRequest) {
        xmlhttp = new XMLHttpRequest();
      } else if (window.ActiveXObject) {
        xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
      }

      if (xmlhttp!=null) {
        var serverUrl = config.new_url+"/oss/signature?imgType=personalImg&userId="+$rootScope.user.id
        xmlhttp.open( "GET", serverUrl, false);
        xmlhttp.send(null);
        return xmlhttp.responseText
      } else {
        alert("Your browser does not support XMLHTTP.");
      }
    };

    $scope.uploadPersonImg.getOssSignature = function ()
    {
      //可以判断当前expire是否超过了当前时间,如果超过了当前时间,就重新取一下.3s 做为缓冲
      var now = Date.parse(new Date()) / 1000;
      if ($scope.uploadPersonImg.expire < now + 3)
      {
        var response = $scope.uploadPersonImg.sendRequest();
        var result = eval ("(" + response + ")");
        $scope.uploadPersonImg.accessid = result.result.accessid;
        $scope.uploadPersonImg.host = result.result.host;
        $scope.personImgInfo.imgUrl = result.result.host;
        $scope.uploadPersonImg.policyBase64 = result.result.policy;
        $scope.uploadPersonImg.signature = result.result.signature;
        $scope.uploadPersonImg.expire = parseInt(result.result.expire);
        $scope.uploadPersonImg.key = result.result.dir;
        $scope.uploadPersonImg.callbackbody = result['callback']
      }
    };

    $scope.uploadPersonImg.randomString = function(len) {
      len = len || 32;
      var chars = 'ABCDEFGHJKMNPQRSTWXYZabcdefhijkmnprstwxyz2345678';
      var maxPos = chars.length;
      var pwd = '';
      for (var i = 0; i < len; i++) {
        pwd += chars.charAt(Math.floor(Math.random() * maxPos));
      }
      return pwd;
    }

    $scope.uploadPersonImg.getFileSuffix = function (filename) {
      var pos = filename.lastIndexOf('.')
      var suffix = ''
      if (pos != -1) {
        suffix = filename.substring(pos)
      }
      return suffix;
    }

    $scope.uploadPersonImg.calculateFileName = function (filename)
    {
      var suffix = $scope.uploadPersonImg.getFileSuffix(filename);
      $scope.uploadPersonImg.finalFileName = $scope.uploadPersonImg.key + $scope.uploadPersonImg.randomString(36) + suffix;
    }

    $scope.uploadPersonImg.setUploadParam = function(up, filename, ret)
    {
      if (!ret){
        $scope.uploadPersonImg.getOssSignature();
      }else{
        if (filename != '') {
          $scope.uploadPersonImg.calculateFileName(filename);
        }
      }

      var new_multipart_params = {
        'key' : $scope.uploadPersonImg.finalFileName,
        'policy': $scope.uploadPersonImg.policyBase64,
        'OSSAccessKeyId': $scope.uploadPersonImg.accessid,
        'success_action_status' : '200', //让服务端返回200,不然，默认会返回204
        'callback' :  $scope.uploadPersonImg.callbackbody,
        'signature':  $scope.uploadPersonImg.signature,
      };

      up.setOption({
        'url': $scope.uploadPersonImg.host,
        'multipart_params': new_multipart_params
      });

      up.start();
    }

    $scope.show = function() {
      //$ionicLoading.show({
      //  template: '更换中...'
      //});
      $scope.isSubmited = false ;
    };
    $scope.hide = function(){
      $scope.isSubmited = true ;
    };

    $scope.uploadPersonImg.uploader = new plupload.Uploader({
      runtimes : 'html5,flash,silverlight,html4',
      browse_button : 'selectImgButton',
      multi_selection: false,
      url : 'http://oss.aliyuncs.com',

      filters: {
        mime_types : [
          { title : "Image files", extensions : "jpg,gif,png,bmp,jpeg" },
        ],
        max_file_size : '10mb',//最大图片大小
        prevent_duplicates : true//不允许选择重复的图片
      },

      init: {
        //PostInit: function() {
        //  document.getElementById('ossfile').innerHTML = '';
        //  document.getElementById('postfiles').onclick = function() {
        //    set_upload_param(uploader, '', false);
        //    return false;
        //  };
        //  $scope.uploadPersonImg.setUploadParam(up, '', false);
        //
        //},
        upload:function(){
          $scope.uploadPersonImg.setUploadParam(up, '', false);
        },

        FilesAdded: function(up, files) {
          $scope.isSubmited = false ;
          $scope.$apply();
          plupload.each(files, function(file) {
            //if(up.files.length > 1){
            //  up.files.splice(0, 1);
            //}
            $scope.uploadPersonImg.setUploadParam(up, file.name, false);
          });
        },

        BeforeUpload: function(up, file) {
          $scope.uploadPersonImg.setUploadParam(up, file.name, true);
        },

        FileUploaded: function(up, file, info) {
          if (info.status == 200) {
            $scope.personImgInfo.imgList = $scope.uploadPersonImg.finalFileName;
            $scope.user_update.personalImage = $scope.personImgInfo.imgUrl.replace('oss', 'img') + $scope.personImgInfo.imgList ;
            up.files = [];
            $scope.isSubmited = true ;
            $scope.$digest();
          } else {
            alert(info.response)
            //$scope.hide() ;
          }
        },

        Error: function(up, err) {
          if (err.code == -600) {
            alert("文件大小超过10M");
          } else if (err.code == -601) {
            alert("只支持图片类型");
          } else if (err.code == -602) {
            alert("不能重复上传文件");
          } else {
            //alert(err.response);
            $scope.isSubmited = true ;
          }
        }
      }
    });

    $scope.uploadPersonImg.uploader.init();
  })
