/**
 * Created by douhao on 2016/5/20.
 */
angular.module('personalChallenge-controller',[])
  .controller('personalChallengeCtrl',function($scope,$rootScope,$state,$ionicSlideBoxDelegate,UserService,caseService,$ionicPopup,$ionicModal,showAlertService,viewService,$sce,$ionicScrollDelegate,$timeout,HomeService){

    $scope.challageStyle = {top: '80px'};
    if (ionic.Platform.isIOS()){
      $scope.challageStyle = {top: '100px'};
    }

    var url = location.href.split('#')[0];
    $scope.params = {
      hasmore : true ,
      from : 1 ,
      pageSize : 10,
    };

    var challengeRecordsContent = $ionicScrollDelegate.$getByHandle('challengeRecordsContent');
    var challengeScroll = $ionicScrollDelegate.$getByHandle('challengeScroll');
    $scope.isVisibleChallenge = false ;
    $scope.isVisible = false ;

    $scope.records = [] ;
    $scope.img_url = img.case_url ;
    $scope.isActive = UserService.getChallengeIsActive() ;
    //$ionicSlideBoxDelegate.$getByHandle('challenge-slide').stop();
    $scope.toSlide = function(index){
      $scope.isActive = index == 0 ?true:false;
      UserService.setChallengeIsActive($scope.isActive) ;
      //$ionicSlideBoxDelegate.$getByHandle('challenge-slide').slide(index);
    };
    //挑战题目id list
    $scope.caseIdList = [] ;
    //挑战题目数量
    $scope.caseNum = 5 ;
    //正确答案
    $scope.trueAnswer = "" ;
    //当前的case
    $scope.currentCase = "" ;
    //匿名用户
    $scope.annoyUserId = "" ;
    //问题
    $scope.question = "" ;
    //选择
    $scope.choose = "" ;
    $scope.challenge_result = [] ;
    $scope.wrong_result = [] ;
    $scope.challenge = {
      caseIdList:[] ,
      caseNum: 5 ,
      currentCase: "" ,
      annoyUserId: "" ,
      answers: "" ,
      choose: "",
      trueAnswer: "",
      paperId: "" ,
      wrongNum: "" ,
      questionType: "",
      isAnswerEnd: false
    };
    $scope.isSubmited = true ;

    $scope.GenerateUuid = function() {
      return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
        var r = Math.random()*16|0, v = c == 'x' ? r : (r&0x3|0x8);
        return v.toString(16);
      });
    };

    //查询分享地址
    if($rootScope.share_urls == undefined){
      UserService.getConfByType('share')
          .then(function(result){
            if(result.success){
              $rootScope.share_urls= result.result ;
            }
          })
    }


    //更改图片路径
    $scope.changeChallengeImgUrl = function(list){
      var img_path = "/jpeg" ;
      for(var i in list.studiesList['a1']['a1']){
        var imgUrl = list.studiesList['a1']['a1'][i].thumbnail ;
        if(!imgUrl){
          list.studiesList['a1']['a1'][i].thumbnail = "img/study/no_learn.png";
          list.studiesList['a1']['a1'][i].imageUrl = "img/study/no_learn.png";
        }else{
          if(imgUrl.substr(0,7)!="http://" && imgUrl.substr(0,8)!="https://"){
            list.studiesList['a1']['a1'][i].thumbnail = $scope.img_url +"/" +list.studiesList['a1']['a1'][i].caseInfoId +img_path +"/"+imgUrl ;
            list.studiesList['a1']['a1'][i].imageUrl = $scope.img_url +"/" +list.studiesList['a1']['a1'][i].caseInfoId +img_path +"/"+imgUrl ;
          }else{
            list.studiesList['a1']['a1'][i].thumbnail = list.studiesList['a1']['a1'][i].thumbnail ;
            list.studiesList['a1']['a1'][i].imageUrl = list.studiesList['a1']['a1'][i].thumbnail ;
          }
        }
      }
      return list;
    }


    //更改图片路径
    $scope.changeImgUrl = function(list){
      var img_path = "/jpeg" ;
      for(var i in list){
        var imgUrl = list[i].thumbnail ;
        if(!imgUrl){
          list.imgUrl.thumbnail = "img/study/no_learn.png";
        }else{
          if(imgUrl.substr(0,7)!="http://" && imgUrl.substr(0,8)!="https://"){
            list[i].thumbnail = $scope.img_url +"/" +"/"+imgUrl ;
          }
        }
      }
      return list;
    }

    $scope.isRight = 0 ;
    $scope.recordsType = UserService.getChallengeRecordsType() ;
    $scope.isOpen = [] ;
    //切换按题集 试题
    $scope.switchType = function(){
      challengeRecordsContent.scrollTop() ;
      $scope.recordsType = $scope.recordsType == 0 ?1:0;
      UserService.setChallengeRecordsType($scope.recordsType) ;
      $scope.doRefresh() ;
    }
    $scope.switchIsRight = function(){
      challengeRecordsContent.scrollTop() ;
      $scope.isRight = $scope.isRight == 0 ?1:0;
      $scope.doRefresh() ;
    }
    $scope.switchStatus = function(index){
      //$scope.isOpen20161024182611 = true ;
      $scope.isOpen[index] = !$scope.isOpen[index] ;
      challengeRecordsContent.resize();
    }
    //刷新记录
    $scope.doRefresh = function(){
      UserService.getChallengeRecords($rootScope.user.id,$scope.recordsType,$scope.isRight,1,$scope.params.pageSize)
        .then(function(result) {
          $scope.params = {
            hasmore : true ,
            from : 1 ,
            pageSize : 10,
          }
          $scope.records = [] ;
          for (var i in result.result){
            if (!!result.result[i]){
              $scope.records.push(result.result[i]);
            }
          }
          if($scope.recordsType == 0){
            $scope.isOpen = [] ;
            for(var i = 0 ;i < result.result.length ; i++){
              $scope.isOpen.push(false) ;
            }
          }
          if(result.result.length < $scope.params.pageSize){
            $scope.params.hasmore = false;
          }else{
            $scope.params.from ++ ;
          }
          $scope.$broadcast('scroll.refreshComplete');
        })
    }

    //加载记录
    $scope.loadMoreRecord = function(){
      UserService.getChallengeRecords($rootScope.user.id,$scope.recordsType,$scope.isRight,$scope.params.from,$scope.params.pageSize)
        .then(function(result){
          for (var i in result.result){
            if (!!result.result[i]){
              $scope.records.push(result.result[i]);
            }
          }
          if($scope.recordsType == 0){
            for(var i = 0 ;i < result.result.length ; i++){
              $scope.isOpen.push(false) ;
            }
          }
          $scope.$broadcast('scroll.infiniteScrollComplete');
          if(result.result.length < $scope.params.pageSize){
            $scope.params.hasmore = false;
          }
          $scope.params.from ++ ;
        })
    }

    //获取挑战赛题目ID
    //$scope.getCaseIds = function(){
    //  UserService.getCaseIds($scope.challenge.caseNum)
    //    .then(function(result){
    //      angular.forEach(result, function(data,index,array) {
    //        $scope.challenge.paperId = index ;
    //        angular.forEach(data, function(id,index,array) {
    //          $scope.challenge.caseIdList.push(id) ;
    //        })
    //      })
    //      $scope.getCaseInfoById($scope.challenge.caseIdList[0]);
    //      $scope.getAnswerById($scope.challenge.caseIdList[0]) ;
    //      //console.log($scope.challenge.caseIdList) ;
    //    })
    //}

    //根据题目id获得答案
    //$scope.getAnswerById = function(caseId){
    //  $scope.challenge.trueAnswer = "" ;
    //  caseService.findQuestionByCaseId(caseId)
    //    .then(function(result){
    //      $scope.challenge_result = result ;
    //      angular.forEach(result,function(data,index,array){
    //        if("y" == data.isTrue){
    //          $scope.challenge.trueAnswer += ""+data.orderby+'、'+data.content+";"
    //        }
    //      })
    //      $scope.isSubmited = true ;
    //    })
    //}

    /** view 相关功能开始， 需要使用view的模块都需要提供以下功能**/
    $scope.view = {};
    $scope.view.oper = {
      maxId: '',
      caseType: 'jd'
    };
    $scope.view.showView = false;
    $scope.view.init = function(list, caseId){
      $scope.view.imgList = list;
      $scope.view.imgCount = list.length;
      $scope.view.showID = 1;
      $scope.view.showView = false;
      $scope.view.oper.caseId = caseId;
    }

    $scope.view.openView = function(index) {
      $scope.view.showView = true;
      $scope.view.showID = 1 + index;
      angular.element('.nav-bar-container').hide();

      $scope.view.oper.maxId = getUUID();
      viewService.addViewerOperLog($scope.view.oper.caseType, $scope.view.oper.caseId,"大图按钮", "点击大图", $scope.view.oper.maxId)
    }

    /** view 相关功能结束**/

    //根据题目id获取case信息
    //$scope.getCaseInfoById = function(caseId){
    //  caseService.findByCaseId(caseId)
    //    .then(function(result){
    //      $scope.challenge.currentCase = $scope.changeChallengeImgUrl(result.result) ;
    //      $scope.challenge.questionType = result.result.questionType ;
    //      $scope.isSubmited = true ;
    //      // 初始化view
    //      $scope.view.init(result.result.studiesList['a1']['a1'], caseId);
    //      //滑动框model修改后，需要刷新并滑动到第一页
    //      $ionicSlideBoxDelegate.$getByHandle("myChallengeSlide").update() ;
    //      $ionicSlideBoxDelegate.$getByHandle('myChallengeSlide').slide(0) ;
    //    })
    //}

    //存入错题库
    //$scope.addWrong = function(userId,caseId,rightAnswer,chooseAnswer,paperId){
    //  UserService.addWrong(userId,caseId,rightAnswer,chooseAnswer,paperId)
    //    .then(function(result){
    //      //if($scope.challenge.caseIdList.length == 0){
    //      //  $scope.userRandomWrong(userId,$scope.challenge.paperId);
    //      //}
    //      //caseIdList 删  除已答题目
    //      $scope.challenge.caseIdList.splice(0,1) ;
    //
    //      if($scope.challenge.caseIdList.length <= 0) {
    //        if ($rootScope.user.id == "" || $rootScope.user.id == undefined || $rootScope.user.id == 0) {
    //          $scope.selectRandomWrong($scope.challenge.annoyUserId, $scope.challenge.paperId);
    //        } else {
    //          $scope.userRandomWrong($rootScope.user.id, $scope.challenge.paperId);
    //        }
    //      }else{
    //        $scope.getCaseInfoById($scope.challenge.caseIdList[0]) ;
    //        $scope.getAnswerById($scope.challenge.caseIdList[0]) ;
    //      }
    //    })
    //}

    //存入临时表错题库
    //$scope.addRandomWrong = function(userId,caseId,rightAnswer,chooseAnswer,paperId){
    //  UserService.addRandomWrong(userId,caseId,rightAnswer,chooseAnswer,paperId)
    //    .then(function(result){
    //      //if($scope.challenge.caseIdList.length == 0){
    //      //  $scope.selectRandomWrong(userId,$scope.challenge.paperId);
    //      //}
    //      //caseIdList 删  除已答题目
    //      $scope.challenge.caseIdList.splice(0,1) ;
    //
    //      if($scope.challenge.caseIdList.length <= 0) {
    //        if ($rootScope.user.id == "" || $rootScope.user.id == undefined || $rootScope.user.id == 0) {
    //          $scope.selectRandomWrong($scope.challenge.annoyUserId, $scope.challenge.paperId);
    //        } else {
    //          $scope.userRandomWrong($rootScope.user.id, $scope.challenge.paperId);
    //        }
    //      }else{
    //        $scope.getCaseInfoById($scope.challenge.caseIdList[0]) ;
    //        $scope.getAnswerById($scope.challenge.caseIdList[0]) ;
    //      }
    //    })
    //}

    //用户登录，查询错题信息
    //$scope.userRandomWrong = function(userId,paperId){
    //  UserService.userRandomWrong(userId,paperId)
    //    .then(function(result){
    //      $scope.challenge.wrongNum = result ;
    //      //显示结果页面
    //      $scope.challenge.isAnswerEnd = true ;
    //      $scope.challengeNum($rootScope.user.id,$scope.challenge.caseNum-result,$scope.challenge.wrongNum) ;
    //      for(var i = 0 ; i < $scope.challenge.caseNum - $scope.challenge.wrongNum ; i ++){
    //        $scope.challenge_result.push(i) ;
    //      }
    //      for(var i = 0 ; i < $scope.challenge.wrongNum ; i ++){
    //        $scope.wrong_result.push(i) ;
    //      }
    //      $scope.isSubmited = true ;
    //      //显示结果页面
    //      $scope.showConfirm() ;
    //    })
    //}

    //用户未登录,查询临时表信息
    //$scope.selectRandomWrong = function(userId,paperId){
    //  UserService.selectRandomWrong(userId,paperId)
    //    .then(function(result){
    //      $scope.challenge.wrongNum = result ;
    //      //显示结果页面
    //      $scope.challenge.isAnswerEnd = true ;
    //      $scope.challengeNum(0,$scope.challenge.caseNum-result,$scope.challenge.wrongNum) ;
    //      for(var i = 0 ; i < $scope.challenge.caseNum - $scope.challenge.wrongNum ; i ++){
    //        $scope.challenge_result.push(i) ;
    //      }
    //      for(var i = 0 ; i < $scope.challenge.wrongNum ; i ++){
    //        $scope.wrong_result.push(i) ;
    //      }
    //      $scope.isSubmited = true ;
    //      //显示结果页面
    //      $scope.showConfirm() ;
    //    })
    //}

    //添加挑战信息
    $scope.challengeNum = function(userId,rightNum,errorNum){
      UserService.ChallengeNum(userId,rightNum,errorNum)
        .then(function(result){

        })
    }


    //初始化信息
    $scope.init = function(){
      //$scope.caseIdList = [] ;
      //$scope.challenge_result = [] ;
      //$scope.wrong_result = [] ;
      //$scope.challenge = {
      //  caseIdList:[] ,
      //  caseNum: 5 ,
      //  currentCase: "" ,
      //  annoyUserId: "" ,
      //  answers: "" ,
      //  choose: "",
      //  trueAnswer: "",
      //  paperId: "" ,
      //  wrongNum: "" ,
      //  questionType: "",
      //  isAnswerEnd: false
      //}
      //if($rootScope.user.id == "" || $rootScope.user.id == undefined || $rootScope.user.id == 0){
      //  if($scope.challenge.annoyUserId == ""){
      //    $scope.challenge.annoyUserId  = 'NM_' + $scope.GenerateUuid() ;
      //  }
      //}
      //$scope.getCaseIds() ;
      $scope.cases =  [],
      $scope.questions = [];
      $scope.casesResult = [] ;
      $scope.caseCount = 5 ;
      $scope.caseIds = "" ;
      $scope.paperId = "" ;
      $scope.trueAnswer = "" ;
      $scope.rightResult = [] ;
      $scope.wrongResult = [] ;
      $scope.currentIndex = 0 ;
      $scope.isSubmited = true ;
      $scope.currentCase = [] ;
      $scope.currentQuestion = [] ;
      UserService.getChallengeCases($scope.caseCount,$scope.dpTag,"","",$scope.recuitFlag)
          .then(function(result){
            if(result.code == 0){
              $scope.caseCount = result.result.cases.length ;
              $scope.paperId = result.result.paperId ;
              $scope.cases = result.result.cases ;
              for(var i = 0 ; i < $scope.cases.length ; i ++){
                $scope.caseIds += $scope.cases[i].caseId + "," ;
              }
              if($scope.cases.length <= 0){
                showAlertService.loadingHide() ;
                $rootScope.$broadcast('message',"题库没有题目,请联系管理员!",3000,"error");
              }else{
                $scope.caseIds = $scope.caseIds.substring(0,$scope.caseIds.length-1) ;
                $scope.currentCase = $scope.cases[$scope.currentIndex] ;
                $scope.currentCase.impressions = $sce.trustAsHtml($scope.currentCase.impressions.replace(/<\/?font[^>]*>/gi,"")) ;
                $scope.currentCase.interpretation = $sce.trustAsHtml($scope.currentCase.interpretation.replace(/<\/?font[^>]*>/gi,"")) ;
                $scope.view.init($scope.currentCase.images, $scope.currentCase.caseId);
                UserService.getChallengeQuestions($scope.caseIds)
                    .then(function(result){
                      if(result.code == 0){
                        $scope.isVisibleChallenge = true ;
                        for(var i = 0 ; i < $scope.cases.length; i ++){
                          var caseId = $scope.cases[i].caseId ;
                          for(var j = 0 ; j < result.result.length; j ++){
                            if(caseId == result.result[j].caseId){
                              $scope.questions.push(result.result[j]) ;
                            }
                          }
                        }
                        showAlertService.loadingHide() ;
                        $scope.currentQuestion = $scope.questions[$scope.currentIndex] ;
                      }else{
                        $rootScope.$broadcast('message',"获取信息失败，请重新获取!",3000,"error");
                        showAlertService.loadingHide() ;
                      }
                    },function(){
                      $rootScope.$broadcast('message',"获取信息失败，请重新获取!",3000,"error");
                      showAlertService.loadingHide() ;
                    })
              }
            }else{
              $rootScope.$broadcast('message',"获取信息失败，请重新获取!",3000,"error");
              showAlertService.loadingHide() ;
            }
          },function(){
           $rootScope.$broadcast('message',"获取信息失败，请重新获取!",3000,"error");
            showAlertService.loadingHide() ;
          })
    }

    //提交事件
    $scope.submitAnswer = function(choice){
      //$scope.isSubmited = false ;
      //var checkChoice = "" ;
      //for(var i in choice){
      //  if(choice[i].checked != undefined && choice[i].checked == true){
      //    checkChoice += choice[i].orderby + '、' + choice[i].content + ";";
      //  }
      //  if(choice[i].clientSide != undefined){
      //    checkChoice = choice[i].clientSide + '、' + choice[i].content + ";";
      //  }
      //}
      //
      ////是否答对
      //if(checkChoice != $scope.challenge.trueAnswer){
      //  //判断用户是否登录  登录，存入错题库  未登录，存入临时错题库
      //  if($rootScope.user.id == "" || $rootScope.user.id == undefined || $rootScope.user.id == 0){
      //    $scope.addRandomWrong($scope.challenge.annoyUserId,$scope.challenge.caseIdList[0],$scope.challenge.trueAnswer,checkChoice,$scope.challenge.paperId)
      //  }else{
      //    $scope.addWrong($rootScope.user.id,$scope.challenge.caseIdList[0],$scope.challenge.trueAnswer,checkChoice,$scope.challenge.paperId)
      //  }
      //}else{
      //  //答对题
      //  $scope.challenge.caseIdList.splice(0,1) ;
      //
      //  if($scope.challenge.caseIdList.length <= 0) {
      //    if ($rootScope.user.id == "" || $rootScope.user.id == undefined || $rootScope.user.id == 0) {
      //      $scope.selectRandomWrong($scope.challenge.annoyUserId, $scope.challenge.paperId);
      //    } else {
      //      $scope.userRandomWrong($rootScope.user.id, $scope.challenge.paperId);
      //    }
      //  }else{
      //    $scope.getCaseInfoById($scope.challenge.caseIdList[0]) ;
      //    $scope.getAnswerById($scope.challenge.caseIdList[0]) ;
      //  }
      //}
      $ionicSlideBoxDelegate.$getByHandle("myChallengeSlide").update() ;
      $scope.isSubmited = false ;
      var checkChoice = "" ;
      for(var i in choice){
        if(choice[i].checked != undefined && choice[i].checked == true){
          checkChoice += choice[i].orderby + '、' + choice[i].content + ";";
        }
        if(choice[i].clientSide != undefined){
          checkChoice = choice[i].clientSide + '、' + choice[i].content + ";";
        }
      }

      if(checkChoice == ""){
        $scope.isSubmited = true ;
        showAlertService.PopShow("提示消息","请选择答案!",1000) ;
        return ;
      }

      angular.forEach($scope.currentQuestion.questions,function(data,index,array){
        if("y" == data.isTrue){
          $scope.trueAnswer += ""+data.orderby+'、'+data.content+";"
        }
      })

      if(checkChoice == $scope.trueAnswer){
        $scope.isRight = 0 ;
        $scope.rightResult.push("0") ;
      }else{
        $scope.isRight = 1 ;
        $scope.wrongResult.push("1") ;
      }
      $scope.currentCaseResult = {
        "userId":$rootScope.user.id,
        "caseId":$scope.currentCase.caseId,
        "type":1,
        "rightAnswer":$scope.trueAnswer,
        "chooseAnswer":checkChoice,
        "isRight":$scope.isRight,
        "paperId":$scope.paperId
      } ;
      $scope.casesResult.push($scope.currentCaseResult) ;
      if($scope.currentIndex >= ($scope.caseCount-1)){
        $scope.share();
        $scope.showConfirm() ;
        $scope.challengeNum(0,$scope.rightResult.length,$scope.wrongResult.length) ;
        $scope.postAnswer() ;
      }else{
        $scope.currentIndex += 1 ;
        $scope.trueAnswer = "" ;
        $scope.currentCase =  $scope.cases[$scope.currentIndex] ;
        $scope.currentQuestion =  $scope.questions[$scope.currentIndex] ;
        // 初始化view
        $scope.view.init($scope.currentCase.images, $scope.currentCase.caseId);
        //滑动框model修改后，需要刷新并滑动到第一页
        $ionicSlideBoxDelegate.$getByHandle("myChallengeSlide").update() ;
        $ionicSlideBoxDelegate.$getByHandle('myChallengeSlide').slide(0) ;
        //challengeScroll.resize() ;
        challengeScroll.scrollTop() ;
        $scope.adjustSlideHeight(0) ;
      }

      $scope.isSubmited = true ;
    }

    //  confirm 对话框
    var confirmPopup ;
    $ionicModal.fromTemplateUrl('templates/personal/challenge/challenge_result.html', {
      scope: $scope,
      animation: 'slide-in-show'
    }).then(function(modal) {
      $scope.modal = modal;
    });
    $scope.showConfirm = function() {
      //显示绑定信息
      if($scope.user.id <= 0){
        $scope.isVisible = true ;
      }else{
        $scope.modal.show() ;
      }
    };

    //监控isVisible变化，显示结果信息
    $scope.$watch('isVisible',function(newValue,oldValue){
      if(newValue == false && oldValue == true && $scope.isRegisterSuccess == true){
        $scope.isVisible = true ;
        $scope.modal.show() ;
      }
    })
    //监控isVisibleChallenge变化，显示导航栏
    $scope.$watch('isVisibleChallenge',function(newValue,oldValue){
      if(newValue){
        //angular.element('.nav-bar-container').hide();
      }else{
        angular.element('.nav-bar-container').show();
      }
    })

    $scope.$on('$ionicView.beforeLeave', function() {
      $scope.isVisibleChallenge = false ;
      $scope.isVisible = false ;
    }, false);

    $scope.exit = function(){
      $scope.modal.hide() ;
      $scope.isRegisterSuccess = false ;
      $scope.isVisible = false ;
      $scope.isVisibleChallenge=false;
    }

    //开始挑战
    $scope.startChallenge = function(type){
      //if($scope.modal != null){
      //  $scope.modal.hide() ;
      //}
      //$scope.init() ;
      //$scope.challenge.isAnswerEnd = false ;
      //$scope.params.isVisibleChallenge = true ;
      $scope.dpTag = type ;
      //是否招募赛 0：否，1：是
      $scope.recuitFlag = 0 ;
      showAlertService.loadingShow() ;
      $scope.modal.hide() ;
      $scope.isVisibleChallenge=false;
      $scope.isRegisterSuccess = false ;
      $scope.isVisible = false ;
      $timeout(function(){
        $scope.init() ;
        $scope.$apply() ;
      },500) ;
    }

    $scope.postAnswer = function(){
      UserService.postChallengeAnswer($scope.casesResult)
          .then(function(){

          },function(){
            $scope.isSubmited = true ;
          })
    }

    $scope.adjustSlideHeight = function(index){
      adjustSlideHeight(angular.element("#caseSlide .img")[index], false);
    }

    //分享
    $scope.share_header = "https://open.weixin.qq.com/connect/oauth2/authorize?appid=wx6939749493987808&redirect_uri=" ;
    $scope.share_footer = "&response_type=code&scope=snsapi_userinfo#wechat_redirect" ;
    $scope.isShare = false ;
    $scope.share = function(type){
      if (type != 0 && type != 1){
        return;
      }

      $scope.isShare = false ;
      for(var i in $rootScope.share_urls){
        if($rootScope.share_urls[i].confKey == "share_challengeresult"){
          $scope.shareUrl = $rootScope.share_urls[i].confValue.replace("{userImage}",$rootScope.user.personalImage).replace("{nickname}",$rootScope.user.nickName).replace("{wrongNum}",$scope.wrongResult.length).replace("{rightNum}",$scope.rightResult.length);
        }
      }
      //alert("$scope.shareUrl="+$scope.shareUrl) ;
      //分享参数
      switch(type){
        case 0:
          $scope.scene = Wechat.Scene.SESSION;
          break ;
        case 1:
          $scope.scene = Wechat.Scene.TIMELINE;
          break ;
      }
      Wechat.isInstalled(function (installed) {
        if(installed == "No"){
          $scope.isShare = false ;
          showAlertService.PopAlert("提示信息","请先安装微信再分享","确认","") ;
          return ;
        }else{
          Wechat.share({
            message:{
              title: "影领挑战",
              description: "我在影领挑战中答对"+$scope.rightResult.length+"道题，很有料，快来挑战吧...",
              thumb: img.shareChallengeImg,
              mediaTagName: "影领-TAG-001",
              messageExt: "影领",
              messageAction: "<action>dotalist</action>",
              media: {
                type:Wechat.Type.LINK ,
                webpageUrl:$scope.share_header+encodeURIComponent($scope.shareUrl)+$scope.share_footer
              }
            },
            scene: $scope.scene
          }, function () {
            HomeService.addShareRecord($rootScope.user.id,$rootScope.user.id,7,$scope.shareUrl)
              .then(function(result){
              }) ;
          }, function (reason) {
          });
        }
      });
    }
    //显示分享
    $scope.showShare = function() {
      $scope.isShare = true ;
    };
    //取消分享
    $scope.cancelShare = function(){
      $scope.isShare = false ;
    }
  })
