/**
 * Created by douhao on 2016/5/4.
 */
angular.module('personalCollect-controller',[])
  .controller('personalCollectCtrl',function($scope,$rootScope,$state,$ionicHistory,UserService,$ionicSideMenuDelegate,showAlertService){
    $scope.case_params = {
      hasmore : true ,
      from : 1 ,
      pageSize : 10,
    }
    $scope.community_params = {
      hasmore : true,
      from : 1 ,
      pageSize : 10,
    }
    $scope.video_params = {
      hasmore : true ,
      from : 1 ,
      pageSize : 10,
    }
    $scope.community_img_url = img.url ;
    $scope.case_img_url = img.case_url ;
    $scope.img_learnPicUrl = img.learnPicUrl ;
    $scope.cases = [] ;
    $scope.communitys = [] ;
    $scope.videos = [] ;

    $scope.changeVideoImgUrl = function(list){
      for(var i in list){
        if(!list[i].dataLearnPic){
          list[i].dataLearnPic = "img/study/no_learn.png";
        }else{
          if(list[i].dataLearnPic.substr(0,7)!="http://" && list[i].dataLearnPic.substr(0,8)!="https://"){
            list[i].dataLearnPic = $scope.img_learnPicUrl + list[i].dataLearnPic;
          }else{
            list[i].dataLearnPic = list[i].dataLearnPic.replace("oss","img") ;
            if(list[i].dataLearnPic.indexOf("@") == -1){
              list[i].dataLearnPic = list[i].dataLearnPic + "@80w_80h_4e_0-0-0bgc_1o" ;
            }
          }
        }
      }
      return list;
    }

    //更改图片路径
    $scope.changeCaseImgUrl = function(list){
      var img_path = "/jpeg" ;
      for(var i in list){
        var imgUrl = list[i].thumbnail ;
        if(!imgUrl){
          list[i].thumbnail = "img/study/no_learn.png";
        }else{
          if(imgUrl.substr(0,7)!="http://" && imgUrl.substr(0,8)!="https://"){
            list[i].thumbnail = $scope.case_img_url +"/" +list[i].caseId +img_path +"/"+imgUrl ;
          }else{
            list[i].thumbnail = list[i].thumbnail ;
          }
        }
      }
      return list;
    }

    //更改图片路径
    $scope.changeCommunityImgUrl = function(list){
      var img_path = "" ;
      user_img = list.thumbnail ;
      //if(!user_img){
      //  list.thumbnail = "img/study/no_learn.png";
      //}else{
      //  if(user_img.substr(0,7)!="http://" && user_img.substr(0,8)!="https://"){
      //    list.thumbnail = $scope.img_url +"/" +list.id +img_path +"/"+user_img ;
      //  }
      //}
      for(var i in list){
        var imgUrl = list[i].thumbnail ;
        if(!imgUrl){
          list[i].thumbnail = "img/study/no_learn.png";
        }else{
          if(imgUrl.substr(0,7)!="http://" && imgUrl.substr(0,8)!="https://"){
            list[i].thumbnail = $scope.community_img_url +"/" +list[i].caseInfoId +img_path +"/"+imgUrl ;
          }else{
            list[i].thumbnail = list[i].thumbnail ;
          }
        }
      }
      return list;
    }

    //返回
    //$scope.goToBack = function() {
    //  $ionicHistory.goBack(-1) ;
    //  $ionicSideMenuDelegate.toggleLeft();
    //};


    //经典病历部分
    $scope.doRefreshCase = function() {
      UserService.getStoreList($rootScope.user.id,1,$scope.case_params.pageSize)
        .then(function(result) {
          $scope.cases = $scope.changeCaseImgUrl(result.result);
          $scope.case_params = {
            hasmore : true ,
            from : 1 ,
            pageSize : 10,
          }
          //当前数量小于查询数量，禁止加载更多
          if (result.result.length < $scope.case_params.pageSize) {
            $scope.case_params.hasmore = false;
          }else{
            $scope.case_params.from += parseInt($scope.case_params.pageSize);
          }
          //$scope.case_params.from += parseInt($scope.case_params.pageSize);
          $scope.$broadcast('scroll.refreshComplete');
          $scope.$broadcast('scroll.infiniteScrollComplete');
        },function(error){
          //$scope.case_params.hasmore = false;
          $scope.$broadcast('scroll.refreshComplete');
        })
    };

    $scope.loadMoreCase = function() {
      UserService.getStoreList($rootScope.user.id, $scope.case_params.from,$scope.case_params.pageSize)
        .then(function (result) {
          $scope.cases = $scope.cases.concat($scope.changeCaseImgUrl(result.result));
          //当前数量小于查询数量，禁止加载更多
          if (result.result.length < $scope.case_params.pageSize) {
            $scope.case_params.hasmore = false;
          }
          $scope.case_params.from += parseInt($scope.case_params.pageSize);
          $scope.$broadcast('scroll.infiniteScrollComplete');
        },function(error){
          //$scope.case_params.hasmore = false;
          $scope.$broadcast('scroll.infiniteScrollComplete');
        })
    };

    $scope.deleteCase = function(item){
      showAlertService.PopConfirm("提示信息","是否取消收藏该病例？","取消","确认")
        .then(function(res) {
          if(res) {
            UserService.deleteCaseStore($rootScope.user.id,item.caseId)
              .then(function(){
                $scope.cases.splice($scope.cases.indexOf(item), 1);
              },function(error){
                showAlertService.PopShow("提示停息","删除失败,请稍后再试!",2000) ;
              })
          } else {
          }
        });
    }


    //社区部分
    $scope.doRefreshCommunity = function() {
      UserService.getForumStoreList($rootScope.user.id,1,$scope.community_params.pageSize)
        .then(function(result) {
          $scope.communitys = $scope.changeCommunityImgUrl(result.result);
          $scope.community_params = {
            hasmore : true ,
            from : 1 ,
            pageSize : 10,
          }
          $scope.community_params.hasmore = true;
          //当前数量小于查询数量，禁止加载更多
          if (result.result.length < $scope.community_params.pageSize) {
            $scope.community_params.hasmore = false;
          }else{
            $scope.community_params.from += parseInt($scope.community_params.pageSize);
          }
          $scope.$broadcast('scroll.refreshComplete');
        },function(error){
          //$scope.community_params.hasmore = false;
          $scope.$broadcast('scroll.refreshComplete');
        }).finally(function () {
          $scope.$broadcast('scroll.refreshComplete');
        });
    };

    $scope.loadMoreCommunity = function() {
      UserService.getForumStoreList($rootScope.user.id, $scope.community_params.from,$scope.community_params.pageSize)
        .then(function (result) {
          $scope.communitys = $scope.communitys.concat($scope.changeCommunityImgUrl(result.result));
          //当前数量小于查询数量，禁止加载更多
          if (result.result.length < $scope.community_params.pageSize) {
            $scope.community_params.hasmore = false;
          }
          $scope.community_params.from += parseInt($scope.community_params.pageSize);
          $scope.$broadcast('scroll.infiniteScrollComplete');
        },function(error){
          //$scope.community_params.hasmore = false;
          $scope.$broadcast('scroll.infiniteScrollComplete');
        }).finally(function () {
          $scope.$broadcast('scroll.infiniteScrollComplete');
        });
    };

    $scope.deleteCommunity = function(item){
      showAlertService.PopConfirm("提示信息","是否取消收藏该病例！","取消","确认")
        .then(function(res) {
          if(res) {
            UserService.deleteCommunityStore($rootScope.user.id,item.caseInfoId)
              .then(function(){
                $scope.communitys.splice($scope.communitys.indexOf(item), 1);
              },function(error){
                showAlertService.PopShow("提示停息","删除失败,请稍后再试!",2000) ;
              })

          } else {
          }
        });

    }


    //视频部分
    $scope.dataLearnUrl = ["","learn-detail","ppt-detail","classroom-detail"]
    $scope.doRefreshVideo = function() {
      UserService.getLearnStoreList($rootScope.user.id,1,$scope.video_params.pageSize)
        .then(function(result) {
          $scope.videos = $scope.changeVideoImgUrl(result.result);
          $scope.video_params = {
            hasmore : true ,
            from : 1 ,
            pageSize : 10,
          }
          $scope.video_params.hasmore = true;
          //当前数量小于查询数量，禁止加载更多
          if (result.length < $scope.video_params.pageSize) {
            $scope.video_params.hasmore = false;
          }else{
            $scope.video_params.from += parseInt($scope.video_params.pageSize);
          }
          $scope.$broadcast('scroll.refreshComplete');
        },function(error){
          //$scope.video_params.hasmore = false;
          $scope.$broadcast('scroll.refreshComplete');
        })
        .finally(function () {
          $scope.$broadcast('scroll.refreshComplete');
        });
    };

    $scope.loadMoreVideo = function() {
      UserService.getLearnStoreList($rootScope.user.id, $scope.video_params.from,$scope.video_params.pageSize)
        .then(function (result) {
          $scope.videos = $scope.videos.concat($scope.changeVideoImgUrl(result.result));
          //当前数量小于查询数量，禁止加载更多
          if (result.result.length < $scope.video_params.pageSize) {
            $scope.video_params.hasmore = false;
          }
          $scope.video_params.from += parseInt($scope.video_params.pageSize);
          $scope.$broadcast('scroll.infiniteScrollComplete');
        },function(error){
          //$scope.video_params.hasmore = false;
          $scope.$broadcast('scroll.infiniteScrollComplete');
        })
        .finally(function () {
          $scope.$broadcast('scroll.infiniteScrollComplete');
        });
    };

    $scope.deleteVideo = function(item){
      showAlertService.PopConfirm("提示信息","是否取消收藏该学习！","取消","确认")
        .then(function(res) {
          if(res) {
            UserService.deleteVideoStore($rootScope.user.id,item.dataLearnId)
              .then(function(){
                $scope.videos.splice($scope.videos.indexOf(item), 1);
              },function(error){
                showAlertService.PopShow("提示停息","删除失败,请稍后再试!",2000) ;
              })
          } else {
          }
        });
    }


  });
