/**
 * Created by douhao on 2016/6/20.
 */
angular.module('personalIntegral-controller',[])
  .controller('personalIntegralCtrl',function($scope,$state,UserService,$rootScope,HomeService){
    $scope.isRuleVisible = false ;
    $scope.isRecordVisible = false ;
    $scope.userScoreLogList = {} ;
    $scope.scoreRuleDetailList = {} ;
    $scope.scoreLog = [] ;
    $scope.userInfo = {} ;
    $scope.params = {
      hasmore : false ,
      current : 1 ,
      pageSize : 10,
    }
    $scope.$on('$ionicView.afterEnter', function() {
      $scope.scoreLog = [] ;
      $scope.params = {
        hasmore : true ,
        current : 1 ,
        pageSize : 10,
      }
    }, false);

    $scope.ruleVisible = function(){
      $scope.isRuleVisible = !$scope.isRuleVisible ;
    }
    $scope.recordVisible = function(){
      $scope.isRecordVisible = !$scope.isRecordVisible ;
    }

    //分享
    $scope.isShare = false ;
    $scope.share = function(type){
      $scope.isShare = false ;
      for(var i in $rootScope.share_urls) {
        if ($rootScope.share_urls[i].confKey == "share_integral") {
          $scope.shareUrl = $rootScope.share_urls[i].confValue.replace("{userId}", $rootScope.user.id).replace("{userImage}", $rootScope.user.personalImage).replace("{nickname}", $rootScope.user.nickName);
          //alert("分享地址"+$scope.shareUrl);
        }
      }
      //alert($scope.shareUrl) ;
      //分享参数
      switch(type){
        case 0:
          $scope.scene = Wechat.Scene.SESSION;
          break ;
        case 1:
          $scope.scene = Wechat.Scene.TIMELINE;
          break ;
      }
      Wechat.isInstalled(function (installed) {
        if(installed == "No"){
          $scope.isShare = false ;
          showAlertService.PopAlert("提示信息","请先安装微信再分享","确认","") ;
          return ;
        }else{
          var title = "";
          var content = "影领积分" ;
          var linkUrl = $scope.shareUrl ;
          var imgUrl = img.shareIntegralImg;
          if($rootScope.statistics.scoreObj == undefined){
            title = "积分分享" ;
          }else{
            title = "我在影领中累计了'"+$rootScope.statistics.scoreObj.userInfo.totalScore+"'积分" ;
          }
          Wechat.share({
            message:{
              title: title,
              description: content,
              thumb: imgUrl,
              mediaTagName: "yinglink-TAG-001",
              messageExt: "",
              messageAction: "<action>dotalist</action>",
              media: {
                type:Wechat.Type.LINK ,
                webpageUrl:$scope.shareUrl
                //webpageUrl: $scope.shareUrl
              }
            },
            scene: $scope.scene
          }, function () {
            //$cordovaToast.showShortBottom('分享成功') ;
            //showAlertService.PopShow("提示信息","分享成功",1000) ;
            HomeService.addShareRecord($rootScope.user.id,$rootScope.user.id,6,$scope.shareUrl)
              .then(function(result){
              }) ;
          }, function (reason) {
            //$cordovaToast.showShortBottom('分享失败') ;
            //showAlertService.PopShow("提示信息","分享失败",1000) ;
          });
        }
      });

    }

    //显示分享
    $scope.showShare = function() {
      if($rootScope.share_urls == null || $rootScope.share_urls == undefined){
        $rootScope.$broadcast('message',"正在获取分享信息，请稍后再试！",3000,"notice");
        UserService.getConfByType('share')
          .then(function(result){
            if(result.success){
              $rootScope.share_urls= result.result ;
            }
          })
        return ;
      }
      $scope.isShare = true ;
    };
    //取消分享
    $scope.cancelShare = function(){
      $scope.isShare = false ;
    }

    //获取积分记录
    $scope.loadMore = function(){
        UserService.getScoreLog($rootScope.user.id,$scope.params.current,$scope.params.pageSize)
          .then(function(result){
            if(result.code == 0 && !!result.result){
              $scope.scoreLog = $scope.scoreLog.concat(result.result.objects) ;
              if(result.result.objects.length < $scope.params.pageSize){
                $scope.params.hasmore = false ;
              }else{
                $scope.params.current ++ ;
              }
            }else{
              $scope.params.hasmore = false ;
            }
          })
          .finally(function(){
            $scope.$broadcast("scroll.infiniteScrollComplete");
          });
    }

    //$scope.load = function(){
    //  UserService.getScoreCenterInfo($rootScope.user.id)
    //    .then(function(result){
    //      $scope.userInfo = result.obj.userInfo ;
    //      $scope.userScoreLogList = result.obj.userScoreLogList ;
    //      $scope.scoreRuleDetailList = result.obj.scoreRuleDetailList ;
    //    })
    //}
    //$scope.load() ;

  })
