/**
 * Created by douhao on 2016/8/5.
 */
angular.module('bound-controller',[])
  .controller('BoundCtrl',function($interval,$scope,$state,$ionicScrollDelegate,UserService,$rootScope,$ionicModal,rongcloudService,innermailService,$stateParams, groupService,showAlertService,$cordovaNetwork,$interval,friendService){
      $scope.isSubmited = true ;
      $scope.type = "" ;
      $scope.weChatUserInfo = $stateParams.weChatUserInfo ;

      $scope.registerUser = {
        phone:"",
        headimgurl:$scope.weChatUserInfo.headimgurl,
        password:"",
        confirmPwd:"",
        nickName:$scope.weChatUserInfo.nickname,
      } ;

      $scope.loginUser = {
        userName:"" ,
        password:""
      } ;
      //alert("boundInfo = "+JSON.stringify($scope.weChatUserInfo)) ;
    $scope.isChecked = false;
    $scope.focusInput = function(){
      $scope.isChecked = false;
      if (!!$scope.myForm.phone){
        $scope.myForm.phone.$dirty = false ;
        $scope.myForm.randomCode.$dirty = false ;
      }
      if (!!$scope.myForm.nickName){
        $scope.myForm.nickName.$dirty = false ;
        $scope.myForm.password.$dirty = false ;
        $scope.myForm.confirmPwd.$dirty = false ;
      }
    }

    $scope.randomCodeButtonDisabled = false;
    $scope.randomCodeButtonText = '发送验证码';
    $scope.randomCodeButtonTimes = 0;
    $scope.getRandomCode = function(){
      $scope.isChecked = true ;
      if($scope.myForm.phone.$error.required || $scope.myForm.phone.$error.pattern){
        $scope.myForm.phone.$dirty = true ;
        return ;
      } ;

      $scope.randomCodeButtonTimes = 60;
      $scope.randomCodeButtonDisabled = true;

      var timer = $interval(function(){
        $scope.randomCodeButtonTimes--;
        $scope.randomCodeButtonText = "重新发送（"+ $scope.randomCodeButtonTimes +"s）";

        if ($scope.randomCodeButtonTimes == 0){
          $scope.randomCodeButtonDisabled = false;
          $scope.randomCodeButtonText = "发送验证码";
          $interval.cancel(timer);
        }
      }, 1000);

      UserService.getRandomCode($scope.registerUser.phone);
    }

      $scope.checkPhone = function(){
        $scope.isChecked = true ;
        if($scope.myForm.$error.required != undefined && $scope.myForm.$error.required.length > 0){
          for(var i in $scope.myForm.$error.required){
            $scope.myForm.$error.required[i].$dirty = true ;
          }
          return ;
        }

        if($scope.myForm.$error.pattern != undefined && $scope.myForm.$error.pattern.length > 0){
          for(var i in $scope.myForm.$error.pattern){
            $scope.myForm.$error.pattern[i].$dirty = true ;
          }
          return ;
        }

        showAlertService.loadingShow();
        UserService.randomcodeChec($scope.registerUser.phone,$scope.registerUser.randomCode)
          .then(function(result){
            if(result.code == 0){
              UserService.getUserInfoByPhone($scope.registerUser.phone)
                .then(function(result){
                  showAlertService.loadingHide();
                  if(!!result.result){
                    $scope.type = "bound"
                    $scope.loginUser.userName = $scope.registerUser.phone ;
                    $scope.loginUser.password = result.result.phonePsd ;
                    $scope.signIn() ;
                  }else{
                    $scope.type = "register" ;
                    $scope.registerUser.nickName = $scope.weChatUserInfo.nickname ;
                  }
                })
            }else if(result.code == 40021){
              showAlertService.loadingHide();
              $rootScope.$broadcast('message',"无效的验证码！",3000,"alert");
            }
          },function(){
            showAlertService.loadingHide();
            $rootScope.$broadcast('message',"验证失败，请稍后再试！",3000,"alert");
          })
      }

      $scope.submitForm = function(){
        $scope.isChecked = true ;
        if($scope.myForm.$error.required != undefined && $scope.myForm.$error.required.length > 0){
          for(var i in $scope.myForm.$error.required){
            $scope.myForm.$error.required[i].$dirty = true ;
          }
          return ;
        }

        if($scope.myForm.$error.pattern != undefined && $scope.myForm.$error.pattern.length > 0){
          for(var i in $scope.myForm.$error.pattern){
            $scope.myForm.$error.pattern[i].$dirty = true ;
          }
          return ;
        }

        if($scope.registerUser.password != $scope.registerUser.confirmPwd){
          $scope.myForm.confirmPwd.$dirty = true ;
          return ;
        }

        if($scope.type == "register"){
          $scope.register() ;
        }
      }

    $scope.signIn = function(){
      showAlertService.loadingShow();
      $scope.isLogining = true ;
      //localStorageService.set("userName",user.userName) ;
      UserService.login($scope.loginUser)
        .then(function(result){
          if(result.code != 0){
            showAlertService.loadingHide();
            if(localStorage.getItem("user") != null && localStorage.getItem("user") != ""){
              localStorage.setItem("user", "");
              localStorage.setItem("pwd", "");
              $scope.isVisible = true  ;
              $scope.isLogining = false ;
              $state.go("signin") ;
            }else{
              switch (result.code){
                case 410:
                  showAlertService.PopAlert("登录失败","用户不存在，请确认用户名是否正确！","确认","") ;
                  break;
                case 411:
                  showAlertService.PopConfirm("登录失败","密码错误，是否找回密码?","取消","找回密码")
                    .then(function(res) {
                      if(res) {
                        $state.go("retrievePwd") ;
                      } else {
                      }
                    });
                  break ;
              }
            }
            //$rootScope.$broadcast("error") ;
          }else{
            //$rootScope.user.userId = result.id ;
            //$rootScope.user.userName = result.name ;
            //保存信息
            //判断手机号码跟手机密码是否存在
            if(result.result.phoneNumber == null || result.result.phonePsd == null){
              localStorage.setItem("user", window.btoa(result.result.email));
              localStorage.setItem("pwd", window.btoa(result.result.emailPsd));
            }else{
              localStorage.setItem("user", window.btoa(result.result.phoneNumber));
              localStorage.setItem("pwd", window.btoa(result.result.phonePsd));
            }

            $rootScope.user = result.result ;
            //sessionStorage.user = result

            if(!result.result.personalImage){
              $rootScope.user.personalImage = img.personalImage ;
            }

            // 记录访问信息
            UserService.addAccessSource();

            //增加登录记录
            UserService.addLoginRecord() ;

            // 定期获取好友申请
            friendService.getFriendApply();
            $interval(function(){
              friendService.getFriendApply();
            }, 1000*60*5);

            if($scope.type == "bound"){
              UserService.boundUnionid($rootScope.user.id,$scope.weChatUserInfo.unionid,$scope.weChatUserInfo.openid)
                .then(function(result){
                  showAlertService.loadingHide();
                  if($rootScope.isVisible){
                    $rootScope.isVisible = false ;
                    $rootScope.goToBack() ;
                  }else{
                    $state.go('menu.tab.homepage') ;
                  }
                },function(response){
                  showAlertService.loadingHide();
                });
            }
            showAlertService.loadingHide();
            if($scope.type != "bound"){
              if($rootScope.isVisible){
                $rootScope.isVisible = false ;
                $rootScope.goToBack() ;
              }else{
                $state.go('menu.tab.homepage') ;
              }
            }

            // 初始化rongCloud
            rongcloudService.getToken($rootScope.user.id)
              .then(function(result){
                rongcloudService.init(result.result.appKey, result.result.token);
                groupService.getGroupsByUserid($rootScope.user.id, '')
                  .then(function(result){
                    var groups = {};
                    groups.groups = [];
                    if (result.code == 0){
                      for(var i in result.result){
                        var group = {id: result.result[i].id, name: result.result[i].name, portraitUrl: !!result.result[i].picture ? result.result[i].picture : img.personalImage};
                        groups.groups.push(group);
                      }
                    }

                    if (groups.groups.length > 0){
                      rongcloudService.syncGroup(groups);
                    }
                  })
              })

          }
        },function(result){
          showAlertService.loadingHide();
          $rootScope.$broadcast("message","网络连接失败,请稍后再试！",3000,"alert") ;
          $scope.isLogining = false ;
          if(localStorage.getItem("user") != null && localStorage.getItem("user") != ""){
            localStorage.setItem("user", "");
            localStorage.setItem("pwd", "");
            $scope.isVisible = true  ;
            $state.go("signin") ;
          }
        })
    }

    $scope.register = function(){
      $scope.isSubmited = false ;
      UserService.registerByUnionid($scope.weChatUserInfo.unionid,$scope.weChatUserInfo.openid,"",$scope.registerUser.phone,$scope.registerUser.password,$scope.registerUser.nickName)
        .then(function(result){
          if(result.code == 0){
            $scope.loginUser.userName = $scope.registerUser.phone ;
            $scope.loginUser.password = $scope.registerUser.password ;
            $scope.signIn() ;
            $scope.isSubmited = true ;
          }else{
            $scope.isSubmited = true ;
          }
        },function(response){
          $scope.isSubmited = true ;
        })
    }

    $scope.goToBack = function(){
      if($rootScope.isVisible){
        $rootScope.isVisible = false ;
        $rootScope.goToBack() ;
      }else{
        $rootScope.goToBack() ;
      }
    }
  })
