/**
 * Created by douhao on 2016/4/22.
 */
angular.module('caseListImgDirective', [])

  .directive("caseListImg",function($animate){
    var caseListObj = {
      restrict:'E',
      templateUrl: 'templates/directive/caseListImg.html',
      replace: true,
      scope:false ,
      controller: function($scope, $element){
        var left = "divCaseLeft" ;
        var center = "divCaseCenter" ;
        var right = "divCaseRight" ;
        var excursion0 = "excursionCase0" ;
        var excursion5 = "excursionCase5" ;
        $scope.left = left ;
        $scope.center = center ;
        $scope.right = right ;
        $scope.desc = ""
        $scope.dragLeftImg = function(length){
          $animate.enabled(true,$element) ;
          $scope.desc = "left"
          //console.log("left")
          if($scope.left == left){
            if(length >= 3){
              $scope.left = excursion0;
              $scope.center = left ;
              $scope.right = center ;
            }
          }else if($scope.left == center){
            $scope.left = left;
            $scope.center = center ;
            $scope.right = right ;
          }
        }
        $scope.dragRightImg = function(){
          $animate.enabled(true,$element) ;
          $scope.desc = right
          //console.log(right)
          if($scope.left == excursion0){
            $scope.left = left;
            $scope.center = center ;
            $scope.right = right ;
          }else if($scope.left == left){
            $scope.left = center;
            $scope.center = right ;
            $scope.right = excursion5 ;
          }
        }
      },
      link: function(scope, ele, attrs) {
      }
    }
    return caseListObj ;
  })
