/**
 * Created by douhao on 2016/5/17.
 */
angular.module('diagnose-service',[])
  .factory('diagnoseService',function($http,$q) {
    return {
      //查找所有
      tasklist: function (params) {
        var q = $q.defer();
        var user = JSON.parse(sessionStorage.getItem('loginUser'));
        if(user == null){
          q.reject("");
          return q.promise;
        }
        if(user.roles[0] === 0){
          params.st = [0,2];
        }else if(user.roles[0] === 1){
          params.st = [0,1,2,3];
        }
        $http({
          method: 'GET',
          headers:{'SESSIONID':user.sessionId},
          url: config.lifeccp_url+"/tasks/menuTask",
          params:{
            groupId:params.groupId,
            currentPage:params.currentPage,
            currentSize:params.currentSize,
            submitFrom:params.submitFrom,
            submitEnd:params.submitEnd,
            createFrom:params.createFrom,
            createEnd:params.createEnd,
            hospitalId:user.hospitalId,
            st:params.st,
            mt:params.mt,
            caseUid:params.caseUid,
            patientName:params.patientName,
            needPicture:params.needPicture
          }
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      }
    }
  })
