angular.module('innermail-service',[])
  .factory('innermailService',function($http,$q) {
    return{
      //查找所有
      getFriendMail: function (userId) {
        var q = $q.defer();
        $http({
          method: 'GET',
          url: config.new_url + "/innermails/"+userId
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      },

      readMail: function (id) {
        var q = $q.defer();
        $http({
          method: 'PUT',
          url: config.new_url + "/innermails/"+id+"/read"
        }).success(function (data, status, headers, config) {
          // 当相应准备就绪时调用
          q.resolve(data);
        }).error(function (data, status, headers, config) {
          // 当响应以错误状态返回时调用
          q.reject(data);
        });

        return q.promise;
      }
    }
  })
