/**
 * Created by douhao on 2016/4/18.
 */
angular.module('localStorage-service',[])
  .factory('localStorageService',function($http,$q) {
    return {
      clear: function () {
        return localStorage.clear();
      },

      get: function (key) {
        return JSON.parse(localStorage.getItem(key));
      },

      set: function (key, data) {
        return localStorage.setItem(key, JSON.stringify(data));
      },

      remove: function (key) {
        return localStorage.removeItem(key);
      }
    };
  })
