//播放器
var isOnConnec = true;
letvplayer = new CloudVodPlayer();
function bytesToSize(bytes) {
  if (bytes === 0) return '0';
  var k = 1024;
  bytes = (bytes / k) / k;
  return bytes.toFixed(2);
}
function setArea(img,x1,y1,height,width){
  //console.log("img="+JSON.stringify(img.clientHeight)) ;
  //console.log("img="+JSON.stringify(img.clientWidth)) ;
  //console.log("img="+JSON.stringify(img.nextElementSibling.children[0].coords)) ;
  //var x1 = img.clientWidth*0.24 ;
  //var y1 = img.clientHeight*0 ;
  //var x2 = img.clientWidth*0.75 ;
  //var y2 = img.clientHeight*0.1 ;
  //img.nextElementSibling.children[0].coords = x1+","+y1+","+x2+","+y2 ;
  //img.x ;
  //img.y ;
  var y = img.y ;
  if(ionic.Platform.isIOS()){
    y = y -20 ;
  }
  img.nextElementSibling.style.left = img.x + img.width*x1 +"px" ;
  img.nextElementSibling.style.top = y + img.height*y1 +"px" ;
  img.nextElementSibling.style.height = img.height*height +"px" ;
  img.nextElementSibling.style.width = img.width*width +"px" ;
}

function tailsImageLoaded(img,count) {
  var index = parseInt(img.getAttribute('index'));
  var length = parseInt(img.getAttribute('length'));
  var windowWidth = window.screen.availWidth / 2 - 8;
  var height = parseFloat(img.naturalHeight/img.naturalWidth) * parseFloat(windowWidth) ;
  img.width = windowWidth ;
  img.height = height ;
  if(count < length-1){
    return ;
  }
  for(var i = 0 ; i <= index;i++){
    angular.element('childImg'+i).css("display","block") ;
    //img.parentElement.style.display = 'block';
  }
  angular.element('#tiles .parentDiv').wookmark({
    autoResize: true,
    container: angular.element('#tilesDiv'),
    offset: 0,
    itemWidth: window.screen.availWidth / 2,
  });

  $('#tiles').trigger('refreshWookmark');
}

function adjustSlideHeight(img, firstFlag){
  var index = parseInt(img.getAttribute('index'));
  var height = angular.element("#caseSlide .img")[index].height;
  img.nextElementSibling.style.height = height+"px" ;
  if(img.nextElementSibling != null){
    img.nextElementSibling.style.display = "none" ;
  }

  if (firstFlag && index > 0){
    return;
  }
  if (height > 0){
    angular.element("#caseSlideDiv").css('height', height);
    angular.element(".slider-pager").css('top', height-30);
    angular.element(".slider-pager-page").css('top', height-30);
  }

  img.style.visibility = "visible" ;
}

function adjustChangeSlideHeight(img, firstFlag){
  setTimeout(function(){
    var index = parseInt(img.getAttribute('index'));
    var height = angular.element("#caseSlide .img")[index].height;
    img.nextElementSibling.style.height = height+"px" ;
    if(img.nextElementSibling != null){
      img.nextElementSibling.style.display = "none" ;
    }

    if (firstFlag && index > 0){
      return;
    }
    if (height > 0){
      angular.element("#caseSlideDiv").css('height', height);
      angular.element(".slider-pager").css('top', height-30);
      angular.element(".slider-pager-page").css('top', height-30);
    }

    img.style.visibility = "visible" ;
  },100)
}

function adjustHomePageHeight(img, firstFlag){
  var index = parseInt(img.getAttribute('index'));
  var height = angular.element("#homepageSlide .img")[index].height;
  //img.nextElementSibling.style.height = height+"px" ;
  if(img.nextElementSibling != null){
    //img.nextElementSibling.style.display = "none" ;
  }

  if (firstFlag && index > 0){
    return;
  }

  img.style.visibility = "visible" ;
}

function hideImgLoad(img){
  img.nextElementSibling.style.display = "none" ;
  img.style.display = "block" ;
}

//function setImgHight(img){
//  var num = 0.5625 ;
//  img.style.height = img.width * num +"px" ;
//}

function setImgBgHight(){
  var num = 0.5625 ;
  angular.element(".study-list-img-bg").css('height', screen.width*num+"px");
}

function autoResizeImage(image) {
  var w = image.width;
  var h = image.height;
  var maxWidth = parseInt(angular.element('.view-pics').width());
  var maxHeight = parseInt(angular.element('.view-pics').height());
  var Ratio = 1;
  var wRatio = maxWidth / w;
  var hRatio = maxHeight / h;

  Ratio = (wRatio <= hRatio ? wRatio : hRatio);
  w = w * Ratio;
  h = h * Ratio;

  var left = 0;
  if (w < maxWidth) {
    left = (maxWidth - w) / 2;
  }
  var top = 0;
  if (h < maxHeight) {
    top = (maxHeight - h) / 2;
  }

  var index = image.getAttribute("indexnum");
  var img = angular.element("#img-" + index);
  img.css("left", left + "px");
  img.css("top", top + "px");
  img.css("width", w + "px");
  img.css("height", h + "px");
}

function bigPictureOnLoad(image) {
    $(image).css('transform', 'scale(1) translate(0px,0px)');
    var imageTemp = new Image();
    imageTemp.src = image.src;
    EXIF.getData(imageTemp, function(){
      var tags = EXIF.getAllTags(this);
      if (!!tags && tags.Orientation > 1){
        if (tags.Orientation == 6){
          $(image.parentElement).css('transform', 'rotate(90deg)');
        }
        if (tags.Orientation == 8){
          $(image.parentElement).css('transform', 'rotate(-90deg)');
        }
        if (tags.Orientation == 3){
          $(image.parentElement).css('transform', 'rotate(180deg)');
        }
      }
    });

  var w = image.width;
  var h = image.height;
  var maxWidth = window.innerWidth;
  var maxHeight = window.innerHeight;

  var Ratio = 1;
  var wRatio = maxWidth / w;
  var hRatio = maxHeight / h;

  Ratio = (wRatio <= hRatio ? wRatio : hRatio);
  w = w * Ratio;
  h = h * Ratio;

  var left = 0;
  if (w < maxWidth) {
    left = (maxWidth - w) / 2;
  }
  var top = 0;
  if (h < maxHeight) {
    top = (maxHeight - h) / 2;
  }

  $(image).css("left", left + "px");
  $(image.parentElement.parentElement).css("top", top + "px");
  $(image).css("width", w + "px");
  $(image).css("height", h + "px");
}

function formatTime(seconds) {
  var min = Math.floor(seconds / 60),
    second = seconds % 60,
    hour, newMin, time;
  if (min > 60) {
    hour = Math.floor(min / 60);
    newMin = min % 60;
  }
  if (second < 10) {
    second = '0' + second;
  }
  if (min < 10) {
    min = '0' + min;
  }

  return time = hour ? (hour + ':' + newMin + ':' + second) : (min + ':' + second);
}

function getUUID() {
  var s = [];
  var hexDigits = "0123456789abcdef";
  for (var i = 0; i < 36; i++) {
    s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
  }
  s[14] = "4"; // bits 12-15 of the time_hi_and_version field to 0010
  s[19] = hexDigits.substr((s[19] & 0x3) | 0x8, 1); // bits 6-7 of the clock_seq_hi_and_reserved to 01
  s[8] = s[13] = s[18] = s[23] = "-";

  var uuid = s.join("");
  return uuid;
}

var rongCloudUtil = {
  resolveCon: function (con, flag, target) {
    try {
      var conversation = con;
      var targetId = conversation.targetId;
      var text = '';
      var conversationType = conversation.conversationType;
      var conversationTitle = conversation.conversationTitle;
      var senderUserId = conversation.senderUserId;

      var title = '';
      var pic = '';

      if (!!target) {
        console.log("解析消息");
        switch (conversationType) {
          case 'PRIVATE':
          case 'GROUP':
            title = target.name;
            pic = !!target.picture ? target.picture : img.personalImage;
            break;
          case 'SYSTEM':
            title = target.name;
            pic = !!target.picture ? target.picture : img.personalImage;
            break;
        }
      }

      conversation.conversationTitle = title;
      conversation.pic = pic;
      var objectName = conversation.objectName;
      if (objectName == 'RC:TxtMsg') {
        if (flag) {
          text = conversation.content.text;
        } else {
          text = conversation.latestMessage.text;
          if (!text) {
            text = conversation.latestMessage;
          }
        }
        text = rongCloudUtil.replace_em(text);
      } else if (objectName == 'RC:CmdNtf') {
        if (!!conversation.latestMessage){
          text = conversation.latestMessage.data;
        }else{
          text = conversation.content.data;
        }
      } else if (objectName == 'RC:ImgMsg') {
        text = '[图片]';
      } else if (objectName == 'RC:VcMsg') {
        text = '[语音]';
      }
      conversation.latestMessage = text;

    } catch (e) {
      //console.log('resolveCon error:'+e);
    }
    return conversation;
  },
  resolveMsg: function (msg) {
    try {
      var message = msg;
      var text = '';
      var messageType = message.conversationType;
      var objectName = message.objectName;
      if (objectName == 'RC:TxtMsg') {
        text = message.content.text;
        text = rongCloudUtil.replace_em(text);
        message.content.text = text;
      } else if (objectName == 'RC:CmdNtf') {
        text = message.content.data;
        text = rongCloudUtil.replace_em(text);
        message.content.text = text;
      } else if (objectName == 'RC:ImgMsg') {
        text = '[图片]';
        message.content.text = text;
      } else if (objectName == 'RC:VcMsg') {
        text = '[语音]';
        message.content.text = text;

        if (!!message.content.duration){
          var vclong = 40 + message.content.duration * 5;
          message.vcstyle = {'width': vclong + "px"};
        }

      }
    } catch (e) {
      //console.log('resolveMsg error:'+e);
    }
    return message;
  },
  symbolReplace: function (str) {
    if (!str) return '';
    str = str.replace(/&/g, '&amp;');
    str = str.replace(/</g, '&lt;');
    str = str.replace(/>/g, '&gt;');
    str = str.replace(/"/g, '&quot;');
    str = str.replace(/'/g, '&#039;');
    return str;
  },
  replaceSymbol: function (str) {
    if (!str) return '';
    str = str.replace(/&amp;/g, '&');
    str = str.replace(/&lt;/g, '<');
    str = str.replace(/&gt;/g, '>');
    str = str.replace(/&quot;/g, '"');
    str = str.replace(/&#039;/g, "'");
    str = str.replace(/&nbsp;/g, " ");
    return str;
  },
  replace_em: function (str) {
    str = str.replace(/\</g, '&lt;');
    str = str.replace(/\>/g, '&gt;');
    str = str.replace(/\n/g, '<br/>');
    str = str.replace(/\[em_([0-9]*)\]/g, '<img src="img/face/$1.gif" border="0" />');
    return str;
  }
};
function getBrowserInfo(){
  var explorer = window.navigator.userAgent.toLowerCase() ;
  //ie
  if (explorer.indexOf("msie") >= 0) {
    var ver=explorer.match(/msie ([\d.]+)/)[1];
    return {type:"IE",version:ver};
  }
  //firefox
  else if (explorer.indexOf("firefox") >= 0) {
    var ver=explorer.match(/firefox\/([\d.]+)/)[1];
    return {type:"Firefox",version:ver};
  }
  //QQ浏览器
  else if(explorer.indexOf("qqbrowser") >= 0){
    var ver=explorer.match(/qqbrowser\/([\d.]+)/)[1];
    return {type:"QQBrowser",version:ver};
  }
  //Chrome
  else if(explorer.indexOf("chrome") >= 0){
    var ver=explorer.match(/chrome\/([\d.]+)/)[1];
    return {type:"Chrome",version:ver};
  }
  //Opera
  else if(explorer.indexOf("opera") >= 0){
    var ver=explorer.match(/opera.([\d.]+)/)[1];
    return {type:"Opera",version:ver};
  }
  //Safari
  else if(explorer.indexOf("safari") >= 0){
    var ver=explorer.match(/version\/([\d.]+)/)[1];
    return {type:"Safari",version:ver};
  }
};
